#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <EEPROM.h>
#include <ESP8266WebServer.h>
#include <ESP8266HTTPClient.h>
#include <WiFiUdp.h>
#include <ESP8266mDNS.h>
#include <functional>
#include "Declarations.h"
#include "SSD1306Ascii.h"
#include "SSD1306AsciiWire.h"
#include <Wire.h>
#include <Adafruit_BMP085.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BME280.h>
#include <PubSubClient.h>
#include <ArduinoOTA.h>

SSD1306AsciiWire oled;
// ---------------------------------------------------------------------------
Adafruit_BMP085 bmp;
Adafruit_BME280 bme; 
// ---------------------------------------------------------------------------
uint8_t buf[10];
uint8_t buflen = sizeof(buf);
// ---------------------------------------------------------------------------
IPAddress timeServer(129, 6, 15, 29); // time.nist.gov NTP server
// Alternative NTP servers addresses   // IPAddress timeServer(129, 6, 15, 27);
// IPAddress timeServer(129, 6, 15, 28);  // IPAddress timeServer(129, 6, 15, 30);
// IPAddress timeServerIP; // time.nist.gov NTP server address
// ---------------------------------------------------------------------------
const char* ntpServerName = "time.nist.gov";
unsigned int localPort_NTP = 2390;      // local port to listen for UDP packets
const int NTP_PACKET_SIZE = 48; // NTP time stamp is in the first 48 bytes of the message
const int TimeZone = 2;        // Time zone adjustment for NTP time server
byte packetBuffer2[ NTP_PACKET_SIZE]; //buffer to hold incoming and outgoing packets 
const byte NTP_WaitTime = 100; // time in multiples of 10 mS that device will wait 
WiFiUDP udp;          // A UDP instance for NTP clock
ESP8266WebServer LocalServer(80);   // Remote control server object 
// -----------------------------------------------------------
boolean wifiConnected = false;
boolean NTP_Timeout;   // if true, NTP attempt timed out
byte ScreenAge[NoOf_OLED_Pages];     // Minutes timer = time between remote page updates

char KeyboardBuffer[MaxStringLength];      // Keyboard buffer
 // -------------------- LED timer and flash rates ----------------------------------
unsigned long LED_OnTimer  = LED_FlashOnStartup;   // flashing LED ON timer with Start up (mS) flash rates
unsigned long LED_OffTimer = LED_FlashOffStartup;  // flashing LED OFF timer with start up (mS) flash rate
boolean Alarm = false;
 // ------------------------------------------------------------
unsigned long LoopTimer;     // used as timer for timed operations. Eg LED flashing
unsigned long NTP_Timer;      // used as timer for the NTP time interval
const unsigned long One_Minute_timer_Tick_Threshold = 60000; // used to determine one minute timer activity (mS)
byte Command = 255;       // input buffer for main screen commands

const boolean AP_SwitchOn = LOW;   // IO status for AP switch ON
const boolean AP_SwitchOff = !AP_SwitchOn;
        // ------------ MQTT ----------------------------
String MQTT_Server = "MQTT-Server" ;
WiFiClient MQTT_Client;
PubSubClient client(MQTT_Client);
long lastMsg = 0;
//char msg[50];
int value = 0;
unsigned long MQTT_PushInterval = 10000;    // interval in milliseconds between each MQTT message push
unsigned long MQTT_RunningTimer;;
String MQTT_ServerCopy;
long MQTT_LastReconnectAttempt = 0;
boolean MQTT_Status;
unsigned int MQTT_DropOutCounter;
String RecipientHostName[] = {"....................","....................","....................","....................","...................."};
boolean RemoteDataSendEnable[5];
        // ----------------------------------------------
void callback(char* topic, byte* payload, unsigned int length) 
{
  String Msg;
  Msg.reserve(55);
  Msg = "";
  byte Counter = 0;
  while (Counter < length)  // create string from received message payload
  {
    Msg+= (char)payload[Counter];
    Counter++;
  }
        // -------------------- evaluate payload contents ---------------------------------
      if(EnableMessages == true) 
      {
        Serial.print("Incoming-[");
        Serial.print(topic);
        Serial.print("] ");
        Serial.println(Msg);
      }  // end of if(EnableMessages == true)        
    // -----------------------------------------------------
    LastRxMessage = Msg;  
    MQTT_Acknowledge = true;  
    // -----------------------------------------------------
    if(Msg.startsWith("SwitchRelay") == true) 
    {     
      boolean State;
      MQTT_Acknowledge = false;  
      byte index = Msg.indexOf(",");
      Msg = Msg.substring(index +1);   // remove Command word from command string
      if(EnableMessages) Serial.println(Msg);
      byte RelayNo = Msg.substring(0,1).toInt();
      if(Msg.endsWith("OFF")) State = false;
      else if(Msg.endsWith("ON")) State = true; 
      if (RelayNo == 1) MQTT_SwitchOne(State);
      else if (RelayNo == 2) MQTT_SwitchTwo(State);      
      else if (RelayNo == 3) MQTT_SwitchThree(State);  
      return;  // Quick exit of callback        
    }  // end of if(msg.startsWith("SwitchRelay")
    // ---------------------------------------------------
    if(Msg.startsWith("RESET") == true) ResetDevice("MQTT Reset");
    // ---------------------------------------------------
    if(Msg.startsWith("Clear") == true)  // turn all relays off
    {
      MQTT_Acknowledge = false;  
      byte i = 0;
      while(i < NoOfRelays)
      {
         Activate_Relay(i, SwitchOff,false);
         i++;
      }
      return;  // Quick exit of callback
    } // end of if(Msg.startsWith("Clear") == true)
    // ---------------------------------------------------
    if(Msg.startsWith("Screen") == true)   // remote display update command
    {
      MQTT_Acknowledge = false;  
      IncomingOLED_ScreenData(Msg);
      return;  // Quick exit of callback
    }  // end of else if(Msg.startsWith("Screen") == true) 
    // ----------------------------------------------------
    if(Msg.startsWith("PIR,") == true)   // remote display update command
    {
      byte PIR_No = Msg.substring(4,5).toInt();
      byte Index = Msg.indexOf(":LL,");
      byte LightLevel = Msg.substring(Index+4).toInt();
      LastRxMessage += "-" + String(PIR_No) + "-" + String(LightLevel); 
      byte i=0; 
      PIR_Tx_CounterEnable = true;
      PIR_Connected = 0;  // reset PIR transmission monitor    
      if(PIR_Action[PIR_No-1] != PIR_DoNothing)  // if PIR is enabled
      {
        boolean RelayState = SwitchOff;;
        if(PIR_Action[PIR_No-1] == PIR_SwitchOn) RelayState = SwitchOn; 
        MQTT_PIR_Switch(PIR_AssignedRelay[PIR_No-1],RelayState,LightLevel);
      }
      else if(EnableMessages) Serial.println(F("PIR but do nothing"));
      return;  // Quick exit of callback 
    }  // end of else if(Msg.startsWith("SoftPIR:") == true)  
    // -----------------------------------------------------
    if(Msg.startsWith("PIR-Status,") == true)   // remote display update command
    {
      MQTT_Acknowledge = false;  
      PIR_Tx_CounterEnable = true;
      PIR_Connected = 0;
      return;  // Quick exit of callback   
    }
    // -----------------------------------------------------
    if(Msg.startsWith("StartAP") == true) Soft_AP_Switch = true;  // start AP   
}  // end of void callback(char* topic, byte* payload, unsigned int length)
       // -------------------------------------------------------------------------------
void MQTT_PIR_Switch(byte RelayNo,boolean RelayState, byte LightLevel)
{
    if(LightLevelThreshold[RelayNo] > 0 && LightLevel < LightLevelThreshold[RelayNo] )
    {      
      Activate_Relay(RelayNo, RelayState,false);
      if(RelayState == SwitchOn) RelayOnTimer[RelayNo] = PIR_TimerInterval[RelayNo];
    }  
} // end of void MQTT_PIR_Switch(byte RelayNo)
// -----------------------------------------------------------------------------      
boolean Reconnect() 
{
  if (!client.connected()) 
  {
    Serial.print("Attempt MQTT connect...");
    String clientId = "MQTT_Client-";
    clientId += String(random(0xffff), HEX);  // Create a random client ID   
    if (client.connect(clientId.c_str())) // Attempt to connect
    {             // Once connected, publish an announcement...
      if(EnableMessages) Serial.println("connected"); 
      String Topic =  HostName + "/#";      
      client.subscribe(Topic.c_str());  // direct addressing topic
      Topic = "Global/#";
      client.subscribe(Topic.c_str());   // Global addressing (all housenodes on network) 
      Topic = HostName;
      client.publish(Topic.c_str(),"Connect");
      MQTT_Status = true;
      MQTT_DropOutCounter ++;
    } 
    else 
    {
      if(EnableMessages)
      {
        Serial.print("failed, rc=");
        Serial.println(client.state());
      }
      MQTT_Status = false;
    }
  } // end of if (!client.connected())
  return client.connected();
}  // end of void Reconnect()
// -----------------------------------------------------------
void setup()
{
  Serial.begin(115200);
  EEPROM.begin(512);            // Enable 512 bytes of EEPROM
  BME280 = false;  
  Serial.println("");
   // ------------ Check if OLED screen fitted ------
      Wire.begin(Board_SDA,Board_SCL);
      Wire.setClock(400000L);
      Wire.beginTransmission(OLED_I2C_ADDRESS);
      byte error = Wire.endTransmission();
      if (error > 0)
      {
        Serial.println(F("No OLED display fitted"));
        OLED = false;
      }
      else Serial.println(F("OLED display detected"));
   // ------------ Initialise OLED screen ----------
  if(OLED)   // only if OLED display is enabled
  {  
      oled.begin(&Adafruit128x64, OLED_I2C_ADDRESS);  
      oled.setFont(Adafruit5x7);
      // ----------------- OLED boot screen ---------------------
      oled.clear();
      oled.setCursor(0,2);
      oled.println(Firmware_Version);
      oled.println(DateCreated);
      oled.println("");
      oled.print("Device Start Up");
      delay(1000);     
  }  // end of   if(OLED)   // only if OLED display is enabled
   // ----------------------------------------------------------- 
    if (bmp.begin() == false) Serial.println(F("BMP180 not fitted!"));  // test for BMP180
    else 
    {
      BMP180 = true;
      Serial.println(F("BMP180 fitted!"));        
    }
    if (bme.begin(BME280_I2C_ADDRESS)== false) Serial.println(F("BME280 not fitted!")); // test for BME280
    else 
    {
      BME280 = true;
      Serial.println(F("BME280 fitted!"));      
    }
  Alarm = false;
  Auto_EEPROM_Check();   // check to see if EEPROM is initialised, if not set to defaults
  NoOfRelays = sizeof(RelayPin); 
  if (NoOfRelays >3 || NoOfRelays == 0) NoOfRelays = 3;  // precaution - ensure valid number is present
  byte i = 0; 
  pinMode(AP_Switch, INPUT_PULLUP);   
  pinMode(ManualButton,INPUT_PULLDOWN_16);
  i = 0;
  while (i < NoOfRelays)
  {  
    pinMode(RelayPin[i], OUTPUT);           // Initialise Relay output pins
    digitalWrite(RelayPin[i], RelayOff);   // set relay OFF
    i++;
  }
  pinMode(Heartbeat_LED,OUTPUT);  // Inititialise Heart beat LED   
  Serial.println("");
  Serial.println(Firmware_Version + "  " + DateCreated);   // display firmware revision number
  Serial.println(F("Developer: Chris Gimson     chris@gimson.co.uk"));
  EnableMessages = EEPROM.read(EEPROM_EnableMessages);  // set the display messages flag 
  Serial.println("");
  Serial.print(NoOfRelays);
  Serial.println(F(" Relay(s) fitted"));  
  Serial.print("EEPROM - ");Serial.print(EEPROM_End);
  Download_WiFi_Login_Details_From_EEPROM(true);   // Download EEPROM values to working memory
  Download_From_EEPROM_Output_And_Input_Settings(true);
  Download_From_EEPROM_Relay_Descriptors(true); 
  Download_From_EEPROM_Timer_Control_Parameters(true); 
  DownloadMQTT_detailsFromEEPROM(true); 
  RouterMode = EEPROM.read(EEPROM_RouterMode);
  WiFiManualEnable = EEPROM.read(EEPROM_WiFiManualEnable);
  AutoResetTimer = AutoResetTimeout;  // Timer for auto reset if connection fails
  AutoResetTimerEnable = false;       // disable auto reset timer
  DisplayToggleInterval = EEPROM.read(EEPROM_DisplayToggleInterval)*1000;
  RemoteScreenTimeout = EEPROM.read(EEPROM_RemoteScreenTimeout);
  TempOffset = float(EEPROMReadlong(EEPROM_TempOffset))/10;
  LightLevelThreshold[0] = EEPROM.read(EEPROM_LightLevelThreshold);
  LightLevelThreshold[1] = EEPROM.read(EEPROM_LightLevelThreshold + 1);
  LightLevelThreshold[2] = EEPROM.read(EEPROM_LightLevelThreshold + 2);  
  if (TempOffset < -10.0 || TempOffset > 10.0) TempOffset = 0.0;
  if(RemoteScreenTimeout > 120) RemoteScreenTimeout = 120;
  if(EEPROM.read(EEPROM_DisplayToggleInterval) == 11) DisplayToggle = false; else DisplayToggle = true;
  DisplayOffTime = EEPROM.read(EEPROM_DisplayOffTime); 
  if (DisplayOffTime > 24) DisplayOffTime = 23;
  DisplayOnTime = EEPROM.read(EEPROM_DisplayOnTime); 
  if (DisplayOnTime > 24) DisplayOnTime = 6; 
  NTP_Resolved = false;   // true = soft clock successfully by NTP  
  if(WiFiManualEnable == true) 
  {
    Soft_AP_Switch = false;  // disable access point
    WifiConnect();      // connect to wifi network  
    randomSeed(micros()); 
    MQTT_ServerCopy = MQTT_Server + ".local";
    client.setServer(MQTT_ServerCopy.c_str(), 1883);
    client.setCallback(callback);  
    if(OLED)
    {
      Display_OLED_String(HostName,0,0,false);  // If Home screen, print to OLED the device name - Line 1  
      Display_OLED_String("Logging on to network",5,0,true);  
    }                
    if (ClockEnable) 
    {
      NTP_TimeInterval = 10000;   // set up NTP interval timer (mS)
      udp.begin(localPort_NTP);   // for the NTP server
      NTP_Timer = millis();   // for the NTP time interval timer
    }
    delay(100);
  }  // end of   if(WiFiManualEnable == true) 
  else 
  {
    WiFi.disconnect(true); 
    Serial.println(F("WiFi not enabled"));  
    Soft_AP_Switch = true;   // enable access point        
  }
  LoopTimer = millis();  // for the LED flash rates
  TimerTick = millis();  // for the output and PIR timers 
  AccessPointRunning = false;  
  i = 0;  
  if(WiFiManualEnable == true) 
  {   
    LocalServer.on("/OLED_Screen_Settings",OLED_Screen_Settings);
    LocalServer.on("/", HomePage);
    LocalServer.on("/Quit",Quit);
    LocalServer.on("/DisplaySystemSettings",DisplaySystemSettings);
    LocalServer.on("/Timer_Page_Relay1",Timer_Page_Relay1);
    LocalServer.on("/Timer_Page_Relay2",Timer_Page_Relay2);   
    LocalServer.on("/Timer_Page_Relay3",Timer_Page_Relay3);
    LocalServer.on("/RelayOnTimers",RelayOnTimers);
    LocalServer.on("/WiFiSetUp",WiFiSetUp);
    LocalServer.on("/ProcessControlOutputNames",ProcessControlOutputNames);
    LocalServer.on("/ControlOutputNames",ControlOutputNames);  
    LocalServer.on("/StartAP",StartAP);
    LocalServer.on("/WebSwitchRelay1",WebSwitchRelay1);      
    LocalServer.on("/WebSwitchRelay2",WebSwitchRelay2);   
    LocalServer.on("/WebSwitchRelay3",WebSwitchRelay3);   
    LocalServer.on("/Relay3TimerControl",Relay3TimerControl);
    LocalServer.on("/Relay2TimerControl",Relay2TimerControl);
    LocalServer.on("/Relay1TimerControl",Relay1TimerControl);
    LocalServer.on("/WiFiConfiguration",WiFiConfiguration);  
    LocalServer.on("/MQTT_SetUp",MQTT_SetUp);  
    LocalServer.on("/PIR_Setup",PIR_Setup);     
    LocalServer.begin(); // start the local server
    if (MDNS.begin(HostName.c_str())) 
    {
      Serial.println("mDNS started"); 
      MDNS.addService("http", "tcp", 80);
    }
    else Serial.println("Failed MDNS");             
  }   // end of if(WiFiManualEnable == true)    
   serverAP.on("/OLED_Screen_Settings",OLED_Screen_Settings);
   serverAP.on("/", HomePage);
   serverAP.on("/Quit",Quit);
   serverAP.on("/DisplaySystemSettings",DisplaySystemSettings);
   serverAP.on("/Timer_Page_Relay1",Timer_Page_Relay1);
   serverAP.on("/Timer_Page_Relay2",Timer_Page_Relay2);   
   serverAP.on("/Timer_Page_Relay3",Timer_Page_Relay3);
   serverAP.on("/RelayOnTimers",RelayOnTimers);
   serverAP.on("/WiFiSetUp",WiFiSetUp);
   serverAP.on("/ProcessControlOutputNames",ProcessControlOutputNames);
   serverAP.on("/ControlOutputNames",ControlOutputNames);  
   serverAP.on("/WebSwitchRelay1",WebSwitchRelay1);      
   serverAP.on("/WebSwitchRelay2",WebSwitchRelay2);   
   serverAP.on("/WebSwitchRelay3",WebSwitchRelay3);   
   serverAP.on("/Relay3TimerControl",Relay3TimerControl);
   serverAP.on("/Relay2TimerControl",Relay2TimerControl);
   serverAP.on("/Relay1TimerControl",Relay1TimerControl);
   serverAP.on("/WiFiConfiguration",WiFiConfiguration);    
   serverAP.on("/MQTT_SetUp",MQTT_SetUp);  
   serverAP.on("/PIR_Setup",PIR_Setup);                     
   byte PageCounter = 0;   // Initialise (clear) OLED display buffer
   if(OLED) oled.clear();  // only if OLED display is enabled
   while (PageCounter < NoOf_OLED_Pages)  // initialise all OLED screen memory buffers
   {
      ScreenEnable[PageCounter] = false;  // initially turn off all OLED screens (except Home screen)
      byte LineCounter = 0;         
      while (LineCounter < NoOf_OLED_OpenLines)
      {
         i = 0;
         while (i < NoOf_OLED_CharactersPerLine)
         {
            OLED_PageBuffer[PageCounter][LineCounter][i] = ' ';             
            i ++; 
         }
         OLED_ScreenHomeCopy [PageCounter][LineCounter] = false;    // reset all OLED lines to "Overwrite"         
         LineCounter++;
      }
      ScreenAge[PageCounter] = 0;  // reset page update timers          
      PageCounter ++;
   } 
   ScreenNo = Home;
   i=0;
   while (i < NoOf_OLED_Pages)
   {
      Remote_OLED_TxCounter[i] = RemoteScreenTimeout * 60000 / DisplayToggleInterval;  // set all OLED page timeouts
      i++;
   }
   FirstPass = false;    // used in OLED update function  
   DisplayToggleRunningTimer = millis(); 
   MQTT_Reset =  false;  
   MQTT_RunningTimer = millis();
   MQTT_LastReconnectAttempt = millis();
   MQTT_Status = false;
   MQTT_Client.setTimeout(100);
   MQTT_DropOutCounter = 0;
   PIR_Connected = false;
   PIR_Tx_CounterEnable = false;
    // ----------------- OTA stuff -------------------------------
    // Port defaults to 8266
    // ArduinoOTA.setPort(8266);
    // Hostname defaults to esp8266-[ChipID]
    // ArduinoOTA.setHostname("HouseNode");
    // No authentication by default
    // ArduinoOTA.setPassword((const char *)"123");

    ArduinoOTA.onStart([]() 
    {
      if(EnableMessages) Serial.println("Start");
    });
   
   ArduinoOTA.onEnd([]() 
   {
     if(EnableMessages) Serial.println("\nEnd");
   });
   ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
    if(EnableMessages) Serial.printf("Progress: %u%%\r", (progress / (total / 100)));
   });
   ArduinoOTA.onError([](ota_error_t error) 
   {
     if(EnableMessages) 
     {
      Serial.printf("Error[%u]: ", error);
      if (error == OTA_AUTH_ERROR) Serial.println("Auth Failed");
      else if (error == OTA_BEGIN_ERROR) Serial.println("Begin Failed");
      else if (error == OTA_CONNECT_ERROR) Serial.println("Connect Failed");
      else if (error == OTA_RECEIVE_ERROR) Serial.println("Receive Failed");
      else if (error == OTA_END_ERROR) Serial.println("End Failed");
     }
   });
   ArduinoOTA.begin();
      // --------------------------------------------------
   LostWiFiCounter = LostWiFiDefaultCounterValue; 
}    // end of void setup()
// -------------------------------------------------------- 
void loop()
{
   ArduinoOTA.handle();   
   byte i = 0;  
        //------------- Check for AP Button presses ---------------------------------
   i = Check_AP_Switch(); 
   if(i == 2) Soft_AP_Switch = true;  // set flag if AP switch pressed for > 5 seconds 
   if(i == 1 && OLED == true) 
   {  // manual inrement of the screen display toggle counter
      ScreenNo ++;
      if (ScreenNo > NoOf_OLED_Pages) ScreenNo = 0; // page counter overflow - reset to start
      if (ScreenNo > 0 && ScreenNo <= NoOf_OLED_Pages ) // page counter is not the home screen pointer
      {
        while(ScreenEnable[ScreenNo-1]== false) // increment page counter until an enabled page is found
        {
          ScreenNo ++;                  
          if (ScreenNo > NoOf_OLED_Pages) 
          {
            ScreenNo = 0;  // has counted to end without finding an enabled page
            break;         // so exit with page counter set to start
          }  // end of if (ScreenNo > NoOf_OLED_Pages) 
        }  // end of while(ScreenEnable[ScreenNo-1]== false)
      }  // end of if (ScreenNo > 0 && ScreenNo <= NoOf_OLED_Pages )
      DisplayToggleRunningTimer = millis(); 
      DisplayToggleInterval = 5000; // temporarily set duration interval to 5 seconds  
      TemporaryDisplayCounter = TemporaryDisplayCounterInterval; // enable temporary display count for approx 15 seconds      
   } // end of  if(i == 1 && OLED == true) 
        //------------- Check for Manual Button presses ---------------------------------
   boolean State = ManualButtonOn;   
   i = CheckManualButton();  // check if Manual Button has been pressed and if so, how long
   if(i == 3 && NoOfRelays > 2)
   {
    if(digitalRead(RelayPin[2]) == ManualButtonOn) State = ManualButtonOff;       
    Activate_Relay(2,State,true);
   }
   else if(i == 2 && NoOfRelays > 1) 
   {
    if(digitalRead(RelayPin[1]) == ManualButtonOn) State = ManualButtonOff;     
    Activate_Relay(1,State,true);
   }
   else if(i == 1) 
   {
    if(digitalRead(RelayPin[0]) == ManualButtonOn) State = ManualButtonOff; 
    Activate_Relay(0,State,true);
   }             
   // ----------------------- Access Point (AP) ------------------------------------
   if(Soft_AP_Switch == true)    // 
   {   // AP is enabled
      if (AccessPointRunning == false)  // is AP already running?
      {                                   // not running so set up AP
         Set_Up_Access_Point();
         AccessPointRunning = true;    
      }   // end of  if (AccessPointRunning == false) 
      else 
      {
        TemporaryDisplayCounter = 49;  // ensures that OLED screen AP screen is always on during AP
        serverAP.handleClient();  // AP is running so maintain AP web page 
      }
   }  // end of    if(Soft_AP_Switch == true)    // Access Point (AP) 
   else
   {                //  AP is disabled
      WiFi.softAPdisconnect(true);   // disconnect the AP
      serverAP.stop();               // Stop  the AP webserver 
      WiFi.mode(WIFI_STA);           // Switch to station mode only
      AccessPointRunning = false;   
      if (WiFiManualEnable == true) 
      {
        LocalServer.handleClient();   // handle incoming requests from Remote access clients          
        MDNS.update();        
      }
   }  // end of  else  
   Check_For_Keyboard_Command();        
// ---------------------------- Station mode ------------------------------------------------                  
   if (WiFiManualEnable == true)
   {   
    if (LoginSuccessful == true)
    {  
      if (WiFi.status() == WL_CONNECTED) 
      {
          LED_OnTimer = LED_OnFlash;   // Set LED flash rate - Station = connected, with NTP resolved
          LED_OffTimer = LED_OffFlash;  
          LostWiFiCounter = LostWiFiDefaultCounterValue;                
	    } // end of if (WiFi.status() == WL_CONNECTED)  
      else 
      if (!AccessPointRunning) 
      {
        LostWiFiCounter --;
        if(LostWiFiCounter == 0) ResetDevice("Lost Wifi Connection");  // Lost connection (only if AP is not running) 
      }
    }  // end of if(LoginSuccessful)  
   }  // end of if (WiFiManualEnable == true)
   else
   {
      LED_OnTimer = LED_OnFlash;   // Set LED flash rate - Station = connected, with NTP resolved
      LED_OffTimer = LED_OffFlash;    
   }
   // -------------------- OLED multi screen toggle feature ---  
   if (DisplayToggle == true) // If the OLED multiscreen toggle feature is enabled
   {
    unsigned long DisplayToggleTimer = millis() - DisplayToggleRunningTimer; 
    if (DisplayToggleTimer >= DisplayToggleInterval)
    {     // Display toggle timeout      
      DisplayToggleInterval = EEPROM.read(EEPROM_DisplayToggleInterval)*1000; //Reload interval time just in case been changed manually
      ScreenNo ++;
      if (ScreenNo > NoOf_OLED_Pages) ScreenNo = 0; // page counter overflow - reset to start
      if (ScreenNo > 0 && ScreenNo <= NoOf_OLED_Pages ) // page counter is not the home screen pointer
      {
        while(ScreenEnable[ScreenNo-1]== false) // increment page counter until an enabled page is found
        {
          ScreenNo ++;                    
          if (ScreenNo > NoOf_OLED_Pages) 
          {
            ScreenNo = 0;  // has counted to end without finding an enabled page
            break;         // so exit with page counter set to start
          }    // end of if (ScreenNo > NoOf_OLED_Pages)                
        }  // end of while(ScreenEnable[ScreenNo-1]== false)         
        if (ScreenNo>0)
          {
            Remote_OLED_TxCounter[ScreenNo-1] --;  
            if(EnableMessages)
            {
              Serial.print(ScreenNo); 
              Serial.print (" Remote_OLED_TxCounter = "); 
              Serial.println(Remote_OLED_TxCounter[ScreenNo-1]);
            }
            if (Remote_OLED_TxCounter[ScreenNo-1] == 0) ScreenEnable[ScreenNo-1] = false; 
          }         
      }  // end of if (ScreenNo > 0 && ScreenNo <= NoOf_OLED_Pages )
      DisplayToggleRunningTimer = millis();     
    }
   } // end of  if (DisplayToggle) // If the OLED multiscreen toggle feature is enabled
   else ScreenNo = Home;  // if toggle not enabled, fix screen at Home Page  
   // --------------------------------------------------------
   unsigned long LED_Timer = millis() - LoopTimer;   // Grab time value since last scan
   if (digitalRead(Heartbeat_LED) == LED_On)   // If the Heartbeat LED is ON
   {
     if (LED_Timer >= LED_OnTimer) 
     {
       digitalWrite(Heartbeat_LED,LED_Off); // On timer has timed out so flip LED output 
      Process_Minute_Timers();  // check and update minute timer (re output timers and timer control)
      if (ClockEnable == true && WiFiManualEnable == true) Interval_Update_Clock();  // Check soft clock against NTP server only if clock is enabled
      Check_Time_Control_Relay1();   // Timer Control for relay 1
      if (NoOfRelays >= 2) Check_Time_Control_Relay2();   // Timer Control for relay 2 if fitted
      if (NoOfRelays == 3) Check_Time_Control_Relay3();   // Timer Control for relay 3 if fitted   
// ---------------- Read environmental sensors ----------------------
      if(BMP180) Get_BMP180();  // if BMP180 is enabled
      if(BME280) Get_BME280();     
// ---------------- Update OLED display  if fitted and enabled ------------------      
      if(OLED == Fitted)
      {
          if(TemporaryDisplayCounter > 0)  // if temporary timed display (via manual button)
          {
            Update_OLED();
            TemporaryDisplayCounter = TemporaryDisplayCounter - 1;           
          }
          else
          if(DisplayOnTime!=DisplayOffTime)    
          {
              if((ClockHour>=DisplayOnTime && ClockHour<DisplayOffTime) || WiFiManualEnable == false) Update_OLED();
              else oled.clear();
          }  // end of if(OLED == Fitted && DisplayOnTime!=DisplayOffTime) 
      }  // end of if(OLED)                
       LoopTimer = millis();              // Set LED flash timer for OFF cycle                
     }  // end of      if (LoopTimer >= LED_OnTimer)      
   } // end of if (digitalRead(Heartbeat_LED) == LED_On)   // If the Heartbeat LED is ON
   else              // If the Heartbeat LED is OFF
   {
    if (LED_Timer >= LED_OffTimer) 
    {
      digitalWrite(Heartbeat_LED,LED_On);  // Off timer has timed out so flip LED output
// ------------------------------------------------------------------      
      LoopTimer = millis();              // Set LED flash timer for ON cycle
    } // end of  if (LoopTimer >= LED_OffTimer)
   }  // end of else  // If the Heartbeat LED is OFF
   if (MQTT_Reset ==  true) ResetDevice("Remote Reset");    // reset command received
   // ------------- Maintain MQTT connection -----------------------
   if (LoginSuccessful == true && RemoteDataSend() == true) 
   {
      if (!client.connected()) 
      {
        long Now = millis();
        if (Now - MQTT_LastReconnectAttempt > 3000) 
        {   // Timeout - enable attempt to reconnect
          MQTT_LastReconnectAttempt = Now;
          if (Reconnect()) MQTT_LastReconnectAttempt = millis();
        }
      }  // end of if (!client.connected()) 
      else client.loop();// Client connected
      // ------------- MQTT Push message  -------------------
      unsigned long MQTT_Timer = millis() - MQTT_RunningTimer;   // Grab time value since last scan
      if (MQTT_Timer >= MQTT_PushInterval )  // if time for an MQTT push message
      {
            if(RemoteDataSendEnable[0] == true) PushMQTT_RelayStatusMessage(0);
            if(RemoteDataSendEnable[1] == true) PushMQTT_RelayStatusMessage(1);
            if(RemoteDataSendEnable[2] == true) PushMQTT_RelayStatusMessage(2);
            if(RemoteDataSendEnable[3] == true) PushMQTT_RelayStatusMessage(3);
            if(RemoteDataSendEnable[4] == true) PushMQTT_RelayStatusMessage(4);
            MQTT_RunningTimer = millis();
      }
      if(MQTT_Acknowledge == true)
      {
        MQTT_Acknowledge = false;
        PushMQTT_AcknowledgeMessage(LastRxMessage);
      }        
   } // end of if (LoginSuccessful && WiFiManualEnable == true)   
} // end of void loop()
// -------------------------------------------------------- 
boolean RemoteDataSend()  // returns true if any MQTT activity is enabled
{
  byte i = 0;
  while(i < sizeof(RemoteDataSendEnable))
  {
    if(RemoteDataSendEnable[i] == true) return true;
    i ++;
  } 
  return false; 
}  // end of boolean RemoteDataSend() 
    // ---------------------------------------------------
void PushMQTT_RelayStatusMessage(byte RecipientNumber)
{    
    if(MQTT_Status == true)
    {
      byte i = 0;
      boolean state;
      String DataPacket = "Compact:Relay";
      while (i < NoOfRelays)
      {
        DataPacket += ":" + String(i+1);
        if (digitalRead(RelayPin[i]) == RelayOn) DataPacket += ",ON";
        else DataPacket += ",OFF"; 
        i++;  
      }   
      delay(10);      
      String Topic = RecipientHostName[RecipientNumber] + "/" + HostName;    
      if(EnableMessages)
      {
        Serial.print(F("Send MQTT ["));
        Serial.print(Topic);
        Serial.print(F("] "));
        Serial.println(DataPacket);  
      }
      client.publish(Topic.c_str(),DataPacket.c_str());     
    }  // end of if(MQTT_Status == true)
}  // end of void PushMQTT_RelayStatusMessage(byte RecipientNumber)
    // ------------------------------------------------------
void PushMQTT_AcknowledgeMessage(String Message)
{    
    if(MQTT_Status == true)
    {
      byte i = 0;
      boolean state;
      String DataPacket = Message;   
      String Topic = "ACK/" + HostName;    
      if(EnableMessages)
      {
        Serial.print(F("Acknowledge MQTT ["));
        Serial.print(Topic);
        Serial.print(F("] "));
        Serial.println(DataPacket);  
      }
      client.publish(Topic.c_str(),DataPacket.c_str());     
    }  // end of if(MQTT_Status == true)
}  // end of void PushMQTT_AcknowledgeMessage(String Message)
    // ---------------------------------------------------------
byte Check_AP_Switch() // returns value depending on how long the AP button is pressed  
{
  unsigned long SwitchPressedTime; 
  if(digitalRead(AP_Switch) == AP_SwitchOff )   // read & test the button status
  {       // if not pressed
      TimeStart = millis();   // get time marker in readiness for switch being pressed
      return 0;
  }
  else // switch is ON
  {
    while (digitalRead(AP_Switch) == AP_SwitchOn)  // wait until button is released
    {
      Heartbeat_Tick();   // keep HW watchdog alive
      SwitchPressedTime = millis() - TimeStart;  // calculate the time since button was pressed(mS)
    }
          // button released
    if (EnableMessages) Serial.println(SwitchPressedTime);     // Diagnostic - button duration time (mS) 
    if(SwitchPressedTime >= 10000) ResetDevice("by AP button");   // if AP_Switch is pressed for > 10 seconds = reset 
    if(SwitchPressedTime >= 5000)  return 2;   // Wake up Access point
    if(SwitchPressedTime >= 100 && OLED == true ) return 1;   // increment screen display counter
    return 0;   // button not pressed long enough

  }  // end of else // switch is ON
}     // end of byte Check_AP_Switch()
//  ---------------------------------------------------------------------
byte CheckManualButton() // returns value depending on how long the AP button is pressed  
{
  unsigned long SwitchPressedTime; 
  if(digitalRead(ManualButton) == ManualButtonOff )   // read & test the button status
  {       // if not pressed
      TimeStart = millis();   // get time marker in readiness for switch being pressed
      return 0;
  }
  else // switch is ON
  {
    while (digitalRead(ManualButton) == ManualButtonOn)  // wait until button is released
    {
      Heartbeat_Tick();   // keep HW watchdog alive
      SwitchPressedTime = millis() - TimeStart;  // calculate the time since button was pressed(mS)
    }
          // button released
    if (EnableMessages) Serial.println(SwitchPressedTime);     // Diagnostic - button duration time (mS) 
    //if(SwitchPressedTime >= 12000) ResetDevice("by Manual button");   // if ManualButton is pressed for > 12 seconds = reset 
    if(SwitchPressedTime >= 7000) return 3;   // Toggle State of relay 3
    if(SwitchPressedTime >= 3000) return 2;   // Toggle State of relay 2    
    if(SwitchPressedTime >= 100) return 1;   // Toggle State of relay 1
    return 0;   // button not pressed long enough
  }  // end of else // switch is ON
}     // end of byte CheckManualButton()
// -----------------------------------------------------------------------
void Process_Minute_Timers()   // check the various function minute timers inc soft clock
{
  unsigned long Minute_Timer = millis() - TimerTick;
  if (Minute_Timer >= One_Minute_timer_Tick_Threshold)   // Check for 1 minute timer tick
  {     // every minute
    TimerTick = millis(); 
    PIR_Connected ++;   
    if(AutoResetTimerEnable)   // if WiFi connect failed at log in
    {
      AutoResetTimer = AutoResetTimer - 1;  // decrement AP timeout counter
      if(AutoResetTimer == 0) ResetDevice("Login Failed, Auto Reset");       
    }   
    byte i = 0;   // check each ON timer for all activated outputs
    while (i < NoOf_OLED_Pages)
    {
      if(ScreenEnable[i]) ScreenAge[i] ++;   // increment each screen timer if enabled
      i ++;  
    }     
    i = 0;
    while (i < NoOfRelays)
    {
      Check_Outputs_For_Timeout(i);  // check timer every minute, if time out switch output off
      i ++;
    } // end of while (i < NoOfRelays)
    ClockMinute ++;    // Service the soft clock
    if (ClockMinute >= 60)  // if on the hour
    {
      ClockMinute = 0;
      ClockHour ++;  // increment the hour value
      if (ClockHour >= 24) // if midnight
      {
        ClockHour = 0; 
        ClockWeekDay ++; //increment week day
        if (ClockWeekDay >= 8 || ClockWeekDay == 0) ClockWeekDay = 1;  // overflow from Saturday to Monday
      }
    }   // end of  if (ClockMinute >= 60)  // if on the hour
    LongClockMinute = (ClockHour * 60) + ClockMinute;   // calculate time in minutes   
  }  // end of if (Minute_Timer >= One_Minute_timer_Tick_Threshold)
}
// ------------------------- MQTT commands -------------------------------
void MQTT_SwitchOne(uint8_t State) 
{
    if (EnableMessages)
    {
      Serial.print(RelayDescriptors[0]); 
      Serial.print(" Switched ... ");
    }
    if(State == 1) 
    {
      Activate_Relay(0, SwitchOn,true); // switch relay & virtual output flag to ON, 
      if (EnableMessages) Serial.print("ON");
    }
    else if(State == 0)
    {
      Activate_Relay(0, SwitchOff,true); // switch relay & virtual output flag to ON,
      if (EnableMessages) Serial.print("OFF");
    }
    else if(State == 2) MQTT_Reset = true;
    if (EnableMessages) Serial.println("");    
}
// --------------------------------------------------------
void MQTT_SwitchTwo(uint8_t State) 
{
    if (EnableMessages)
    {
      Serial.print(RelayDescriptors[1]); 
      Serial.print(" Switched ... ");
    }
    if(State == 1) 
    {
      Activate_Relay(1, SwitchOn,true); // switch relay & virtual output flag to ON, 
      if (EnableMessages) Serial.print("ON");
    }
    else if(State == 0) 
    {
      Activate_Relay(1, SwitchOff,true); // switch relay & virtual output flag to ON,
      if (EnableMessages) Serial.print("OFF");
    }
    else if(State == 2) MQTT_Reset = true;
    if (EnableMessages) Serial.println("");
}
// --------------------------------------------------------
void MQTT_SwitchThree(uint8_t State) 
{
    if (EnableMessages)
    {
      Serial.print(RelayDescriptors[2]); 
      Serial.print(" Switched ... ");
    }
    if(State == 1) 
    {
      Activate_Relay(2, SwitchOn,true); // switch relay & virtual output flag to ON, 
      if (EnableMessages) Serial.print("ON");
    }
    else if(State == 0) 
    {
      Activate_Relay(2, SwitchOff,true); // switch relay & virtual output flag to ON,
      if (EnableMessages) Serial.print("OFF");
    }
    else if(State == 2) MQTT_Reset = true;
    if (EnableMessages) Serial.println("");    
}
// --------------------------------------------------------
void Check_For_Keyboard_Command()  // Used in loop() - checks keyboard for a single character command
{
  if (Serial.available() > 0) 
  {
    Command = Serial.read();
    if (Command == 'A' || Command == 'A')  Soft_AP_Switch = true; 
    if (Command == 'b')  Setup_AP_Password();  
    if (Command == 'c')  
    {
      ClockEnable = !ClockEnable;
      Serial.print(F("Clock is "));
      if (ClockEnable) Serial.println(F("Enabled")); else Serial.println(F("Disabled"));
      EEPROM.write (EEPROM_ClockEnable, ClockEnable);
      EEPROM.commit();
      ResetDevice("Reset to install clock");
    }      
    if (Command == 'd')  // Download and display all EEPROM based values
    {     
      EnableMessages = EEPROM.read(EEPROM_EnableMessages);
      Serial.print(F("Diagnostic messages enable: ")); Serial.println(EnableMessages);     
      Download_WiFi_Login_Details_From_EEPROM(true);
      Download_From_EEPROM_Relay_Descriptors(true);        
      Download_From_EEPROM_Output_And_Input_Settings(true);  
      if (ClockEnable) Download_From_EEPROM_Timer_Control_Parameters(true); 
      else Serial.println(F("NTP Clock is Disabled"));
      DownloadMQTT_detailsFromEEPROM(true); 
      Serial.println("");
      Serial.print(F("CheckForCombinedTimersRelay1 - ")); Serial.println(CheckForCombinedTimersRelay1());
      Serial.print(F("CheckForCombinedTimersRelay2 - ")); Serial.println(CheckForCombinedTimersRelay2());
      Serial.print(F("CheckForCombinedTimersRelay3 - ")); Serial.println(CheckForCombinedTimersRelay3());      
      Display_Current_Output_Timer_Values();
      if(OLED)
      {
        Serial.print(F("Display Screen Toggle is "));
        if(DisplayToggle == false) Serial.println(F("Disabled"));
        else
        {
          Serial.println(F("Enabled"));
          if (DisplayToggle) 
          {
            Serial.print(F("Screen display Toggle Time (s) = ")); Serial.println(DisplayToggleInterval/1000);
            Serial.print(F("Remote sensor screen timeout (min) is ")); Serial.println(RemoteScreenTimeout); 
          }         
        }  // end of else  
        byte i = 0;
        while (i < NoOf_OLED_Pages)  // print all enabled Aux screen update timer values
        {
          if(ScreenEnable[i])
          {
            Serial.print(F("Aux screen "));
            Serial.print(i+1);
            Serial.print(F(" update timer (mins) = "));
            Serial.println(ScreenAge[i]);   // increment each screen timer if enabled
          }
          i ++;  
        }  // end of while (i < NoOf_OLED_Pages)  // print all enabled ...             
      }  // end of  if(OLED)
      if (BMP180)
      {
          Serial.println("");
          Serial.print(F("Room Temperature ('C)    = "));Serial.println(RoomTemp,1);
          Serial.print(F("Barometric Pressure (mb) = "));Serial.println(BaraPress,0);
          Serial.print(F("Temp Calibration Offset = ")); Serial.println(float(TempOffset),1);         
      }
      if (BME280)
      {
          Serial.println("");
          Serial.print(F("Room Temperature ('C)    = "));Serial.println(RoomTemp,1);
          Serial.print(F("Barometric Pressure (mb) = "));Serial.println(BaraPress,0);
          Serial.print(F("Humidity (%RH) = ")); Serial.println(Humidity,1);
          Serial.print(F("Temp Calibration Offset = ")); Serial.println(float(TempOffset),1);           
      } 
          Serial.println("");
          Serial.print(F("LightLevelThreshold[0] - "));Serial.println(LightLevelThreshold[0]);
          Serial.print(F("LightLevelThreshold[1] - "));Serial.println(LightLevelThreshold[1]);
          Serial.print(F("LightLevelThreshold[2] - "));Serial.println(LightLevelThreshold[2]);
          Serial.print(F("PIR_Connected - "));Serial.println(PIR_Connected);
          Serial.print(F("PIR_Tx_CounterEnable - "));Serial.println(PIR_Tx_CounterEnable);       
    }   // end of if (Command == 'd')  // Download and display all EEPROM based values
    
    if (Command == 'h' || Command == 'H')  
    {
      Serial.println(""); 
      Serial.print(Firmware_Version);
      Serial.print(F(" - ")); 
      Serial.println(DateCreated);
      Serial.println("");
      Serial.println(F("AVAILABLE KEYBOARD COMMANDS")); Serial.println("");
      Serial.println(F("A = Toggle the soft Access Point Enable Flag")); 
      Serial.println(F("b = Set up Configuration Access Point password"));        
      Serial.println(F("d = Download and display all of the EEPROM stored configuration parameters"));
      Serial.println(F("c = Toggle Clock Enable Feature (will reset afterwards"));
      Serial.println(F("E = Clear EEPROM to defaults (Must reset afterwards)"));
      Serial.println(F("z = Clear WiFi & MQTT settings in EEPROM to defaults (Must reset afterwards)"));
      Serial.println(F("f = Diagnostic Demon - Active Flags & Variables")); 
      Serial.println(F("h = Show this Help menu screen again"));                  
      Serial.println(F("l = Keyboard entry of WiFi login parameters"));
      Serial.println(F("m = Toggle Enable Diagnostic Messsages"));
      //Serial.println(F("n = Set the number of output relays outputs <Must reset afterwards>")); 
      Serial.println(F("R = Reset device"));
      Serial.println(F("t = Display current output timer values"));
      if(ClockEnable) Serial.println(F("T = Display Soft Clock"));        
      Serial.println(F("w = Direct write to output relays E.g w10, w11, w20, w21, w30, w31")); 
      Serial.println(F("r = Direct read of output relays")); 
      Serial.println(F("W = Display WiFi connection status and details"));            
      Serial.println("");
    } 
    if (Command == 'r')  Remote_Read_Of_Relay_Status();   // Send output status values to serial port
    if (Command == 'w')  Remote_Control_Of_Relay(); // Set/reset outputs from serial port
    if (Command == 'W')  Display_WiFi_Connection_Status();
    if (Command == 'R')  ResetDevice("by keyboard");  // Reset device
    if (Command == 'E')  Reset_EEPROM();  
    if (Command == 'z')  ResetWiFi_MQTT_EEPROM();
    if (Command == 't')  Display_Current_Output_Timer_Values(); 
    if (Command == 'T' && ClockEnable == true)  Print_Clock();  
    if (Command == 'l')  Setup_New_WiFi_Login_Values();
    if (Command == 'f')  Diagnostic_Flag_Dump();
    if (Command == 'm')  Toggle_Diagnostic_Messages(); 
    //if (Command == 'n')  Setup_NoOfRelays();                 
    Command = 255;
  }   // end of if (Serial.available() > 0) Command = Serial.read();
}     // end of void Check_For_Keyboard_Command() 
//  ---------------------------------------------------------------------
/*
void Setup_NoOfRelays()
{
  Serial.println(""); Serial.println(F("How many relays fitted (1-3)? <You must reset before the new setting is loaded>"));
  byte Length = GetKeyboardInput();   // Get keyboard entry
  byte value = Validate_Numerical_Entry_From_Keyboard_Buffer(Length, 3);  // validate it for value 1 to 3
  if (value == 255)
  {
    Serial.println(F("Invalid Entry"));
    return; // not valid
  }
  if (value == 0) value = 1;
  Serial.print(F("No of relays fitted = ")); Serial.println(value);
  EEPROM.write(EEPROM_NoOfRelays, value);
  EEPROM.commit();
}
//  ---------------------------------------------------------------------
byte Validate_Numerical_Entry_From_Keyboard_Buffer(byte No_Of_Keystrokes, byte Value_Limit) // validate characters in the keyboard buffer and return a value
{
  byte Value;   // numerical value to be returned from the keyboard buffer.  255 = invalid entry
  boolean Invalid_Entry = false;
  // test depending on number of keystrokes
  if (No_Of_Keystrokes == 1) if(isDigit (KeyboardBuffer[0])) Value = KeyboardBuffer[0] - '0'; else Invalid_Entry = true;      
  if (No_Of_Keystrokes == 2)
  {
    if (isDigit(KeyboardBuffer[1]) && isDigit(KeyboardBuffer[0])) 
      Value = (KeyboardBuffer[1] - '0') + ((KeyboardBuffer[0] - '0') * 10); else Invalid_Entry = true;
  }
  if (No_Of_Keystrokes == 3) 
  {
    if (isDigit(KeyboardBuffer[2]) && isDigit(KeyboardBuffer[1]) && isDigit(KeyboardBuffer[0])) 
      Value = (KeyboardBuffer[2] - '0') + ((KeyboardBuffer[1] - '0') * 10) + ((KeyboardBuffer[0] - '0') * 100) ;
    else Invalid_Entry = true;      // if not numeric  
  }             
       // test for validity - range, null entry, too many characters
  if (No_Of_Keystrokes > 3 || No_Of_Keystrokes == 0 || Value > Value_Limit) Invalid_Entry = true;
  if (Invalid_Entry)
  {
    Serial.println(""); Serial.println(F("Invalid Entry")); Serial.println("");
    Value = 255;
    return Value;   // illegal data entry      
  }
  else return Value;   // value = numerical keyboard entry or = 255 if not valid  
}
*/
    // ------------------------------------------------------------------  
void Toggle_Diagnostic_Messages()  // enable/disable display printout of messages
{
  EnableMessages = !EEPROM.read(EEPROM_EnableMessages);  // get and invert the current flag status
  EEPROM.write(EEPROM_EnableMessages, EnableMessages);         // re-write the inverted flag
  Serial.print(F("Diagnostic is now "));
  if (EnableMessages) Serial.println(F("enabled")); else Serial.println(F("disabled"));
  EEPROM.commit();
}  // end of void Toggle_Diagnostic_Messages()
//  ---------------------------------------------------------------------
void Diagnostic_Flag_Dump()
{
  Serial.println("");
  Serial.println(F("DEMON Status Dump"));
  Serial.print(F("No of Relays: ")); Serial.println(NoOfRelays);  
  Serial.println("");  
  Serial.print(F("Access Point: ")); Serial.println(AccessPointRunning); 
  Serial.print(F("AP Switch: ")); Serial.println(Soft_AP_Switch);  
  Serial.println("");  
  Serial.print(F("LoginSuccessful ")); Serial.println (LoginSuccessful);
  Serial.print (F("WiFi.status()")); Serial.println(WiFi.status());      
  Serial.println("");  
  if(ClockEnable)
  {
    Serial.print(F("NTP_TimeInterval (mS) is ")); Serial.println(NTP_TimeInterval);
    Serial.print(F("last successful NTP update was at "));Serial.print(Last_NTP_Hour); Serial.print(":");
    if (Last_NTP_Minute > 9) Serial.print(Last_NTP_Minute); 
    else 
    {
      Serial.print('0'); 
      Serial.print(Last_NTP_Minute);    
    }
    Serial.print(F("  Day:")); Serial.println(Last_NTP_Day); 
    Serial.println("");
    Serial.print(F("Relay 1 Timer 1: ")); Serial.println(TimerActive[0][0]);
    Serial.print(F("Relay 1 Timer 2: ")); Serial.println(TimerActive[0][1]); 
    if (NoOfRelays >= 2) 
    {
      Serial.print(F("Relay 2 Timer 1: ")); Serial.println(TimerActive[1][0]); 
      Serial.print(F("Relay 2 Timer 2: ")); Serial.println(TimerActive[1][1]);   
    } // end of if (NoOfRelays >= 2) 
    if (NoOfRelays == 3)
    {
      Serial.print(F("Relay 3 Timer 1: "));  Serial.println(TimerActive[2][0]);
      Serial.print(F("Relay 3 Timer 2: "));  Serial.println(TimerActive[2][1]);
      Serial.println();           
    }    // end of if (NoOfRelays == 3)
  } // end of if(ClockEnable)
  
  Serial.print(F("Auto Reset Timer Enable: ")); Serial.println(AutoResetTimerEnable);
  Serial.print(F("Auto Reset Timer (mins): ")); Serial.println(AutoResetTimer);     
  Serial.print(F("Serial port diagnostic messaging: ")); Serial.println(EnableMessages);  
  Serial.println(""); 

  if(OLED)
  {
    byte OLED_ScreenNo = 0;
    while (OLED_ScreenNo < NoOf_OLED_Pages)  // print if OLED screens are enabled
    {
      Serial.print(F("OLED Screen "));Serial.print(OLED_ScreenNo + 1);Serial.print(F(" is "));
      if (ScreenEnable[OLED_ScreenNo] == false) Serial.println(F("Disabled")); 
      else  // screen is enabled
      {
        Serial.println(F("Enabled"));
        byte LineNo = 0;
        while(LineNo < 8)
        {
          Serial.print(F("  Line number "));Serial.print(LineNo + 1);Serial.print(F(" is set to "));
          if (OLED_ScreenHomeCopy[OLED_ScreenNo][LineNo]) Serial.println(F("Home Copy")); else Serial.println(F("Over write"));
          LineNo ++;
        }  
      }  // end of // screen is enabled
      OLED_ScreenNo ++;     
    }  // end of while (OLED_ScreenNo < NoOf_OLED_Pages)  // print if OLED screens are enabled
  } // end of if(OLED)
  else Serial.println(F("OLED display not fitted"));
  Serial.println("");
  Serial.print(F("BMP180 sensor ")); Serial.println(BMP180);  
  Serial.print(F("BME280 sensor ")); Serial.println(BME280);   
}   // end of  void Diagnostic_Flag_Dump()
// ----------------------------------------------------------------------
void Remote_Read_Of_Relay_Status()   // displays the current state of the fitted relays
{   
  byte i = 0;
  boolean state;
  while (i < NoOfRelays)
  {
    state = digitalRead(RelayPin[i]);
    if (state == RelayOn) state = true; else state = false;   
    Serial.println(state);
    i++;  
  }  
}   // end of void Remote_Read_Of_Relay_Status()
//  ---------------------------------------------------------------------
void Remote_Control_Of_Relay()  // Remote control of any active output. w11 = set out 1, w10 = reset output 1,  
{                               // w21 = set output 2, w20 = reset output 2 etc
  byte Output_No;
  byte State = 0;  
  byte i = 0;  
  delay(2);
  while (Serial.available()>0) 
  {
    delay(2);
    char ch = Serial.read();
    KeyboardBuffer[i] = ch;   // get data sent after the command letter
    i++;        
  }   // end of while (Serial.available()>0)
  if (isDigit(KeyboardBuffer[1]) && isDigit(KeyboardBuffer[0])) // check 2 characters are numeric
  {
    Output_No = ((KeyboardBuffer[0] - '0')); // first char = output number
    State = (KeyboardBuffer[1] - '0');       // 2nd character = output status
    if(State == true) State = RelayOn; else State = RelayOff;
    Activate_Relay(Output_No-1,State,true);
  }  // end of if (isDigit(KeyboardBuffer[1]) && isDigit(KeyboardBuffer[0]))
}    // end of void Remote_Control_Of_Relay()
//  ---------------------------------------------------------------------
void Check_Outputs_For_Timeout(byte Output_No)    // every minute check outputs for possible time out (output timers)
{
  if((digitalRead(RelayPin[Output_No]) == RelayOff) || RelayOnTimer[Output_No] == 0) return;  // nothing to do if relay is OFF or timer disabled
  RelayOnTimer[Output_No] = RelayOnTimer[Output_No] - 1;   // decrement timer
  if (RelayOnTimer[Output_No] > 0) return;  // nothing to do if timer has not timed out
  Activate_Relay(Output_No,RelayOff,true);  // Switch relay and remote control flag OFF
}  // end of void Check_Outputs_For_Timeout(byte Output_No)
// ----------------------------------------------------------------------
void Display_Current_Output_Timer_Values()  // displays the current timer values for each fitted relay
{
  byte i = 0;
  while(i < NoOfRelays)  // For each output, display timer value
  {
    Serial.println("");
    Serial.print(F("Output Running Timer ")); 
    Serial.print(i+1); 
    Serial.print(F(" = ")); 
    Serial.print(RelayOnTimer[i]);
    Serial.println(F(" minutes"));
    i ++;
  }
}  // end of void Display_Current_Output_Timer_Values()
// ------------------------------------------------------------
void Reset_EEPROM()   // Clear out all of the previous stored configuration entries & reset the device
{                         // to default values 
  EEPROM.write (EEPROM_RelayOnTimeParameter,60); // Output 1 timer = 60
  EEPROM.write (EEPROM_RelayOnTimeParameter + 1,60); // Output 2 timer = 60
  EEPROM.write (EEPROM_RelayOnTimeParameter + 2,60); // Output 3 timer = 60
  EEPROM.write (EEPROM_Timer_Reset_Enable,false);  // NTP master clock = disabled  
  EEPROM.write (EEPROM_EnableMessages,true);  // enable disgnostic messages
  //EEPROM.write (EEPROM_NoOfRelays,3);  // default no of relays
  EEPROM.write (EEPROM_TimerEnableRelay1Timer1,false);   // Relay Time control disabled
  EEPROM.write (EEPROM_TimerEnableRelay2Timer1,false);
  EEPROM.write (EEPROM_TimerEnableRelay3Timer1,false);
  EEPROM.write (EEPROM_TimerEnableRelay1Timer2,false); 
  EEPROM.write (EEPROM_TimerEnableRelay2Timer2,false);
  EEPROM.write (EEPROM_TimerEnableRelay3Timer2,false);  
  EEPROM.write (EEPROM_ClockEnable,false);  
  EEPROM.write (EEPROM_DisplayToggleInterval,4); 
  EEPROM.write (EEPROM_RemoteScreenTimeout,30);
  EEPROM.write (EEPROM_TempOffset,0);
  EEPROM.write (EEPROM_DisplayOffTime,23); 
  EEPROM.write (EEPROM_DisplayOnTime,8);   
  EEPROM.write (EEPROM_LightLevelThreshold,100);
  EEPROM.write (EEPROM_LightLevelThreshold + 1,100);
  EEPROM.write (EEPROM_LightLevelThreshold + 2,100);  
  int i = 0;
  while (i < 45)    // reset boolean flags for each of 6 x timer week day flags and timer enable flags
  {
    EEPROM.write(EEPROM_Relay1_Timer1_Sun + i, false);
    i++;
  }
  i = 0;
  while (i < 12)    // clear all Timer ON & OFF control parameters
  {
    EEPROM.write(EEPROM_Relay1_Timer1_TimOn_Min + (2 * i),0);
    EEPROM.write(EEPROM_Relay1_Timer1_TimOn_Hrs + (2 * i),i);   
    i= i + 1;   
  } 
  byte Value;         // set up EEPROM header block - indicates that the EEPROM
  i = 0;              // has been initialised
  while (i < 5)
  {
    EEPROM.write(EEPROM_Header_Block + i, i);  // write header byte
    i ++;  
  }  // end of while (i < 5)      
  i = 0;
  while (i < 6)
  {
    EEPROM.write(EEPROM_PIR_TimerInterval + i,10);
    EEPROM.write(EEPROM_PIR_Action + i,PIR_DoNothing);
    i ++;
  } 
  i = 0;  
  while (i < 3)
  {
    EEPROM.write(EEPROM_PIR_AssignedRelay + i,i);
    i ++;
  }
  while (i < 6)
  {
    EEPROM.write(EEPROM_PIR_AssignedRelay + i,i-3);
    i ++;
  }      
  EEPROM.commit();
  if(EnableMessages) Serial.println(F("EEPROM reset to default values"));
}   // end of void Reset_EEPROM()
// ------------------------------------------------------------
void ResetWiFi_MQTT_EEPROM()
{
  unsigned int i = EEPROM_Start_Address;   // initial clear out of complete EEPROM block
  while(i < 60)  
  {
     EEPROM.write(EEPROM_Start_Address + i , 255);
     i++;
  }
  i = EEPROM_WiFi_SSID;
  while(i < EEPROM_WiFi_SSID + MaxStringLength)  // stuff default name into SSID
  {
    EEPROM.write(i, 'S');
    i++;
  }
  i = EEPROM_WiFi_Password;
  while(i < (EEPROM_WiFi_Password + MaxStringLength))  // stuff default name into Password
  {
    EEPROM.write(i, 'P'); 
    i++;
  }
  i = EEPROM_HostName;
  while(i < (EEPROM_HostName + MaxStringLength))  // stuff default name into HostName
  {
    EEPROM.write(i, 'N'); 
    i++;
  } 
  EEPROM.write (EEPROM_WiFiManualEnable,false);
  EEPROM.write(EEPROM_MQTT_PushInterval,240); 
  EEPROM.write (EEPROM_RouterMode,DHCP);   
  EEPROM.write(EEPROM_StaticIPAddress, '0'); 
  EEPROM.write(EEPROM_StaticIPAddress + 1, '1'); 
  EEPROM.write(EEPROM_StaticIPAddress + 2, '0'); 
  EEPROM.write(EEPROM_StaticIPAddress + 3, '.'); 
  EEPROM.write(EEPROM_StaticIPAddress + 4, '0'); 
  EEPROM.write(EEPROM_StaticIPAddress + 5, '0'); 
  EEPROM.write(EEPROM_StaticIPAddress + 6, '0'); 
  EEPROM.write(EEPROM_StaticIPAddress + 7, '.'); 
  EEPROM.write(EEPROM_StaticIPAddress + 8, '0'); 
  EEPROM.write(EEPROM_StaticIPAddress + 9, '0'); 
  EEPROM.write(EEPROM_StaticIPAddress + 10, '0'); 
  EEPROM.write(EEPROM_StaticIPAddress + 11, '.'); 
  EEPROM.write(EEPROM_StaticIPAddress + 12, '1'); 
  EEPROM.write(EEPROM_StaticIPAddress + 13, '5'); 
  EEPROM.write(EEPROM_StaticIPAddress + 14, '0'); 
  EEPROM.write(EEPROM_GatewayIPAddress, '0'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 1, '1'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 2, '0'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 3, '.'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 4, '0'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 5, '0'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 6, '0'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 7, '.'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 8, '0'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 9, '0'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 10, '0'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 11, '.'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 12, '2'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 13, '5'); 
  EEPROM.write(EEPROM_GatewayIPAddress + 14, '4'); 
  EEPROM.write(EEPROM_SubnetIPAddress, '2'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 1, '5'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 2, '5'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 3, '.'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 4, '2'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 5, '5'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 6, '5'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 7, '.'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 8, '2'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 9, '5'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 10, '5'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 11, '.'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 12, '0'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 13, '0'); 
  EEPROM.write(EEPROM_SubnetIPAddress + 14, '0');  
  EEPROM.write(EEPROM_MQTT_Server,'M');
  EEPROM.write(EEPROM_MQTT_Server + 1,'Q');  
  EEPROM.write(EEPROM_MQTT_Server + 2,'T');  
  EEPROM.write(EEPROM_MQTT_Server + 3,'T');  
  EEPROM.write(EEPROM_MQTT_Server + 4,'-');  
  EEPROM.write(EEPROM_MQTT_Server + 5,'S');
  EEPROM.write(EEPROM_MQTT_Server + 6,'e');  
  EEPROM.write(EEPROM_MQTT_Server + 7,'r');  
  EEPROM.write(EEPROM_MQTT_Server + 8,'v');  
  EEPROM.write(EEPROM_MQTT_Server + 9,'e');  
  EEPROM.write(EEPROM_MQTT_Server + 10,'r');
  EEPROM.write(EEPROM_MQTT_Server + 11,255);
  EEPROM.write(EEPROM_MQTT_Server + 12,255);
  EEPROM.write(EEPROM_MQTT_Server + 13,255);
  EEPROM.write(EEPROM_MQTT_Server + 14,255);
  EEPROM.write(EEPROM_MQTT_Server + 15,255);
  EEPROM.write(EEPROM_MQTT_Server + 16,255);
  EEPROM.write(EEPROM_MQTT_Server + 17,255);
  EEPROM.write(EEPROM_MQTT_Server + 18,255);
  EEPROM.write(EEPROM_MQTT_Server + 19,255);
  
  EEPROM.write(EEPROM_RecipientHostName1,'H');
  EEPROM.write(EEPROM_RecipientHostName1 + 1,'o');  
  EEPROM.write(EEPROM_RecipientHostName1 + 2,'u');    
  EEPROM.write(EEPROM_RecipientHostName1 + 3,'s');    
  EEPROM.write(EEPROM_RecipientHostName1 + 4,'e');  
  EEPROM.write(EEPROM_RecipientHostName1 + 5,'N');    
  EEPROM.write(EEPROM_RecipientHostName1 + 6,'o');    
  EEPROM.write(EEPROM_RecipientHostName1 + 7,'d');  
  EEPROM.write(EEPROM_RecipientHostName1 + 8,'e');    
  EEPROM.write(EEPROM_RecipientHostName1 + 9,'1');   
  EEPROM.write(EEPROM_RecipientHostName1 + 10,255);  
  EEPROM.write(EEPROM_RecipientHostName1 + 11,255);    
  EEPROM.write(EEPROM_RecipientHostName1 + 12,255); 
  EEPROM.write(EEPROM_RecipientHostName1 + 13,255);
  EEPROM.write(EEPROM_RecipientHostName1 + 14,255);
  EEPROM.write(EEPROM_RecipientHostName1 + 12,255);
  EEPROM.write(EEPROM_RecipientHostName1 + 13,255);
  EEPROM.write(EEPROM_RecipientHostName1 + 14,255);
  EEPROM.write(EEPROM_RecipientHostName1 + 15,255);
  EEPROM.write(EEPROM_RecipientHostName1 + 16,255);
  EEPROM.write(EEPROM_RecipientHostName1 + 17,255);
  EEPROM.write(EEPROM_RecipientHostName1 + 18,255);
  EEPROM.write(EEPROM_RecipientHostName1 + 19,255); 

  EEPROM.write(EEPROM_RecipientHostName2,'H');
  EEPROM.write(EEPROM_RecipientHostName2 + 1,'o');  
  EEPROM.write(EEPROM_RecipientHostName2 + 2,'u');    
  EEPROM.write(EEPROM_RecipientHostName2 + 3,'s');    
  EEPROM.write(EEPROM_RecipientHostName2 + 4,'e');  
  EEPROM.write(EEPROM_RecipientHostName2 + 5,'N');    
  EEPROM.write(EEPROM_RecipientHostName2 + 6,'o');    
  EEPROM.write(EEPROM_RecipientHostName2 + 7,'d');  
  EEPROM.write(EEPROM_RecipientHostName2 + 8,'e');    
  EEPROM.write(EEPROM_RecipientHostName2 + 9,'2');   
  EEPROM.write(EEPROM_RecipientHostName2 + 10,255);  
  EEPROM.write(EEPROM_RecipientHostName2 + 11,255);    
  EEPROM.write(EEPROM_RecipientHostName2 + 12,255); 
  EEPROM.write(EEPROM_RecipientHostName2 + 13,255);
  EEPROM.write(EEPROM_RecipientHostName2 + 14,255);
  EEPROM.write(EEPROM_RecipientHostName2 + 12,255);
  EEPROM.write(EEPROM_RecipientHostName2 + 13,255);
  EEPROM.write(EEPROM_RecipientHostName2 + 14,255);
  EEPROM.write(EEPROM_RecipientHostName2 + 15,255);
  EEPROM.write(EEPROM_RecipientHostName2 + 16,255);
  EEPROM.write(EEPROM_RecipientHostName2 + 17,255);
  EEPROM.write(EEPROM_RecipientHostName2 + 18,255);
  EEPROM.write(EEPROM_RecipientHostName2 + 19,255); 

  EEPROM.write(EEPROM_RecipientHostName3,'H');
  EEPROM.write(EEPROM_RecipientHostName3 + 1,'o');  
  EEPROM.write(EEPROM_RecipientHostName3 + 2,'u');    
  EEPROM.write(EEPROM_RecipientHostName3 + 3,'s');    
  EEPROM.write(EEPROM_RecipientHostName3 + 4,'e');  
  EEPROM.write(EEPROM_RecipientHostName3 + 5,'N');    
  EEPROM.write(EEPROM_RecipientHostName3 + 6,'o');    
  EEPROM.write(EEPROM_RecipientHostName3 + 7,'d');  
  EEPROM.write(EEPROM_RecipientHostName3 + 8,'e');    
  EEPROM.write(EEPROM_RecipientHostName3 + 9,'3');   
  EEPROM.write(EEPROM_RecipientHostName3 + 10,255);  
  EEPROM.write(EEPROM_RecipientHostName3 + 11,255);    
  EEPROM.write(EEPROM_RecipientHostName3 + 12,255); 
  EEPROM.write(EEPROM_RecipientHostName3 + 13,255);
  EEPROM.write(EEPROM_RecipientHostName3 + 14,255);
  EEPROM.write(EEPROM_RecipientHostName3 + 12,255);
  EEPROM.write(EEPROM_RecipientHostName3 + 13,255);
  EEPROM.write(EEPROM_RecipientHostName3 + 14,255);
  EEPROM.write(EEPROM_RecipientHostName3 + 15,255);
  EEPROM.write(EEPROM_RecipientHostName3 + 16,255);
  EEPROM.write(EEPROM_RecipientHostName3 + 17,255);
  EEPROM.write(EEPROM_RecipientHostName3 + 18,255);
  EEPROM.write(EEPROM_RecipientHostName3 + 19,255); 

  EEPROM.write(EEPROM_RecipientHostName4,'H');
  EEPROM.write(EEPROM_RecipientHostName4 + 1,'o');  
  EEPROM.write(EEPROM_RecipientHostName4 + 2,'u');    
  EEPROM.write(EEPROM_RecipientHostName4 + 3,'s');    
  EEPROM.write(EEPROM_RecipientHostName4 + 4,'e');  
  EEPROM.write(EEPROM_RecipientHostName4 + 5,'N');    
  EEPROM.write(EEPROM_RecipientHostName4 + 6,'o');    
  EEPROM.write(EEPROM_RecipientHostName4 + 7,'d');  
  EEPROM.write(EEPROM_RecipientHostName4 + 8,'e');    
  EEPROM.write(EEPROM_RecipientHostName4 + 9,'4');   
  EEPROM.write(EEPROM_RecipientHostName4 + 10,255);  
  EEPROM.write(EEPROM_RecipientHostName4 + 11,255);    
  EEPROM.write(EEPROM_RecipientHostName4 + 12,255); 
  EEPROM.write(EEPROM_RecipientHostName4 + 13,255);
  EEPROM.write(EEPROM_RecipientHostName4 + 14,255);
  EEPROM.write(EEPROM_RecipientHostName4 + 12,255);
  EEPROM.write(EEPROM_RecipientHostName4 + 13,255);
  EEPROM.write(EEPROM_RecipientHostName4 + 14,255);
  EEPROM.write(EEPROM_RecipientHostName4 + 15,255);
  EEPROM.write(EEPROM_RecipientHostName4 + 16,255);
  EEPROM.write(EEPROM_RecipientHostName4 + 17,255);
  EEPROM.write(EEPROM_RecipientHostName4 + 18,255);
  EEPROM.write(EEPROM_RecipientHostName4 + 19,255); 

  EEPROM.write(EEPROM_RecipientHostName5,'H');
  EEPROM.write(EEPROM_RecipientHostName5 + 1,'o');  
  EEPROM.write(EEPROM_RecipientHostName5 + 2,'u');    
  EEPROM.write(EEPROM_RecipientHostName5 + 3,'s');    
  EEPROM.write(EEPROM_RecipientHostName5 + 4,'e');  
  EEPROM.write(EEPROM_RecipientHostName5 + 5,'N');    
  EEPROM.write(EEPROM_RecipientHostName5 + 6,'o');    
  EEPROM.write(EEPROM_RecipientHostName5 + 7,'d');  
  EEPROM.write(EEPROM_RecipientHostName5 + 8,'e');    
  EEPROM.write(EEPROM_RecipientHostName5 + 9,'5');   
  EEPROM.write(EEPROM_RecipientHostName5 + 10,255);  
  EEPROM.write(EEPROM_RecipientHostName5 + 11,255);    
  EEPROM.write(EEPROM_RecipientHostName5 + 12,255); 
  EEPROM.write(EEPROM_RecipientHostName5 + 13,255);
  EEPROM.write(EEPROM_RecipientHostName5 + 14,255);
  EEPROM.write(EEPROM_RecipientHostName5 + 12,255);
  EEPROM.write(EEPROM_RecipientHostName5 + 13,255);
  EEPROM.write(EEPROM_RecipientHostName5 + 14,255);
  EEPROM.write(EEPROM_RecipientHostName5 + 15,255);
  EEPROM.write(EEPROM_RecipientHostName5 + 16,255);
  EEPROM.write(EEPROM_RecipientHostName5 + 17,255);
  EEPROM.write(EEPROM_RecipientHostName5 + 18,255);
  EEPROM.write(EEPROM_RecipientHostName5 + 19,255); 
  
  EEPROM.write(EEPROM_RemoteDataSendEnable1,0);
  EEPROM.write(EEPROM_RemoteDataSendEnable2,0);
  EEPROM.write(EEPROM_RemoteDataSendEnable3,0);
  EEPROM.write(EEPROM_RemoteDataSendEnable4,0);
  EEPROM.write(EEPROM_RemoteDataSendEnable5,0);
  EEPROM.write (EEPROM_AP_Password,'p');      // AP default password = password
  EEPROM.write (EEPROM_AP_Password+1,'a'); 
  EEPROM.write (EEPROM_AP_Password+2,'s'); 
  EEPROM.write (EEPROM_AP_Password+3,'s'); 
  EEPROM.write (EEPROM_AP_Password+4,'w'); 
  EEPROM.write (EEPROM_AP_Password+5,'o'); 
  EEPROM.write (EEPROM_AP_Password+6,'r'); 
  EEPROM.write (EEPROM_AP_Password+7,'d');   
  EEPROM.commit();
  if(EnableMessages) Serial.println(F("WiFi/MQTT EEPROM reset to default values"));
}  // end of void ResetWiFi_EEPROM()
// ---------------------------------------------------------
void Download_WiFi_Login_Details_From_EEPROM(boolean Display)   // Download to memory, the EEPROM stored values of SSID and password
{
    unsigned int i = EEPROM_WiFi_SSID;
    esid = "";  //start with empty string
    while (i < EEPROM_WiFi_SSID + MaxStringLength)  // build up string from stored characters that are not FF
    {
      if (EEPROM.read(i) != 255) 
      {
      esid += char (EEPROM.read(i)); 
      } else break;
      i++; 
    }
    i = EEPROM_StaticIPAddress;
    StaticIPAddress = "";   //start with empty string
    while (i < EEPROM_StaticIPAddress + 15) // build up string from stored characters that are not FF
    {
      if (EEPROM.read(i) != 255) 
      {
      StaticIPAddress += char(EEPROM.read(i)); 
      } else break; 
      i++;
    }    
    i = EEPROM_GatewayIPAddress;
    GatewayIPAddress = "";   //start with empty string
    while (i < EEPROM_GatewayIPAddress + 15) // build up string from stored characters that are not FF
    {
      if (EEPROM.read(i) != 255) 
      {
      GatewayIPAddress += char(EEPROM.read(i)); 
      } else break; 
      i++;
    }      
    i = EEPROM_SubnetIPAddress;
    SubnetIPAddress = "";   //start with empty string
    while (i < EEPROM_SubnetIPAddress + 15) // build up string from stored characters that are not FF
    {
      if (EEPROM.read(i) != 255) 
      {
      SubnetIPAddress += char(EEPROM.read(i)); 
      } else break; 
      i++;
    }    
    i = EEPROM_WiFi_Password;
    epass = "";   //start with empty password string
    while (i < EEPROM_WiFi_Password + MaxStringLength) // build up password string from stored characters that are not FF
    {
      if (EEPROM.read(i) != 255) 
      {
      epass += char(EEPROM.read(i)); 
      } else break; 
      i++;
    }
    i = EEPROM_HostName;
    HostName = "";   //start with empty password string
    while (i < EEPROM_HostName + MaxStringLength) // build up password string from stored characters that are not FF
    {
      if (EEPROM.read(i) != 255) 
      {
      HostName += char(EEPROM.read(i)); 
      } else break; 
      i++;
    }
    ArduinoOTA.setHostname(HostName.c_str());
    i = EEPROM_AP_Password;
    passphrase = "";   //start with empty password string
    while (i < EEPROM_AP_Password + MaxStringLength) // build up password string from stored characters that are not FF
    {
      if (EEPROM.read(i) != 255) 
      {
      passphrase += char(EEPROM.read(i)); 
      } else break; 
      i++;
    } 
    if (Display)
    {
      Serial.println(""); 
      Serial.print(F("EEPROM SSID: ")); 
      Serial.println(esid); // print final SSID string - diagnostic
      Serial.print(F("EEPROM Password: ")); 
      Serial.println(epass);  // print final Password string - diagnostic
      Serial.print(F("EEPROM HostName: ")); 
      Serial.println(HostName);  // print final HostName string - diagnostic
      Serial.print(F("EEPROM Access Point Password: ")); 
      Serial.println(passphrase);     
      Serial.println("");
    }    
}   // end of void Download_WiFi_Login_Details_From_EEPROM()
// ------------------------------------------------------------
void DownloadMQTT_detailsFromEEPROM(boolean Print)
{   
    byte i = 0;
    MQTT_Server = "";   //start with empty string
    while (i < MaxStringLength) // build up string from stored characters that are not FF
    {
      if (EEPROM.read(EEPROM_MQTT_Server + i) != 255) 
             MQTT_Server += char(EEPROM.read(EEPROM_MQTT_Server + i)); 
      else break; 
      i++;
    }
    if(Print) 
    {
      Serial.print(F("MQTT_Server ")); 
      Serial.println(MQTT_Server);  
    }
    
    i = 0;
    RecipientHostName[0] = "";   //start with empty string
    while (i < MaxStringLength) // build up string from stored characters that are not FF
    {
      if (EEPROM.read(EEPROM_RecipientHostName1 + i) != 255) 
             RecipientHostName[0] += char(EEPROM.read(EEPROM_RecipientHostName1 + i)); 
      else break; 
      i++;
    }
    if(Print) 
    {
      Serial.print(F("RecipientHostName[0] ")); 
      Serial.println(RecipientHostName[0]);  
    }
    
    i = 0;
    RecipientHostName[1] = "";   //start with empty string
    while (i < MaxStringLength) // build up string from stored characters that are not FF
    {
      if (EEPROM.read(EEPROM_RecipientHostName2 + i) != 255) 
             RecipientHostName[1] += char(EEPROM.read(EEPROM_RecipientHostName2 + i)); 
      else break; 
      i++;
    }
    if(Print) 
    {
      Serial.print(F("RecipientHostName[1] ")); 
      Serial.println(RecipientHostName[1]);       
    }
    
    i = 0;
    RecipientHostName[2] = "";   //start with empty string
    while (i < MaxStringLength) // build up string from stored characters that are not FF
    {
      if (EEPROM.read(EEPROM_RecipientHostName3 + i) != 255) 
             RecipientHostName[2] += char(EEPROM.read(EEPROM_RecipientHostName3 + i)); 
      else break; 
      i++;
    }
    if(Print) 
    {
      Serial.print(F("RecipientHostName[2] ")); 
      Serial.println(RecipientHostName[2]);      
    }
    
    i = 0;
    RecipientHostName[3] = "";   //start with empty string
    while (i < MaxStringLength) // build up string from stored characters that are not FF
    {
      if (EEPROM.read(EEPROM_RecipientHostName4 + i) != 255) 
             RecipientHostName[3] += char(EEPROM.read(EEPROM_RecipientHostName4 + i)); 
      else break; 
      i++;
    }
    if(Print) 
    {
      Serial.print(F("RecipientHostName[3] ")); 
      Serial.println(RecipientHostName[3]);      
    }
    
    i = 0;
    RecipientHostName[4] = "";   //start with empty string
    while (i < MaxStringLength) // build up string from stored characters that are not FF
    {
      if (EEPROM.read(EEPROM_RecipientHostName5 + i) != 255) 
             RecipientHostName[4] += char(EEPROM.read(EEPROM_RecipientHostName5 + i)); 
      else break; 
      i++;
    }
    if(Print) 
    {
      Serial.print(F("RecipientHostName[4] ")); 
      Serial.println(RecipientHostName[4]);      
    }
      
    MQTT_PushInterval = EEPROM.read(EEPROM_MQTT_PushInterval) * 1000; 
    if(Print) 
    {
      Serial.print(F("MQTT_PushInterval ")); 
      Serial.println(MQTT_PushInterval);     
    }
    i = 0;
    while (i < 6)
    {
      PIR_TimerInterval[i] = EEPROM.read(EEPROM_PIR_TimerInterval+i);
      i ++;
    }
    i = 0;
    while (i < sizeof(RemoteDataSendEnable))
    {
      RemoteDataSendEnable[i] = EEPROM.read(EEPROM_RemoteDataSendEnable1 + i);
      if(Print)
      {
        Serial.print(F("RemoteDataSendEnable"));
        Serial.print(i+1);
        Serial.print(F(" = ")); 
        Serial.println(RemoteDataSendEnable[i]);          
      }
      i++;
    }
    i = 0;
    while (i < 6)
    {
      PIR_AssignedRelay[i] = EEPROM.read(EEPROM_PIR_AssignedRelay + i);
      PIR_Action[i] = EEPROM.read(EEPROM_PIR_Action + i);
      if(Print)
      {
        Serial.print(F("PIR "));
        Serial.print(i+1);
        Serial.print(F(" is linked to relay ")); 
        Serial.print(PIR_AssignedRelay[i]);
        Serial.print(F(" Action = ")); 
        Serial.println(PIR_Action[i]);           
      }
      i++;
    }      
} // end of void DownloadMQTT_detailsFromEEPROM()
// -----------------------------------------------------------
void Display_WiFi_Connection_Status()  // display the status of the current WiFi connection
{
    Serial.println(""); 
               // print out to serial monitor, the connected network details 
    Serial.print(F("Device name: "));
    Serial.println(HostName);
    Serial.print(F("SSID: "));      // SSID
    Serial.println(WiFi.SSID());                         
    long rssi = WiFi.RSSI();        // print the received signal strength:
    Serial.print(F("signal strength (RSSI):"));
    Serial.println(rssi);              
    IPAddress ip = WiFi.localIP();
    Serial.print(F("IP Address: ")); // IP address given to the connection
    Serial.println(ip);
    Serial.print(F("MAC address: "));
    Serial.println(WiFi.macAddress());
    IPAddress subnet = WiFi.subnetMask();   // Subnet mask
    Serial.print(F("NetMask: "));
    Serial.println(subnet);  
    IPAddress gateway = WiFi.gatewayIP();   // Gateway address
    Serial.print(F("Gateway: "));
    Serial.println(gateway);
    Serial.println("");    
  }  // end of void Display_WiFi_Connection_status

// ---------------------- WIFI --------------------------------------
void WifiConnect()     // Connect to the wifi network using the stored credentials
{        
   byte Login_Wait_Timer = 0;    // no of loops waiting for log in success
   LoginSuccessful = true;
   if(RouterMode == DHCP)
   {
      WiFi.mode(WIFI_STA);             // Set WIFI module to STA mode
      Serial.println(); 
      Serial.println(F("Connecting to WiFi"));
      WiFi.begin(esid.c_str(), epass.c_str());  
      WiFi.hostname(HostName.c_str());  
   }  // end of if(RouterMode == DHCP)
   else     //Static IP address configuration
   { 
      IPAddress staticIP = StringToIP(StaticIPAddress);  // Static IP Address for router
      IPAddress gateway = StringToIP(GatewayIPAddress);   //IP Address of your WiFi Router (Gateway)
      IPAddress subnet = StringToIP(SubnetIPAddress);  //Subnet mask
      //IPAddress dns(10,0,0,254);  //DNS      
      WiFi.disconnect();  //Prevent connecting to wifi based on previous configuration
      WiFi.hostname(HostName.c_str());  
      WiFi.config(staticIP,gateway,subnet); //,dns);  
      WiFi.begin(esid.c_str(), epass.c_str()); 
      WiFi.mode(WIFI_STA);
   }  // end of else
// ------------------------------------------------   
   while (WiFi.status() != WL_CONNECTED) 
   {                 // wait for connection whilst flashing the heartbeat LED
     Check_For_Keyboard_Command();  // check for any keyboard command     
     digitalWrite(Heartbeat_LED,LED_On);    // flash the Heartbeat LED
     delay(LED_OnTimer);
     Serial.print(".");
     digitalWrite(Heartbeat_LED,LED_Off);
     delay(LED_OffTimer );   
     Login_Wait_Timer ++;
     if ( Login_Wait_Timer >= 100)  // login failed after 100 loops
     {
        LoginSuccessful = false;
        Soft_AP_Switch = true;      // enable Access point to allow set up check
        AutoResetTimer = AutoResetTimeout;
        AutoResetTimerEnable = true;  // Connection failed, start timer, timeout = auto reset
        break;
     }         
   }  // end of while (WiFi.status() != WL_CONNECTED) 
   if(LoginSuccessful) 
   { 
      Serial.println("");
      Serial.println(F(" Connected to Network"));
      Display_WiFi_Connection_Status();               
   }  // end of if(LoginSuccessful)
   else
   {   
      if (EnableMessages)
      {
          Serial.println(); 
          Serial.println(F("Login failed"));
      }
   } // end of else      
   LED_OnTimer = LED_OnFlash ;    // Connected to network so reset the LED flash timers for the main loop
   LED_OffTimer = LED_OffFlash; 
 } // end of void WifiConnect()
// -------------------------------------------------------------------
IPAddress StringToIP(String IP_Address)
{
    IPAddress StaticIP;
    byte pointer1 = IP_Address.indexOf('.');  // build up static IP address
    byte pointer2;                                 // from the stored address
    String Temp;
    Temp = IP_Address.substring(0,pointer1);
    StaticIP[0] = Temp.toInt();
    pointer2 = IP_Address.indexOf('.', pointer1 + 1) ;
    Temp = IP_Address.substring(pointer1+1,pointer2);
    StaticIP[1] = Temp.toInt();         
    pointer1 = pointer2;
    pointer2 = IP_Address.lastIndexOf('.') ;
    Temp = IP_Address.substring(pointer1+1,pointer2);
    StaticIP[2] = Temp.toInt();          
    Temp = IP_Address.substring(pointer2+1);
    StaticIP[3] = Temp.toInt(); 
    return StaticIP;
}  // end of IPAddress StringToIP(String IP_Address)
// ----------------------- NTP functions ---------------------------------------
// send an NTP request to the time server at the given address
unsigned long sendNTPpacket(IPAddress& address)
{       // set all bytes in the buffer to 0
  memset(packetBuffer2, 0, NTP_PACKET_SIZE);
            // Initialize values needed to form NTP request
  packetBuffer2[0] = 0b11100011;   // LI, Version, Mode
  packetBuffer2[1] = 0;     // Stratum, or type of clock
  packetBuffer2[2] = 6;     // Polling Interval
  packetBuffer2[3] = 0xEC;  // Peer Clock Precision
                            // 8 bytes of zero for Root Delay & Root Dispersion
  packetBuffer2[12]  = 49;
  packetBuffer2[13]  = 0x4E;
  packetBuffer2[14]  = 49;
  packetBuffer2[15]  = 52;
                            // you can send a packet requesting a timestamp:
  udp.beginPacket(address, 123); //NTP requests are to port 123
  udp.write(packetBuffer2, NTP_PACKET_SIZE);
  udp.endPacket();
} // end of unsigned long sendNTPpacket(IPAddress& address)
    // ---------------------------------------------------
void Interval_Update_Clock() // update the soft clock with the NTP clock data
{
   unsigned long NTPTimer = millis() - NTP_Timer;
   if (NTPTimer >= NTP_TimeInterval)   // only do this at defined intervals
   {
     NTP_Timer = millis();
     Get_Clock_Data();   // get latest time via NTP and if valid, update soft clock
   }
}   //end of  Interval_Update_Clock()
    // ---------------------------------------------------
void Get_Clock_Data() // update the soft clock with the NTP clock data
{                        // Returns false if NTP fails
    unsigned long Raw_Time = Get_NTP_Time();  // get the NTP time
    if ( Raw_Time > 1512259200L) // check for validity against a random     
    {                            // already passed date - 12AM 3rd December                      
      ClockHour = byte((Raw_Time % 86400L) / 3600);   // Update the soft clock with NTP data
      if (ClockHour >= 24) ClockHour = ClockHour -24;  // correct for day overflow in time zone correction calculation
      Last_NTP_Hour = ClockHour;  // Store for diagnostic page
      ClockMinute = byte((Raw_Time % 3600) / 60);
      Last_NTP_Minute = ClockMinute;  // Store for diagnostic page
      ClockWeekDay = byte(((Raw_Time % 604800L) / 86400)); 
      if (ClockWeekDay < 3) ClockWeekDay = ClockWeekDay + 5;
      else  ClockWeekDay = ClockWeekDay - 2;      // correct for week day offset
      Last_NTP_Day = ClockWeekDay;  // Store for diagnostic page
      NTP_TimeInterval = 10680000; // set next timed update for 2 hour, 58 minutes 
      NTP_Resolved = true;  
      if (EnableMessages) 
      {
          Serial.println(""); Serial.print(F("NTP successful @ ")); 
      }
      LongClockMinute = ClockMinute + (ClockHour * 60);   // calc & save updated time value in minutes        
    }   // end of if ( Raw_Time > 1512259200L) // check for validity against a random ...
    else    // clock data was invalid so set reduced interval timer for
    {       // another attempt at NTP
      NTP_TimeInterval = 10000;  
      NTP_Resolved = false;
      if (EnableMessages) 
      {
          Serial.println(""); Serial.print(F("NTP Failed @ ")); 
      }
     }   // end of else    // clock data was invalid so set reduced ....
     Print_Clock();   // print the current NTP time
}   // end of Get_Clock_data
    // ---------------------------------------------------
void Print_Clock()
{
      Serial.print(ClockHour); // print the hour
      Serial.print(':');
      if (ClockMinute < 10 ) Serial.print('0');
      Serial.print(ClockMinute); // print the minute 
      Serial.print(F("    Week day: ")); Serial.println(ClockWeekDay);          
} // end of void Print_Clock()
    // --------------------------------------------------------------------     
time_t Get_NTP_Time()   // request timestamp from NTP server. returns 0 if fail
{
    while (udp.parsePacket() > 0) ; // discard any previously received packets    
    udp.begin(localPort_NTP);   
    sendNTPpacket(timeServer); // send an NTP packet to a time server   
    // wait to see if a reply is available
    byte NTP_WaitTimer = 0;
    boolean cb = false;
    unsigned long epoch = 0;
    while (NTP_WaitTimer < NTP_WaitTime && !cb)  // wait upto 1 second for NTP server to respond
    {
      digitalWrite(Heartbeat_LED,LED_On);  // keep HW watchdog alive
      delay(5);
      cb = udp.parsePacket();
      NTP_WaitTimer ++;
      digitalWrite(Heartbeat_LED,LED_Off);
      NTP_Timeout = false;       
      delay(5);
    }
    if (NTP_WaitTimer >= NTP_WaitTime) // check to see if wait timer timed out
    {         // time out - attempt failed so set timer update interval to 15 seconds for next attempt
      NTP_Timeout = true; 
      return epoch; // nothing received back
    }
    else // data was received so read data
    {
      udp.read(packetBuffer2, NTP_PACKET_SIZE); // read the packet into the buffer
      unsigned long highWord = word(packetBuffer2[40], packetBuffer2[41]);
      unsigned long lowWord = word(packetBuffer2[42], packetBuffer2[43]);
      unsigned long secsSince1900 = highWord << 16 | lowWord;
      const unsigned long seventyYears = 2208988800UL;
      epoch = secsSince1900 - seventyYears;    // UTC time seconds
      epoch = epoch + (TimeZone*3600);  // adjust epoch for timezone difference      
      return epoch;
    }  // end of else   
    udp.stop();   
}   // end of void Get_NTP_Time()
// ------------------------------------------------------------
byte GetKeyboardInput()    // get data string from keyboard - max 20 characters, terminator = carriage return
{                                           
   byte pointer = 0;      // flush keyboard buffer
   while(pointer < 20)
   {
    KeyboardBuffer[pointer] = 255;
    pointer ++;
   }
   while (Serial.available() > 0) {byte Trash = Serial.read();}   // flush out any trash data
   while (Serial.available() == false) Heartbeat_Tick();  // pause for keyboard input & flash 
                                                          // the Heartbeat LED to keep the watchdog alive   
   char ch;
   pointer = 0;
   while (Serial.available()>0)   //For each character entered
   {
     ch = Serial.read();
     if (pointer < MaxStringLength && byte(ch) != 13)    
     {
       KeyboardBuffer[pointer] = ch;  // save to keyboard buffer
       pointer ++; 
     }
   }  // end of    while (Serial.available()>0)   //For each character entered
   return pointer;
}  // end of void GetKeyboardInput
// ------------------------------------------------------------
void Setup_New_WiFi_Login_Values()  // Set up new WiFi login - SSID, Password & Host Name
{
  Serial.println(""); Serial.println(F("Enter new SSID - 20 chars max"));
   
  byte Length = GetKeyboardInput() ;   // get input from keyboard, length = number of characters used 
  unsigned int i=EEPROM_WiFi_SSID;
  if (Length >= 8 && Length < 21)  // if entry is > minimum & less than the max no of characters 
  {
    while(i < EEPROM_WiFi_SSID + MaxStringLength)  // Clear out all of the previous stored entriesfor SSID
    {
      EEPROM.write(i, 255);
      i++;
    }
    Serial.print(F("New WiFi SSID = "));
    i=0;
    while(i < Length)   // store new SSID to EEPROM
    {
      EEPROM.write(EEPROM_WiFi_SSID + i, KeyboardBuffer[i]);
      Serial.print(char(EEPROM.read(EEPROM_WiFi_SSID + i))); 
      i++;
    }
  } // end of if (Length >= 8 && Length < 21)  // if entry is > minimum & less than the max no of characters
  else
  Serial.println(F("Invalid - WiFi SSID not changed"));   
  Serial.println("");
    
  Serial.println(F("Enter WiFi Password - 8 chars min, 20 chars max"));
  Length = GetKeyboardInput() ;   // get input from keyboard & how many characters entered   
  if(Length >= 8 && Length < 21)  // if entry is > minimum & less than the max no of characters 
  {   
    i = EEPROM_WiFi_Password;
    while(i < (EEPROM_WiFi_Password + MaxStringLength))
    {
      EEPROM.write(i, 255); // Clear out all of the previous stored entries for password
      i++;
    }
    Serial.print(F("WiFi Password = "));     
    i = 0; 
    while(i < Length)  // store new password to EEPROM
    {
      EEPROM.write(EEPROM_WiFi_Password + i, KeyboardBuffer[i]);
      Serial.print(char(EEPROM.read(EEPROM_WiFi_Password + i))); 
      i++;
    }
  } // end of if(Length >= 8 && Length < 21)  // if entry is > minimum & less than the max no of characters
  else
  Serial.println(F("Invalid - WiFi password not changed"));
  Serial.println("");
  
  Serial.println(F("Enter Device Name - 4 chars min, 20 chars max"));
  Length = GetKeyboardInput() ;   // get input from keyboard  & how many characters entered      
  i = EEPROM_HostName;
  if (Length >= 4 && Length  < 21)  // if entry is > minimum & less than the max no of characters
  {
    while(i < (EEPROM_HostName + MaxStringLength))
    {
      EEPROM.write(i, 255); // Clear out all of the previous stored entries
      i++;
    }
    Serial.print(F("Device Name = "));     
    i = 0; 
    while(i < Length)  // store new password to EEPROM
    {
      EEPROM.write(EEPROM_HostName + i, KeyboardBuffer[i]);
      Serial.print(char(EEPROM.read(EEPROM_HostName + i))); // ------------------
      i++;
    }
    Serial.println("");
  }   // end of  if (Length >= 4)  // if entry is > minimum no of characters
  else
  Serial.println(F("Invalid - Device Name not changed"));
  EEPROM.commit();   // update EEPROM   
  Download_WiFi_Login_Details_From_EEPROM(true); 
}  // end of  void Setup_New_WiFi_Login_Values()  
 // ---------------------------------------------------------------------------
void Setup_AP_Password()
{  
  Serial.println(F("Enter Configuration Access Point Password - 8 chars min, 20 chars max"));
  byte Length = GetKeyboardInput() ;   // get input from keyboard & how many characters entered   
  byte i = 0;
  if (Length >= 8 && Length < 21)  // if entry is > minimum & less than the max no of characters
  {
    while(i < MaxStringLength)
    {
      EEPROM.write(EEPROM_AP_Password + i, 255); // Clear out all of the previous stored entries
      i++;
    }
    Serial.print(F("New Access Point Password = "));     
    i = 0; 
    while(i < Length)  // store new password to EEPROM
    {
      EEPROM.write(EEPROM_AP_Password + i, KeyboardBuffer[i]);
      Serial.print(char(EEPROM.read(EEPROM_AP_Password + i))); 
      i++;
    }
    Serial.println("");
    EEPROM.commit();   // update EEPROM   
    Download_WiFi_Login_Details_From_EEPROM(true);  
  }  // end of   if (Length >= 8)  // if entry is > minimum no of characters
  else
  Serial.println(F("Invalid number of characters (min 8, max 20 required"));
}  // end of void Setup_AP_Password()
 // ---------------------------------------------------------------------------
void Check_Time_Control_Relay1()  
{
   const byte Relay1 = 0;
  // ---------------------------------- Timer 1 start --------------------------------------------
          // only if relay timer is enabled AND clock is valid (weekday not = 0) AND timer 1 not previously active  
   if(TimerEnable[Relay1][Timer1] && ClockWeekDay != 0 && TimerActive[Relay1][Timer1] == false)  
   {
     if (Relay1TimeControlDayFlags[Timer1][ClockWeekDay-1]) 
     {    // The clock day is enabled for timer control so check the clock against the timer settings
          if (LongClockMinute >= LongTimer_ON[Relay1][Timer1] && LongClockMinute < LongTimer_OFF[Relay1][Timer1])
          {  // if clock is inbetween the ON & OFF setpoints then the timer ON should be initiated
             Activate_Relay(Relay1, SwitchOn,false);   // Switch relay 1 ON, disable output timer 
             RelayOnTimer[Relay1] =  LongTimer_OFF[Relay1][Timer1] -  LongClockMinute; // set relay ON timer  
             if (EnableMessages)
             {
               Serial.println(F("Relay 1 Timer 1 Start"));
               Print_Clock();
             }
             TimerActive[Relay1][Timer1] = true;    // set relay 1 timer 1 active flag                                
          }   // end of if (LongClockMinute >= LongTimer_ON[Relay1][Timer1] && LongClockMinute < LongTimer_OFF[Relay1][Timer1])     
     }  // end of if (Relay1TimeControlDayFlags[Timer1][ClockWeekDay-1])
   } // end of if(TimerEnable[Relay1] && ClockWeekDay != 0 && TimerActive[Relay1][Timer1] == false)  
    // ---------------------------------------------------------------------
  if(CheckForCombinedTimersRelay1() == false)   // only if timers are not combined into 1
  {  
      // ------------------------- Timer 2 start -------------------------------------- 
      // only if relay timer is enabled AND clock is valid (weekday not = 0) AND timer 2 not previously active      
      if(TimerEnable[Relay1][Timer2] && ClockWeekDay != 0 && TimerActive[Relay1][Timer2] == false)  
      {    
        if (Relay1TimeControlDayFlags[Timer2][ClockWeekDay-1]) 
        {    // The clock day is enabled for timer control so check the clock against the timer settings
            if (LongClockMinute >= LongTimer_ON[Relay1][Timer2] && LongClockMinute < LongTimer_OFF[Relay1][Timer2])
            {  // if clock is inbetween the ON & OFF setpoints then the timer ON should be initiated
              Activate_Relay(Relay1, SwitchOn,false);   // Switch relay 1 ON, disable output timer 
              RelayOnTimer[Relay1] =  LongTimer_OFF[Relay1][Timer2] -  LongClockMinute; // set relay ON timer 
              if (EnableMessages)
              {
                Serial.println(F("Relay 1 Timer 2 Started"));
                Print_Clock();
              }
              TimerActive[Relay1][Timer2] = true;    // set relay 1 timer 2 active flag          
            } // end of if (LongClockMinute >= LongTimer_ON[Relay1][Timer2] && LongClockMinute < LongTimer_OFF[Relay1][Timer1])  
      }       // end of if (Relay1TimeControlDayFlags[Timer2][ClockWeekDay-1]) 
    }         // if(TimerEnable[Relay1][Timer2] && ClockWeekDay != 0 && TimerActive[Relay1][Timer2] == false) 
    // *************************** At the end of timer 1 period ***********************
    if (Relay1TimeControlDayFlags[Timer1][ClockWeekDay-1] && TimerActive[Relay1][Timer1] == true) 
    {    // The timer has been running & the clock day is enabled so reset Timer Active flag if the clock is > setpoint OFF and before midnight 
        if (LongClockMinute >= LongTimer_OFF[Relay1][Timer1] && LongClockMinute <= 1439)
        {
          TimerActive[Relay1][Timer1] = false;
          Activate_Relay(Relay1, SwitchOff,false);   // Switch relay 1 OFF, disable output timer  
          if (EnableMessages)
          {
            Serial.println(F("Relay 1 Timer 1 Stopped"));
            Print_Clock();
          }           
        }  // end of if (LongClockMinute >= LongTimer_OFF[Relay1][Timer1] && LongClockMinute <= 1439)
    }      // end of if (Relay1TimeControlDayFlags[Timer1][ClockWeekDay-1]) 
  }        // end of if(CheckForCombinedTimersRelay1() == false) 
 // *************************** At the end of timer 2 period *********************** 
 if (Relay1TimeControlDayFlags[Timer2][ClockWeekDay-1] && TimerActive[Relay1][Timer2] == true)
 {  // The clock day is enabled so reset Timer Active flag if the clock is > setpoint OFF and before midnight 
    if (LongClockMinute >= LongTimer_OFF[Relay1][Timer2] && LongClockMinute <= 1439) 
    {
      TimerActive[Relay1][Timer2] = false;
      Activate_Relay(Relay1, SwitchOff,false);   // Switch relay 1 OFF, disable output timer   
      if (EnableMessages)
      {
        Serial.println(F("Relay 1 Timer 2 Stopped"));
        Print_Clock();
      }          
    }  // end of if (LongClockMinute >= LongTimer_OFF[Relay1][Timer2] && LongClockMinute <= 1439)
 }  // end of if (Relay1TimeControlDayFlags[Timer2][ClockWeekDay-1])
}   // end of void Check_Time_Control_Relay1() 
 // ---------------------------------------------------------------------------
void Check_Time_Control_Relay2()  
{ 
   const byte Relay2 = 1;
  // ---------------------------------- Timer 1 start -------------------------------------
          // only if relay timer is enabled AND clock is valid (weekday not = 0) AND timer 1 not previously active  
   if(TimerEnable[Relay2][Timer1] && ClockWeekDay != 0 && TimerActive[Relay2][Timer1] == false)  
   {
     if (Relay2TimeControlDayFlags[Timer1][ClockWeekDay-1]) 
     {    // The clock day is enabled for timer control so check the clock against the timer settings
          if (LongClockMinute >= LongTimer_ON[Relay2][Timer1] && LongClockMinute < LongTimer_OFF[Relay2][Timer1])
          {  // if clock is inbetween the ON & OFF setpoints then the timer ON should be initiated
             Activate_Relay(Relay2, SwitchOn,false);   // Switch relay 1 ON, disable output timer 
             RelayOnTimer[Relay2] =  LongTimer_OFF[Relay2][Timer1] -  LongClockMinute; // set relay ON timer  
             if (EnableMessages)
             {
               Serial.println(F("Relay 2 Timer 1 Started"));
               Print_Clock();
             }
             TimerActive[Relay2][Timer1] = true;    // set relay 1 timer 1 active flag                                
          }   // end of if (LongClockMinute >= LongTimer_ON[Relay2][Timer1] && LongClockMinute < LongTimer_OFF[Relay2][Timer1])     
     }  // end of if (Relay2TimeControlDayFlags[Timer1][ClockWeekDay-1])
   } // end of if(TimerEnable[Relay2][Timer1] && ClockWeekDay != 0 && TimerActive[Relay2][Timer1] == false)  
   // ---------------------------------------------------------------------------------------
   if(CheckForCombinedTimersRelay2() == false)  // only if timers are not combined into 1
   {   
              // ------------------------- Timer 2 start --------------------------------------- 
              // only if relay timer is enabled AND clock is valid (weekday not = 0) AND timer 2 not previously active  
      if(TimerEnable[Relay2][Timer2] && ClockWeekDay != 0 && TimerActive[Relay2][Timer2] == false)  
      {    
        if (Relay2TimeControlDayFlags[Timer2][ClockWeekDay-1]) 
        {    // The clock day is enabled for timer control so check the clock against the timer settings
            if (LongClockMinute >= LongTimer_ON[Relay2][Timer2] && LongClockMinute < LongTimer_OFF[Relay2][Timer2])
            {  // if clock is inbetween the ON & OFF setpoints then the timer ON should be initiated
              Activate_Relay(Relay2, SwitchOn,false);   // Switch relay 1 ON, disable output timer 
              RelayOnTimer[Relay2] =  LongTimer_OFF[Relay2][Timer2] -  LongClockMinute; // set relay ON timer 
              if (EnableMessages)
              {
                Serial.println(F("Relay 2 Timer 2 Started"));
                Print_Clock();
              }
              TimerActive[Relay2][Timer2] = true;    // set relay 1 timer 2 active flag          
            } // end of if (LongClockMinute >= LongTimer_ON[Relay2][Timer2] && LongClockMinute < LongTimer_OFF[Relay2][Timer1])  
        } // end of if (Relay2TimeControlDayFlags[Timer2][ClockWeekDay-1]) 
    }    // if(TimerEnable[Relay2][Timer2] && ClockWeekDay != 0 && TimerActive[Relay2][Timer2] == false) 
         // *************************** At the end of each timer period ***********************
    if (Relay2TimeControlDayFlags[Timer1][ClockWeekDay-1] && TimerActive[Relay2][Timer1] == true) 
    {    // The clock day is enabled so reset Timer Active flag if the clock is > setpoint OFF and before midnight 
        if (LongClockMinute >= LongTimer_OFF[Relay2][Timer1] && LongClockMinute <= 1439)
        {
          TimerActive[Relay2][Timer1] = false;
          Activate_Relay(Relay2, SwitchOff,false);   // Switch relay 2 OFF, disable output timer 
          if (EnableMessages)
          {
            Serial.println(F("Relay 2 Timer 1 Stopped"));
            Print_Clock();
          }      
        }  // end of if (LongClockMinute >= LongTimer_OFF[Relay2][Timer1] && LongClockMinute <= 1439)
    }    // end of if (Relay2TimeControlDayFlags[Timer1][ClockWeekDay-1]) 
  }  //end ofif(CheckForCombinedTimersRelay2() == false)
  // -----------------------------------------------------------------------------
 if (Relay2TimeControlDayFlags[Timer2][ClockWeekDay-1] && TimerActive[Relay2][Timer2] == true)
 {  // The clock day is enabled so reset Timer Active flag if the clock is > setpoint OFF and before midnight 
    if (LongClockMinute >= LongTimer_OFF[Relay2][Timer2] && LongClockMinute <= 1439) 
    {
      TimerActive[Relay2][Timer2] = false;
      Activate_Relay(Relay2, SwitchOff,false);   // Switch relay 2 OFF, disable output timer  
      if (EnableMessages)
      {
        Serial.println(F("Relay 2 Timer 2 Stopped"));
        Print_Clock();
      }           
    }  // end of if (LongClockMinute >= LongTimer_OFF[Relay2][Timer2] && LongClockMinute <= 1439)
 }  // end of if (Relay2TimeControlDayFlags[Timer2][ClockWeekDay-1])
}   // end of void Check_Time_Control2()
 // ---------------------------------------------------------------------------
void Check_Time_Control_Relay3()  
{ 
   const byte Relay3 = 2;
  // ---------------------------------- Timer 1 --------------------------------------------
          // only if relay timer is enabled AND clock is valid (weekday not = 0) AND timer 1 not previously active  
   if(TimerEnable[Relay3][Timer1] && ClockWeekDay != 0 && TimerActive[Relay3][Timer1] == false)  
   {
     if (Relay3TimeControlDayFlags[Timer1][ClockWeekDay-1]) 
     {    // The clock day is enabled for timer control so check the clock against the timer settings
          if (LongClockMinute >= LongTimer_ON[Relay3][Timer1] && LongClockMinute < LongTimer_OFF[Relay3][Timer1])
          {  // if clock is inbetween the ON & OFF setpoints then the timer ON should be initiated
             Activate_Relay(Relay3, SwitchOn,false);   // Switch relay 1 ON, disable output timer 
             RelayOnTimer[Relay3] =  LongTimer_OFF[Relay3][Timer1] -  LongClockMinute; // set relay ON timer  
             if (EnableMessages)
             {
               Serial.println(F("Relay 3 Timer 1 Started"));
               Print_Clock();
             }
             TimerActive[Relay3][Timer1] = true;    // set relay 1 timer 1 active flag                                
          }   // end of if (LongClockMinute >= LongTimer_ON[Relay3][Timer1] && LongClockMinute < LongTimer_OFF[Relay3][Timer1])     
     }  // end of if (Relay3TimeControlDayFlags[Timer1][ClockWeekDay-1])
   } // end of if(TimerEnable[Relay3][Timer1] && ClockWeekDay != 0 && TimerActive[Relay3][Timer1] == false)  
   // ------------------------------------------------------------------------------------------------------  
   if(CheckForCombinedTimersRelay3() == false)  // only if timers are not combined into 1
   {          // ------------------------- Timer 2 -------------------------------------------- 
              // only if relay timer is enabled AND clock is valid (weekday not = 0) AND timer 2 not previously active  
      if(TimerEnable[Relay3][Timer2] && ClockWeekDay != 0 && TimerActive[Relay3][Timer2] == false)  
      {    
        if (Relay3TimeControlDayFlags[Timer2][ClockWeekDay-1]) 
        {    // The clock day is enabled for timer control so check the clock against the timer settings
            if (LongClockMinute >= LongTimer_ON[Relay3][Timer2] && LongClockMinute < LongTimer_OFF[Relay3][Timer2])
            {  // if clock is inbetween the ON & OFF setpoints then the timer ON should be initiated
              Activate_Relay(Relay3, SwitchOn,false);   // Switch relay 1 ON, disable output timer 
              RelayOnTimer[Relay3] =  LongTimer_OFF[Relay3][Timer2] -  LongClockMinute; // set relay ON timer 
              if (EnableMessages)
              {
                Serial.println(F("Relay 3 Timer 2 Started"));
                Print_Clock();
              }
              TimerActive[Relay3][Timer2] = true;    // set relay 1 timer 2 active flag          
            } // end of if (LongClockMinute >= LongTimer_ON[Relay3][Timer2] && LongClockMinute < LongTimer_OFF[Relay3][Timer1])  
        } // end of if (Relay3TimeControlDayFlags[Timer2][ClockWeekDay-1]) 
    }    // if(TimerEnable[Relay3][Timer2] && ClockWeekDay != 0 && TimerActive[Relay3][Timer2] == false) 
          // *************************** At the end of each timer period ***********************
    if (Relay3TimeControlDayFlags[Timer1][ClockWeekDay-1] && TimerActive[Relay3][Timer1] == true) 
    {    // The clock day is enabled so reset Timer Active flag if the clock is > setpoint OFF and before midnight 
        if (LongClockMinute >= LongTimer_OFF[Relay3][Timer1] && LongClockMinute <= 1439)
        {
          TimerActive[Relay3][Timer1] = false;
          Activate_Relay(Relay3, SwitchOff,false);   // Switch relay 1 OFF, disable output timer  
          if (EnableMessages)
          {
            Serial.println(F("Relay 3 Timer 1 Stopped"));
            Print_Clock();
          }           
        }  // end of if (LongClockMinute >= LongTimer_OFF[Relay3][Timer1] && LongClockMinute <= 1439)
    }    // end of if (Relay3TimeControlDayFlags[Timer1][ClockWeekDay-1]) 
  } // end of  if(CheckForCombinedTimersRelay3() == false)  // only if timers are not combined into 1
  // ------------------------------------------------------------------------------ 
 if (Relay3TimeControlDayFlags[Timer2][ClockWeekDay-1] && TimerActive[Relay3][Timer2] == true)
 {  // The clock day is enabled so reset Timer Active flag if the clock is > setpoint OFF and before midnight 
    if (LongClockMinute >= LongTimer_OFF[Relay3][Timer2] && LongClockMinute <= 1439) 
    {
      TimerActive[Relay3][Timer2] = false;
      Activate_Relay(Relay3, SwitchOff,false);   // Switch relay 1 OFF, disable output timer   
      if (EnableMessages)
      {
        Serial.println(F("Relay 3 Timer 2 Stopped"));
        Print_Clock();
      }          
    }  // end of if (LongClockMinute >= LongTimer_OFF[Relay3][Timer2] && LongClockMinute <= 1439)
 }  // end of if (Relay3TimeControlDayFlags[Timer2][ClockWeekDay-1])
}   // end of void Check_Time_Control3()     
    // --------------------------------------------------------------------
void Auto_EEPROM_Check()   // test EEPROM Block for correct ID, set EEPROM to default if 1st run
{
  byte Value;
  byte i = 0;
  while (i < 5)
  {
    Value = EEPROM.read(EEPROM_Header_Block + i);
    if (Value != i) 
    {    // if any one of header block not correct, reset all EEPROM & exit
      Serial.println(""); Serial.println(F("EEPROM not initialised"));
      Reset_EEPROM();
      ResetWiFi_MQTT_EEPROM();
      break;
    }  // end of if (Value != i) 
    i ++;  
  }  // end of while (i < 5) 
}   // end of void Auto_EEPROM_Check() 
// --------------------------------------------------------------
void Display_OLED_String(String Text, byte LineNo, byte CharNo, boolean ClearField)  // LineNo 0-7
{        
        oled.setCursor(CharNo*oled.fontWidth(),LineNo);       
        oled.print (Text); 
        if(ClearField) oled.clearToEOL();                      
}
// ------------------------------------------------------------
String ConvertClockTimeToString()
{
    String Time_Day = String(ClockHour) + ":";      
    if (ClockMinute > 9) Time_Day += String(ClockMinute) + " ";
    else Time_Day += "0" + String(ClockMinute) + " ";      
    switch (ClockWeekDay)
    {
       case 1:
          Time_Day += "Sunday ";
       break;
       case 2: 
          Time_Day += "Monday ";
       break;
       case 3:
          Time_Day += "Tuesday ";
       break;
       case 4:
          Time_Day += "Wednesday ";
       break;
       case 5:
           Time_Day += "Thursday ";
       break;
       case 6:
          Time_Day += "Friday ";
       break;
       case 7:
          Time_Day += "Saturday ";
       break;
    }
    return Time_Day;
}
// ------------------------------------------------------------------------
void Update_OLED()
{       
  if(AccessPointRunning) // if Access point is running - display message screen
  {
    
    if(FirstPass == false)
    {   // once only
      oled.clear();
      oled.println("Web Configurator ON");   // line 1
      oled.println("Connect Phone to ");     // line 2
      oled.println(HostName);                // line 3  
      oled.println(" - Setup wifi & then");   // line 4   
      oled.println("connect a browser to");  // line 5
      oled.println("http://192.168.8.200");  // line 6
      oled.println("Controller will reset"); // line 7
      oled.print  ("on closing connection"); // line 8    
      FirstPass = true;     
    }  // end of if(FirstPass == false)
  }  // end of if(AccessPointRunning) // if Access point is running - display message screen
 else
 {      // AP is not running = normal display modes     
   byte InputOnCounter;   // will count how many inputs are ON
   byte z = 0;
   String Status = "";
   byte LineNo = 3; 
   String Temp = "";     
   // ------------------------------- Top Line -------------------
   switch(ScreenNo)
   {
    case Home:
      Display_OLED_String(HostName,0,0,true);  // If Home screen, print to OLED the device name - Line 1
      break;
    //---------------------------------------------------------
      default:  // all other pages
      if(ScreenEnable[ScreenNo-1] == true)  // if page is enabled
      {
        if(OLED_ScreenHomeCopy[ScreenNo - 1][0] == false)
        {
          oled.setCursor(0,0);
          z = 0;
          Temp = "";
          while (z < 20)  // create text line from screen array
          {
            Temp += OLED_PageBuffer[ScreenNo-1][0][z];   // build up text string from array
            z++;  // increment character counter
          }   // end of  while (z < 20)  // create text line from screen array
          oled.println(Temp);   // print text line to display
        }  // end of if(OLED_ScreenHomeCopy[ScreenNo - 1][0] == false)
        else  // display same as home screen
        Display_OLED_String(HostName,0,0,true);  
      } // end of if(ScreenEnable(ScreenNo-1))  // if page is enabled
      break;        
   }  // end of switch(ScreenNo)
// ----------------------------------- Line 2 ----------------------      
   switch(ScreenNo)
   {
    case Home:   
      if(ClockEnable == true && NTP_Resolved == true) Display_OLED_String(ConvertClockTimeToString(),1,0,true);  // Display current time
      else  // clear line
      {
        oled.setCursor(0,1);
        oled.clearToEOL();
      }
    break;
    default:
      if(ScreenEnable[ScreenNo-1] == true)  // if page is enabled
      {
        if(OLED_ScreenHomeCopy[ScreenNo - 1][1] == false)
        {
          oled.setCursor(0,1);
          z = 0;
          Temp = "";
          while (z < 20)  // create text line from screen array
          {
            Temp += OLED_PageBuffer[ScreenNo-1][1][z];   // build up text string from array
            z++;  // increment character counter
          } 
          oled.println(Temp);   // print text line to display
        } // end of if(OLED_ScreenHomeCopy[ScreenNo - 1][1] == false)
        else 
        if(ClockEnable) Display_OLED_String(ConvertClockTimeToString(),1,0,true);  // Display current time
        oled.setCursor(23*oled.fontWidth(),1);
        oled.print(ScreenAge[ScreenNo-1]);                  
      } // end of   if(ScreenEnable(ScreenNo-1))  // if page is enabled          
      break; 
   }    // end of switch(ScreenNo) 
// ------------------------------------ Data Area Lines 3,4,5,6,7 ---------------------
   switch (ScreenNo) 
   {   
       case Home: 
       LineNo = 4;
       z=0;
       InputOnCounter = 0;
       while(z < NoOfRelays) // determine how many relays are ON
       {
          if (digitalRead(RelayPin[z]) == RelayOn) InputOnCounter ++;   // if output is ON 
          z ++;              
       }
       if (InputOnCounter == 0) // If no Outputs are ON
       {
        oled.setCursor(0,2);
        oled.clearToEOL();  // clear line 3       
        if(!BMP180 && !BME280) Display_OLED_String("All Outputs are OFF",3,0,true); // if BMP/BME sensors not enabled
        if(BMP180)
        {
          oled.setCursor(2*oled.fontWidth(),3); 
          oled.set2X();
          oled.print(RoomTemp+0.05,1); oled.print(" "); oled.println(BaraPress+0.5,0);
          oled.set1X();
          oled.print("     'C      mBar");
        }   // end of if(BMP180)
        if(BME280)
        {
          oled.setCursor(0,3); 
          oled.set2X();
          oled.print(RoomTemp+0.05,1); 
          oled.print(" ");
          oled.set1X();
          oled.print(BaraPress+0.5,0);
          oled.print("  ");
          oled.println(Humidity+.05,1);    
          oled.setCursor(50,30);        
          oled.println("  mBar  %RH");
          oled.print("    'C");
          oled.clearToEOL();
        }  // end of  if(BME280)     
       } // end of if (InputOnCounter == 0) // If no Outputs are ON */
       else
       {
          z = 0;
          while(z < NoOfRelays)  // print status of each output
          {
            if (digitalRead(RelayPin[z]) == RelayOn)   // if output is ON  // Lines 4,5,6
            {
              Display_OLED_String(RelayDescriptors[z],LineNo-1,0,true);
              Status = String(RelayOnTimer[z]);          
              Display_OLED_String(Status,LineNo-1,20,true);          
              Display_OLED_String("m",LineNo-1,23,true);
              LineNo ++;
            } 
            else Display_OLED_String(" ",LineNo-1,0,true);
            z ++;        
          }  // end of while(z < NoOfRelays)  // print status of each output 
    
          if(LineNo > 4)
          {        
            while (LineNo < 7)
            {
              oled.setCursor(0,LineNo-1);         
              oled.clearToEOL();  // clear line
              LineNo ++;
            } 
          }
       }  // end of else            
       break;
       // -------------------------------------------------------------------------       
       default:
        if(ScreenEnable[ScreenNo-1] == true)  // if page is enabled 
        {      
          LineNo = 3;
          oled.setCursor(0,LineNo-1);
          while (LineNo < 8)  // for each line
          {      
            z = 0;
            Temp = "";
            while (z < 20)  // create text line from screen array
            {
              Temp += OLED_PageBuffer[ScreenNo-1][LineNo-1][z];   // build up text string from array
              z++;  // increment character counter
            } 
            oled.println(Temp);   // print text line to display
            LineNo ++;                  // increment line counter
          }
        } // end of    if(ScreenEnable[ScreenNo-1] == true)  // if page is enabled  
       break;        
   }  // end of  switch(ScreenNo)  
// --------------------  Bottom OLED line (line 8) ------------------------------------
  switch(ScreenNo)
  { 
    case Home:
      if(InputOnCounter == 0)  // If all Outputs are OFF
      {
        if(WiFi.status() == WL_CONNECTED) // if home screen, print local IP address if connected
        {   
          IPAddress IP = WiFi.localIP();  // Print to OLED the local IP address
          String IPStr = String(IP[0]) + '.' + String(IP[1]) + '.' + String(IP[2]) + '.' + String(IP[3]);   
          Display_OLED_String("IP:" + IPStr,7,0,true); 
        }
        else  Display_OLED_String("WiFi Not Connected",7,0,true); 
      }    // end of if(InputOnCounter == 0)  // If all Outputs are OFF
      else   // if 1 or more outputs is ON
      {
        oled.setCursor(0,7);        
        if(BMP180)   // only if BMP180 fitted
        {
          oled.print("Room:"); oled.print(RoomTemp+0.05,1); oled.print("'C "); 
          oled.print(BaraPress+0.5,0); oled.print(" mb");
          oled.clearToEOL();          
        }
        else if(BME280)   // only if BME280 fitted
        {
          oled.print(RoomTemp+0.05,1); oled.print("'C "); 
          oled.print(BaraPress+0.5,0); oled.print("mb ");
          oled.print(Humidity+0.05,1); oled.print("%RH");
          oled.clearToEOL();
        }
        else
        {
            if(WiFi.status() == WL_CONNECTED) // if home screen, print local IP address if connected
            {   
              IPAddress IP = WiFi.localIP();  // Print to OLED the local IP address
              String IPStr = String(IP[0]) + '.' + String(IP[1]) + '.' + String(IP[2]) + '.' + String(IP[3]);   
              Display_OLED_String("IP:" + IPStr,7,0,true); 
            }
            else  Display_OLED_String("WiFI Not Connected",7,0,true); 
        }      
      }  // end of else   // if 1 or more outputs is ON      
      break;
      //---------------------------------------------------------
      default:
      if(ScreenEnable[ScreenNo-1] == true)  // if page is enabled
      {
        if(OLED_ScreenHomeCopy[ScreenNo - 1][7] == false)
        {            
          oled.setCursor(0,7);
          z = 0;
          Temp = "";
          while (z < 20)  // create text line from screen array
          {
            Temp += OLED_PageBuffer[ScreenNo-1][7][z];   // build up text string from array
            z++;  // increment character counter
          } 
          oled.print(Temp);   // print text line to display
          oled.clearToEOL();          
        } // end of if(OLED_ScreenHomeCopy[ScreenNo - 1][2] == false)
        else 
        {
            if(BMP180)   // only if BMP180 is enabled
            {
              oled.setCursor(0,7);
              oled.print("Room:"); oled.print(RoomTemp+0.05,1); oled.print("'C "); 
              oled.print(BaraPress+0.5,0); oled.print(" mb");
              oled.clearToEOL();
            }
            else 
            if(BME280)   // only if BME280 fitted
            {
              oled.print(RoomTemp+0.05,1); oled.print("'C "); 
              oled.print(BaraPress+0.5,0); oled.print("mb ");
              oled.print(Humidity+0.05,1); oled.print("%RH ");
              oled.clearToEOL();
            }
        }  // end of else
      } // end of if(ScreenEnable(ScreenNo-1))  // if page is enabled                 
      break;       
  }  // end of   switch(ScreenNo)
 }  // end of  {      // AP is not running = normal display modes  
}  // end of void Update_OLED()
// -------------------------------------------------------------------------  
void Get_BMP180()   // Read Temperature and pressure from BMP180 sensor
{
  RoomTemp = bmp.readTemperature() + TempOffset;       // Temperature in 'C 
  BaraPress = bmp.readPressure()/100;         // Pressure in millibar  
}
// --------------------------------------------------------------------------
void Get_BME280()   // Read Temperature, pressure & Humidity from BME280 sensor
{
  RoomTemp = bme.readTemperature() + TempOffset;       // Temperature in 'C 
  BaraPress = bme.readPressure()/100;     // Pressure in millibar  
  Humidity = bme.readHumidity();          // Humidity in %RH
}
// ------------------------------------------------------------------------------- 
void IncomingOLED_ScreenData(String MQTT_Message)  // Update OLED screens via MQTT
{
  byte ScreenNo;
    String Line = "";   // OLED line number 1 to 6
  String Text = "";   // Text to be displayed on OLED
  String Mode = "";   // if set to "H", use line from Home screen, "O" = overwrite line  
  String Screen = ""; // if set to "E", enable this screen, "D" = disable 
  String Host = "";   // contains the Hostname of the addressed House Node
  char Temp[NoOf_OLED_CharactersPerLine];  // temporary buffer
  // ------------- unpack MQTT_Message --------------------------------------
  byte Index1 = MQTT_Message.indexOf("Screen",0);
  if(Index1 != -1) ScreenNo = MQTT_Message.substring(Index1+7,Index1+8).toInt();
  Index1 = MQTT_Message.indexOf("Line");
  if(Index1 != -1) Line = MQTT_Message.substring(Index1+5,Index1+6);
  Index1 = MQTT_Message.indexOf("Mode");
  if(Index1 != -1) Mode = MQTT_Message.substring(Index1+5,Index1+6);
  Index1 = MQTT_Message.indexOf("Screen",10);
  if(Index1 != -1) Screen = MQTT_Message.substring(Index1+7,Index1+8);
  Index1 = MQTT_Message.indexOf("Text");
  if(Index1 != -1) Text = MQTT_Message.substring(Index1+5);  
  // -------------------------------------------------------------------------
  Remote_OLED_TxCounter[ScreenNo] = RemoteScreenTimeout * 60000 / DisplayToggleInterval;    
  if(Line.length() > 0 &&  Text.length() > 0)  // if a line number & display text is passed
  { 
      Text.toCharArray(Temp,Text.length()+1);  // store display text in temporary buffer array
      byte i = 0;    
      while(i < Text.length())  // transfer incoming text from temp buffer to the OLED display buffer
      {
        OLED_PageBuffer[ScreenNo][Line.toInt()-1][i] = Temp[i];    
        i ++;
      }  
      while (i < NoOf_OLED_CharactersPerLine) // fill any unused characters in the line with spaces
      {
      OLED_PageBuffer[ScreenNo][Line.toInt()-1][i] = ' ';      
      i++; 
      } 
  } // end of if(Line.length() > 0 && Command.length() > 0 &&  Text.length() > 0)
  // ------------------------------------------------------------  
  if(Line.length() > 0 &&  Mode.length() > 0 && Line != "0")   // Copy Home line or overwrite with sent line
  {
      if(Mode == "H") OLED_ScreenHomeCopy[ScreenNo][Line.toInt()-1] = true; 
      if(Mode == "O") OLED_ScreenHomeCopy[ScreenNo][Line.toInt()-1] = false; 
  }  // end of if(Line.length() > 0 &&  Mode.length() > 0 && Line != "0")   // Copy Home line or update command sent 
      // ------------------------------------------------------------
  if(Screen.length() > 0)    // Screen enable/disable command sent
  {
      if(Screen == "E") ScreenEnable[ScreenNo] = true;   // enable screen 
      if(Screen == "D") ScreenEnable[ScreenNo] = false;   // disable screen  
  } // end of   if(Screen.length() > 0)    // Screen enable/disable command sent
    
  ScreenAge[ScreenNo] = 0;   //Reset screen age timer for this screen    
  //if(EnableMessages) Serial.println(content);
}  // end of void IncomingOLED_ScreenData(byte ScreenNo, String (MQTT_Message))   
// --------------------------------------------------------------------------------
void OLED_Screen_Settings()     // OLED Auxiliary screen settings
{
    String qToggleTime; 
    String qScreenTimeout;
    String qTempSensorOffset;
    String qDisplayOn;
    String qDisplayOff;
    
    if(AccessPointRunning)
    {
      qToggleTime = serverAP.arg("ToggleTime"); 
      qScreenTimeout = serverAP.arg("ScreenTimeout");
      qTempSensorOffset = serverAP.arg("TempSensorOffset");     
      qDisplayOn = serverAP.arg("DisplayOn");
      qDisplayOff = serverAP.arg("DisplayOff");  
    }
    else
    {
      qToggleTime = LocalServer.arg("ToggleTime"); 
      qScreenTimeout = LocalServer.arg("ScreenTimeout");
      qTempSensorOffset = LocalServer.arg("TempSensorOffset");  
      qDisplayOn = LocalServer.arg("DisplayOn");
      qDisplayOff = LocalServer.arg("DisplayOff");           
    }          
    boolean EEPROM_Update = false;            
    if(qDisplayOn.length() > 0)  //a value has been entered into parameter field
    {
      byte temp = qDisplayOn.toInt();
      DisplayOnTime = temp;
      EEPROM.write(EEPROM_DisplayOnTime,DisplayOnTime);
      EEPROM_Update = true;
    }
    if(qDisplayOff.length() > 0)  //a value has been entered into parameter field
    {
      byte temp = qDisplayOff.toInt();
      DisplayOffTime = temp;
      EEPROM.write(EEPROM_DisplayOffTime,DisplayOffTime);
      EEPROM_Update = true;
    }    
     if(qToggleTime.length() > 0)  //a value has been entered into parameter field
    {
      byte temp = qToggleTime.toInt();
      if(temp == 11) // display toggle is disabled
      {
        DisplayToggle = false;
        temp = 10;     // reset toggle time to 10 seconds
      }
      else DisplayToggle = true; 
      DisplayToggleInterval = temp * 1000;  // store toggle time parameter in milliseconds
      EEPROM.write(EEPROM_DisplayToggleInterval,temp);  // save to EEPROM  (time in seconds)
      EEPROM_Update = true;
    }  // end of if(qToggleTime.length() > 0)  //a value has been entered into parameter field         
    if(qTempSensorOffset.length() > 0)  //a value has been entered into parameter field
    {
      int temp = qTempSensorOffset.toInt(); // save calibration offset
      EEPROMWritelong(EEPROM_TempOffset,temp);  // save to EEPROM   // x10 of actual value
      TempOffset = float(temp)/10.0;
      EEPROM_Update = true;
    }          
    if(qScreenTimeout.length() > 0)  //a value has been entered into parameter field
    {
      byte temp = qScreenTimeout.toInt();
      RemoteScreenTimeout = temp;  // store time out parameter in minutes
      EEPROM.write(EEPROM_RemoteScreenTimeout,temp);  // save to EEPROM  (time in seconds) 
      EEPROM_Update = true;
    }    
    if(EEPROM_Update) EEPROM.commit();   // lock in EEPROM
      
    String content;
    content = "<!DOCTYPE HTML>\r\n<html>";
    content += "<head> <style>";  
    content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
    content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
    content += "</style></head><body>"; 
    content += "<h3>" + HostName + " OLED Auxiliary Screen settings</h3>";
    content += "<p><form action = 'OLED_Screen_Settings'>";            
    content += "<fieldset>";
    content += "<legend><b>Settings are set automatically by any remote connected sensors</b></legend>";    
    byte OLED_ScreenNo = 0;
    byte ScreenCounter = 0;  // counter for no of screens that are disabled 
    while (OLED_ScreenNo < NoOf_OLED_Pages)  // print if OLED screens are enabled
    {
     if (ScreenEnable[OLED_ScreenNo] == false) ScreenCounter ++;   // screen is disabled so increment counter     
     else   // Screen is enabled
     {
        content += "OLED Screen " + String(OLED_ScreenNo) + " is Enabled<br>";
        byte LineNo = 0;
        while(LineNo < 3)
        {
            content += "  Line number " + String(LineNo + 1) + " is set to ";
            if (OLED_ScreenHomeCopy[OLED_ScreenNo][LineNo]) content += "Home Copy<br>"; else content += "Over write<br>";
            LineNo ++;
        }  
      }  // end of else   // Screen is enabled
      OLED_ScreenNo ++;
    } // end of while (OLED_ScreenNo < NoOf_OLED_Pages)  // print if OLED screens are enabled
    if(ScreenCounter == NoOf_OLED_Pages) content += "All Auxiliary screens are disabled";       // All screens are disabled  
    content += "</fieldset>"; 

    content += "<br><fieldset>";
    content += "<legend><b>Display Settings</b></legend>";
    content += "Current value of display time between each enabled screen (S) = " + String(DisplayToggleInterval/1000) + "<br>";
    content += "<label>Enter new value if required (1-10s)(11 = display toggle disabled) </label> ";    
    content += "<input type = 'number' name='ToggleTime' + length=3 size = '4' min='1' max = '11'><br><br>";

    content += "Current value of Remote Screen timeout (min) = " + String(RemoteScreenTimeout) + "<br>";
    content += "<label>Enter new value if required (1-120 min)</label> ";    
    content += "<input type = 'number' name='ScreenTimeout' + length=3 size = '4' min='1' max = '120'>";
    content += "</fieldset>";   

    content += "<br><fieldset>";
    content += "<legend><b>Temperature reading Calibration offset</b></legend>";
    content += "Current value of Calibration Offset applied to Sensor measurement = " + String(TempOffset) + "<br>";
    content += "<label>Enter new Temp Offset (x10 )(-100 to +100) 'C (E.g. -99=-9.9) </label> ";    
    content += "<input type = 'number' name='TempSensorOffset' + length=4 size = '4' min='-100' max = '100'>";
    content += "</fieldset>";

    if(ClockEnable)
    {
      content += "<br><fieldset>";
      content += "<legend><b>Auto Switching On and Off times Of Local Display (Hours only)</b></legend>";
      content += "Display is only enabled inbetween these times&nbsp<i/>(Display is OFF if both times are the same)</i>";
      content += "<br>ON time =&nbsp&nbsp" + String(DisplayOnTime);
      content += "&nbsp&nbsp<label>New ON time (0-23)  </label> ";    
      content += "<input type = 'number' name='DisplayOn' + length=4 size = '3' min='0' max = '23'>";
      content += "<br>OFF time =&nbsp" + String(DisplayOffTime);
      content += "&nbsp&nbsp<label>New OFF time (0-23) </label> ";    
      content += "<input type = 'number' name='DisplayOff' + length=4 size = '3' min='0' max = '23'>";       
      content += "</fieldset>";
    }
    else // ensure that the display will not switch off (since clock is running but not corrected by NTP
    {
      DisplayOffTime = 24;
      DisplayOnTime = 0;
    }
    content += "<br><input type='submit' value = 'Upload new values to the device'  style = 'color:blue;background:yellow;font size 25 px'>";         
    content += "<br><br><a href='http://";           
    if(AccessPointRunning) content += "192.168.8.200'>"; else     content += IPaddressToString(WiFi.localIP()) + "'>";
    content +=  " Return to the Main Menu  </a>";   
    content += "</form></html>"; 
    if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
    else LocalServer.send(200, "text/html", content);  // send message to AP Webpage 
}  // end of  void OLED_Screen_Settings()  
// ---------------------------------------------------------------------------------------------------
void HomePage()                  // Configuration Menu page
{
      String content;
      byte CharCounter;
      AutoResetTimerEnable = false;  //Stop Auto reset counter (only if login failed)      
      content = "<!DOCTYPE HTML> <html>";  
      content += "<meta http-equiv='refresh' content='3'>";         
      content += "<head> <style>";  
      content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
      content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
      content += "</style></head><body>"; 
      content += "<form>";        
      content += "<h3>" + HostName;
      if(AccessPointRunning) content += " (Offline) Data & Configuration Page</h3>";
      else content += " (Online) Setup Menu</h3>";      
      content += Firmware_Version  + " Issue Date " + (DateCreated) + "<br>";
      if (ClockEnable)
      {
        content+= "Current clock time = ";
        content += String(ClockHour) + ":";      
        if (ClockMinute > 9) content += String(ClockMinute);
        else content += "0" + String(ClockMinute);      
        switch (ClockWeekDay)
        {
          case 1:
          content += " Sunday, ";
          break;
          case 2: 
          content += " Monday, ";
          break;
          case 3:
          content += " Tuesday, ";
          break;
          case 4:
          content += " Wednesday, ";
          break;
          case 5:
          content += " Thursday, ";
          break;
          case 6:
          content += " Friday, ";
          break;
          case 7:
          content += " Saturday, ";
          break;
        }     
      }  // end of if(ClockEnable)  
      
      content += "<p><fieldset>";   
      content += "<legend><b>Relay Outputs (Press Buttons To Manually Switch the Outputs)</b></legend>";        
      content += "&nbsp<input type = 'submit' formaction = 'WebSwitchRelay1' style = 'color:blue;background:yellow;font size 25 px'"; 
      if(digitalRead(RelayPin[0]) == RelayOn) 
          content += "value = '" + RelayDescriptors[0] + " is ON'>"; else content += "value = '" + RelayDescriptors[0] + " is OFF'>";    
      if (NoOfRelays >= 2)   // if 2 or 3 relays fitted
      {
        content += "&nbsp&nbsp<input type = 'submit' formaction = 'WebSwitchRelay2' style = 'color:blue;background:yellow;font size 25 px'";            
        if(digitalRead(RelayPin[1]) == RelayOn) 
           content += "value = '" + RelayDescriptors[1] + " is ON'>"; else content += "value = '" + RelayDescriptors[1] + " is OFF'>";
      }      
      if (NoOfRelays ==3)  // if 3 relays fitted
      {
        content += "&nbsp&nbsp<input type = 'submit' formaction = 'WebSwitchRelay3' style = 'color:blue;background:yellow;font size 25 px'";       
        if(digitalRead(RelayPin[2]) == RelayOn) 
           content += "value = '" + RelayDescriptors[2] + " is ON'>"; else content += "value = '" + RelayDescriptors[2] + " is OFF'>";
      }
      content += "</fieldset>"; 

      if(BMP180 == true || BME280 == true)
      {
        content += "<br><fieldset>";   
        content += "<legend><b>Aux. Enviromental Measurements</b></legend>"; 
        content += "Room Temperature = " + String(RoomTemp) + " 'C";
        content += "<br>Barometric pressure = " + String(BaraPress) + " mB";
        if(BME280) content += "<br>Humidity = " + String(Humidity) + " %RH";
        content += "</fieldset>"; 
      }

      byte i = 0;
      boolean Stat = false;
      while(i < NoOf_OLED_Pages)
      {
        if (ScreenEnable[i] == true) Stat = true;
        i ++;
      }     
      if(Stat == true)  // only if one of the remote sensors is running
      {
        content += "<p><fieldset>";   
        content += "<legend><b>Aux. Data from Remote Sensors (if fitted)</b></legend>";   // taken from OLED screen buffer          
        byte ScreenNo = 1;
        byte WebScreenIndex = 0;
        while(ScreenNo < NoOf_OLED_Pages)  // For each Auxiliary screen
        { 
          if(ScreenEnable[ScreenNo] == true)  // if page is enabled 
          {                        
            // ------------------------- Line 1 -------------------------------
            if(WebScreenIndex > 0) content += "<br><br>";  // new line if NOT screen 1
            CharCounter = 0;          
            while (CharCounter < 20)  // create text line from screen array
            {
              content += OLED_PageBuffer[ScreenNo][0][CharCounter];   // build up text string from array  // display line 1
              CharCounter++;  // increment character counter
            }   // end of  while (CharCounter < 20)  // create text line from screen array
            content += "&nbsp&nbsp&nbspScreen Age = " + String(ScreenAge[ScreenNo]) + " minute(s)<br>";
        // ------------------------- Lines 4,5 & 6 ---------------------------------------
            byte OLED_LineNo = 3;
            while (OLED_LineNo < 7)  // for each line
            {      
              CharCounter = 0;
              while (CharCounter < 20)  // create text line from screen array
              {
                content += OLED_PageBuffer[ScreenNo][OLED_LineNo-1][CharCounter];   // build up text string from array
                CharCounter++;  // increment character counter
              }
              if(OLED_LineNo != 6) content += "<br>";  // blank line except for last line
              OLED_LineNo ++;                  // increment line counter
            }  // end of while (OLED_LineNo < 7)  // for each line
            WebScreenIndex ++;
          } // end of    if(ScreenEnable[ScreenNo-1] == true)  // if page is enabled 
          ScreenNo ++;
        }  // end of while(ScreenNo < NoOf_OLED_Pages)
        content += "</fieldset>"; 
      }  // end of if(Stat == false)

      content += "<br><fieldset>";
      content += "<legend><b>Control Output Relay Settings</b></legend>";
      content += "<input type = 'submit' formaction = 'ControlOutputNames'";
      content += "value = 'Control Output Names' style = 'color:blue;background:yellow;font size 25 px' >";  
      content += "&nbsp&nbsp<input type = 'submit' formaction = 'RelayOnTimers'";
      content += "value = 'Control Output ON times' style = 'color:blue;background:yellow;font size 25 px'> ON time of each output after being switched";
      content += "<br><br><input type = 'submit' formaction = 'PIR_Setup'";
      content += "value = 'Remote PIR Settings' style = 'color:blue;background:yellow;font size 25 px'> If any remote (MQTT) PIR devices are active";      
      
      if (ClockEnable)
      {     
        content += "<br><br>Timer Controls: <input type = 'submit' formaction = 'Timer_Page_Relay1' value = '" + RelayDescriptors[0] + "' style = 'color:blue;background:yellow;font size 25 px'>";  
        if (NoOfRelays >=2)  
        content += "&nbsp&nbsp<input type = 'submit' formaction = 'Timer_Page_Relay2' value = '" + RelayDescriptors[1] + "' style = 'color:blue;background:yellow;font size 25 px'>"; 
        if (NoOfRelays == 3) 
        content += "&nbsp&nbsp<input type = 'submit' formaction = 'Timer_Page_Relay3' value = '" + RelayDescriptors[2] + "' style = 'color:blue;background:yellow;font size 25 px'>";            
      }  // end of if(ClockEnable)      
      content += "</fieldset>";  
      
      content += "<br><input type = 'submit' formaction = 'Quit' value = 'Close A.P. and Reset Device' style = 'color:blue;background:yellow;font size 25 px'> ";  
      content += "&nbsp&nbsp<input type = 'submit' formaction = 'DisplaySystemSettings' value = 'System Settings' style = 'color:blue;background:yellow;font size 25 px'> ";    
      content += "&nbsp&nbsp<input type = 'submit' formaction = 'MQTT_SetUp' value = 'MQTT Settings' style = 'color:blue;background:yellow;font size 25 px'> ";                              
      content += "</form></html>";         
      if(AccessPointRunning) serverAP.send(200, "text/html", content);  
      else   LocalServer.send(200, "text/html", content);  
}  // end of void HomePage() 
// -----------------------------------------------------------------------------------------------  
void StartAP()
{
    String content;
    content = "<!DOCTYPE HTML> \r\n<html>";     
    content += "The Offline Configuration Tool will now start.";  
    content += "<br><br>Note that Wifi connection will now be broken";
    content += "<br>Connect your mobile device/computer to the"; 
    content += "<br>Controller Setup network SSID and";
    content += "<br>then connect a web browser to http://192.168.8.200";
    content += "<br><br>Note that the controller will reset on quitting the Configuration Tool";
    LocalServer.send(200, "text/html", content);     
    Soft_AP_Switch  = true;   // Start AP
}
// -------------------------------------------------------------------------------------------
void Quit()    // Quit
 {
    String content;
    content = "<!DOCTYPE HTML> \r\n<html>";
    content += "Device will now reset and attempt login";         
    if(AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage
    else LocalServer.send(200, "text/html", content);  // send message to AP Webpage
    delay(2000);
    ResetDevice("From Access Point"); 
 }   
// -----------------------------------------------------------------------------------
void DisplaySystemSettings()    // Display System settings page
{    
   String qClockEnable = serverAP.arg("ClockEnable"); 
   String qLightLevelThreshold1 = serverAP.arg("LightLevelThreshold1");
   String qLightLevelThreshold2 = serverAP.arg("LightLevelThreshold2");
   String qLightLevelThreshold3 = serverAP.arg("LightLevelThreshold3");
   String qEnableMessages = serverAP.arg("EnableMessages");
   String qResetEEPROM = serverAP.arg("ResetEEPROM");     
   boolean LockEEPROM = false;

   if(qResetEEPROM == "1") Reset_EEPROM();
   else   if(qResetEEPROM == "2") ResetWiFi_MQTT_EEPROM();
      
   if(qEnableMessages == "E" && EnableMessages == false) 
   {
      EnableMessages = true;
      EEPROM.write(EEPROM_EnableMessages,EnableMessages);
      LockEEPROM = true; 
   }
   if(qEnableMessages == "D" && EnableMessages == true) 
   {
      EnableMessages = false;
      EEPROM.write(EEPROM_EnableMessages,EnableMessages);
      LockEEPROM = true;    
   }
  
   if(qLightLevelThreshold1.length() > 0)
   {
      LightLevelThreshold[0] = qLightLevelThreshold1.toInt();
      EEPROM.write(EEPROM_LightLevelThreshold,LightLevelThreshold[0]);
      LockEEPROM = true; 
   }
   if(qLightLevelThreshold2.length() > 0)
   {
      LightLevelThreshold[1] = qLightLevelThreshold2.toInt();
      EEPROM.write(EEPROM_LightLevelThreshold+1,LightLevelThreshold[1]);
      LockEEPROM = true; 
   }   
   if(qLightLevelThreshold3.length() > 0)
   {
      LightLevelThreshold[2] = qLightLevelThreshold3.toInt();
      EEPROM.write(EEPROM_LightLevelThreshold+2,LightLevelThreshold[2]);
      LockEEPROM = true; 
   }   
      
   if(qClockEnable == "E" && ClockEnable == false) 
   {
      ClockEnable = true;
      EEPROM.write(EEPROM_ClockEnable,ClockEnable);
      LockEEPROM = true; 
   }
   if(qClockEnable == "D" && ClockEnable == true) 
   {
      ClockEnable = false;
      EEPROM.write(EEPROM_ClockEnable,ClockEnable);
      LockEEPROM = true;    
   }
   if(LockEEPROM == true) EEPROM.commit();   
    
    String content;
    content = "<!DOCTYPE HTML> \r\n<html>";
    //content += "<meta http-equiv='refresh' content='4'>";     
    content += "<head> <style>";  
    content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
    content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
    content += "</style></head><body>";     
    content += "<h3>" + HostName;
    if(AccessPointRunning) content += " (Offline)"; else content += " (Online)"; 
    content += " System Settings</h3><form>";    
    content += Firmware_Version;
    content += "<br>Long Clock (minutes) = " + String(LongClockMinute);    
    content += "&nbspminutes,&nbspCurrent clock time = ";
    content += String(ClockHour) + ":";      
    if (ClockMinute > 9) content += String(ClockMinute);
    else content += "0" + String(ClockMinute);
    switch (ClockWeekDay)
    {
      case 1:
      content += " on Sunday ";
      break;
      case 2: 
      content += " on Monday ";
      break;
      case 3:
      content += " on Tuesday ";
      break;
      case 4:
      content += " on Wednesday ";
      break;
      case 5:
      content += " on Thursday ";
      break;
      case 6:
      content += " on Friday ";
      break;
      case 7:
      content += " on Saturday ";
      break;
    }        
    content += "<form>";  
    
    content += "<br><fieldset>";
    content += "<legend><b>Network</b></legend>";
    if(WiFi.status() == WL_CONNECTED) content += "The device " + HostName + " is connected to SSID " + esid; 
    else content += " <b><i>The device is not connected </b></i>";        
      
    if(!AccessPointRunning)  // if WiFi Screen
    {
          content += "<br><br>To change the Wifi Setting, start the Offline Configuration Server (see button below). The current WiFi connection will be broken. You must reconnect";
          content += " your mobile device/computer to the setup network SSID and connect your web browser to http://192.168.8.200 - The device";
          content += " will reset after quiting the Offline Configuration Server";
          content += "<br><br><a href='http://" + IPaddressToString(WiFi.localIP()) + "/StartAP '>Start Offline Configuration Server </a>";                
    }
    else   // AP screen        
      content += "<br><br> <input type = 'submit' formaction = 'WiFiSetUp' value = 'Change WiFi Settings' style = 'color:blue;background:yellow;font size 25 px'> <br>";          
    content += "</fieldset>";    
    
    content += "<fieldset>"; 

    content += "<legend><b>PIR/Time/Diagnostics</b></legend>";     

    content += "Current light threshold for Relay 1 PIR switching = " + String(LightLevelThreshold[0]) + "%";
    if(AccessPointRunning)  // if access point 
    {
        content += "&nbsp&nbsp<label>Enter new value </label> ";    
        content += "<input type = 'number' name='LightLevelThreshold1' + length=3 size = '4' min='0' max = '100'>";  
    }    
    if(NoOfRelays > 1) content += "<br>Current light threshold for Relay 2 PIR switching = " + String(LightLevelThreshold[1]) + "%";
    if(AccessPointRunning)  // if access point 
    {    
        content += "&nbsp&nbsp<label>Enter new value if required </label> ";  
        content += "<input type = 'number' name='LightLevelThreshold2' + length=3 size = '4' min='0' max = '100'>";   
    }
    if(NoOfRelays > 2) content += "<br>Current light threshold for Relay 3 PIR switching = " + String(LightLevelThreshold[2]) + "%";    
    if(AccessPointRunning)  // if access point 
    {  
          content += "&nbsp&nbsp<label>Enter new value if required </label> "; 
          content += "<input type = 'number' name='LightLevelThreshold3' + length=3 size = '4' min='0' max = '100'>";  
    }
    
    if(PIR_Tx_CounterEnable == true) content += "<br>Minutes since last remote PIR message = " + String(PIR_Connected); 
    if(AccessPointRunning == true)
    {       
      if(ClockEnable == true) content += "<br><input type = 'radio' name = 'ClockEnable' value = 'D'>Click to DISABLE NTP Clock";  
      else content += "<br><input type = 'radio' name = 'ClockEnable' value = 'E'>Click to ENABLE NTP Clock"; 
    } 
    
    content += "<p><input type='submit' formaction = 'DisplaySystemSettings' value = 'Upload new settings' style = 'color:blue;background:yellow;font size 25 px'></form></p>";                     
 
    if(ClockEnable)
    {
     content += "Last successful NTP update was at " + String(Last_NTP_Hour) + ":";
     if (Last_NTP_Minute > 9) content += String(Last_NTP_Minute); else content += "0" + String(Last_NTP_Minute);    
     content += "  Day:" + String(Last_NTP_Day) + "<br>";
    }  // end of   if(ClockEnable)

    if(AccessPointRunning == true)
    {
      if(EnableMessages == true) content += "<input type = 'radio' name = 'EnableMessages' value = 'D'>Click to DISABLE Diagnostic Messages";  
        else content += "<input type = 'radio' name = 'EnableMessages' value = 'E'>Click to ENABLE Diagnostic Messages";     
    
      content += "<br>Reset EEPROM to default values <input type = 'radio' name = 'ResetEEPROM' value = '1'>Timers/Clock/OLED/PIR";
      content += "&nbsp&nbsp<input type = 'radio' name = 'ResetEEPROM' value = '2'>WiFi/MQTT"; 
      content += "&nbsp&nbsp<input type = 'radio' name = 'ResetEEPROM' value = '3' checked>Do Nothing";   
    }
    
    if(ClockEnable)
    {
      content += "<br><br>Relay 1: Timer 1 is "; 
      if(TimerActive[0][0]) content += "RUNNING"; else  content += "NOT RUNNING";
      content += "&nbsp&nbspand Timer 2 is "; 
      if(TimerActive[0][1]) content += "RUNNING"; else  content += "NOT RUNNING";    
      if (NoOfRelays >= 2) 
      {
        content += "<br>Relay 2: Timer 1 is ";      
        if(TimerActive[1][0]) content += "RUNNING"; else  content += "NOT RUNNING";
        content += "&nbsp&nbspand Timer 2 is "; 
        if(TimerActive[1][1]) content += "RUNNING"; else  content += "NOT RUNNING";    
      }  
      if (NoOfRelays == 3)
      {
        content += "<br>Relay 3: Timer 1 is ";      
        if(TimerActive[2][0]) content += "RUNNING"; else  content += "NOT RUNNING";
        content += "&nbsp&nbspand Timer 2 is "; 
        if(TimerActive[2][1]) content += "RUNNING"; else  content += "NOT RUNNING";    
      }       
    }  // end of   if(ClockEnable)
    content += "</fieldset>";  

    content += "<fieldset>"; 
    content += "<legend><b>BMP180/BME280/OLED Display</b></legend>"; 
    content += "OLED Display module is "; 
    if(OLED == false) content += "not fitted"; 
    else 
    {
      content += "fitted&nbsp&nbsp <a href='http://";
      if(AccessPointRunning) content += "192.168.8.200"; 
      else content += IPaddressToString(WiFi.localIP());
      content += "/OLED_Screen_Settings'> Go to OLED Aux Screen Status </a>";
    }    
    content += "<br>";
    if(BMP180) content += "BMP180 Temp & Pres module is fitted";    
    else if(BME280) content += "BME280 Temp,Pres & Humidity module is fitted"; 
         else content += "No local environmental sensor fitted";    
    content += "</fieldset>"; 
       
    content += "<br><a href='http://";           
    if(AccessPointRunning) content += "192.168.8.200'>"; 
    else content += IPaddressToString(WiFi.localIP()) + "'>";
    content +=  " Return to the Main Menu  </a>"; 
    content += "</form> </html>";       
    if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage
    else LocalServer.send(200, "text/html", content);  // send message to AP Webpage
}  // end of void DisplaySystemSettings()    // Display System settings page
 // -----------------------------------------------------------------------------------
void RelayOnTimers()    // Relay On Timers
{
   String qSwitch_Timer1 = serverAP.arg("Switch_Timer1");
   String qSwitch_Timer2 = serverAP.arg("Switch_Timer2");
   String qSwitch_Timer3 = serverAP.arg("Switch_Timer3"); 
   boolean Status = false;
     
      // .................... Process Output Timer1 ................................ 
   if (qSwitch_Timer1.length()> 0 && qSwitch_Timer1 != String(RelayOnTimeParameter[0]))  
   {
           RelayOnTimeParameter[0] = qSwitch_Timer1.toInt();
           EEPROM.write(EEPROM_RelayOnTimeParameter, RelayOnTimeParameter[0]);    
           Status = true;
   } // end of if (qSwitch_Timer1.length()> 0 && qSwitch_Timer1 != RelayOnTimeParameter[0])  
      // .......................... Process Output Timer 2 .......................... 
   if (qSwitch_Timer2.length()> 0 && qSwitch_Timer2 != String(RelayOnTimeParameter[1]))  
   {
           RelayOnTimeParameter[1] = qSwitch_Timer2.toInt();
           EEPROM.write(EEPROM_RelayOnTimeParameter+1, RelayOnTimeParameter[1]);    
           Status = true;
   } // end of if (qSwitch_Timer2.length()> 0 && qSwitch_Timer2 != RelayOnTimeParameter[1])              
      // ........................ Process Output Timer 3 ................................... 
   if (qSwitch_Timer3.length()> 0 && qSwitch_Timer3 != String(RelayOnTimeParameter[2]))  
   {
           RelayOnTimeParameter[2] = qSwitch_Timer3.toInt();
           EEPROM.write(EEPROM_RelayOnTimeParameter+2, RelayOnTimeParameter[2]);    
           Status = true;
   } // end of if (qSwitch_Timer3.length()> 0 && qSwitch_Timer3 != RelayOnTimeParameter[2])              
   if (Status == true)  EEPROM.commit();   // Lock in EEPROM changes    
   // --------------------------------------------------------------  
    String content;
    content = "<!DOCTYPE HTML> \r\n<html>";
    content += "<head> <style>";  
    content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
    content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
    content += "</style></head><body>";     
    content += "<h3>" + HostName;
    content += " Relay Output Timer Page</h3>";
   
    content += "<fieldset>"; 
    content += "<legend><b>Time that the relay remains ON after switching (PIR Timer if activated by PIR)</b></legend>";
    content += "<p><form action='RelayOnTimers'></p>";        
    
    content += "<p><label>" + RelayDescriptors[0] + " Timer(1-240 mins): </label>"; 
    content += "<input type = 'number' name='Switch_Timer1' + value = ";
    content += String(RelayOnTimeParameter[0]) + " length=3 size = '3' min='0' max = '240'>";  
       
    if (NoOfRelays >= 2) 
    {
      content += "<p><label>" + RelayDescriptors[1] + " Timer(1-240 mins): </label> ";
      content += "<input type = 'number' name='Switch_Timer2' + value = " ;
      content += String(RelayOnTimeParameter[1]) + " length=3 size = '3' min='0' max = '240'>";    
    }
    if (NoOfRelays == 3) 
    {
      content += "<p><label>" + RelayDescriptors[2] + " Timer(1-240 mins): </label> ";
      content += "<input type = 'number' name='Switch_Timer3' + value = ";
      content += String(RelayOnTimeParameter[2]) + " length=3 size = '3' min='0' max = '240'>";        
    }
    content += "</p>";
   
    content += "<fieldset>"; 
    content += "<legend><b>Current value of Output running ON timers (mins)</b></legend>";
    content += RelayDescriptors[0] + " = " + String(RelayOnTimer[0]);   
    if (NoOfRelays >= 2) content += "<p>" + RelayDescriptors[1] + " = " + String(RelayOnTimer[1]);     
    if (NoOfRelays == 3) content += "<p>" + RelayDescriptors[2] + " = " + String(RelayOnTimer[2]);          
    content += "</fieldset>"; 
    content += "</fieldset>"; 
       
    if(AccessPointRunning)  
          content += "<p><input type='submit' value = 'Upload new settings to the device' style = 'color:blue;background:yellow;font size 25 px'></p>";
    
    content += "<br><a href='http://";           
    if(AccessPointRunning) content += "192.168.8.200'>"; else content += IPaddressToString(WiFi.localIP()) + "'>";
    content +=  " Return to the Main Menu  </a> </form>";    
     
    if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
    else LocalServer.send(200, "text/html", content);  // send message to AP Webpage
}  // end of void RelayOnTimers()    // Relay On Timers
// --------------------------------------------------------------------------
String BinHex(byte BinaryNumber)
{
  byte Left = BinaryNumber & 0xF0;
  Left = Left >> 4;  
  byte Right = BinaryNumber & 0x0F;
  String Result = BinToHex(Left) + BinToHex(Right);
  return Result;
}
String BinToHex(byte Binary)
{
  String Nibble;
  switch(Binary)
  {
    case 10:
      Nibble = "A";
    break;
    case 11:
      Nibble = "B";
    break;
    case 12:
      Nibble = "C";
    break;
    case 13:
      Nibble = "D";
    break; 
    case 14:
      Nibble = "E";
    break;
    case 15:
      Nibble = "F";
    break;
    default:
      Nibble = String(Binary);
    break;        
  }  // end of switch(Binary)
  return Nibble;  
}  // end of  String BinToHex(byte Binary)
  // ----------------------------------------------------------------------- 
String IPaddressToString(IPAddress ip)
{
   String ipStr = String(ip[0]) + '.' + String(ip[1]) + '.' + String(ip[2]) + '.' + String(ip[3]);
   return ipStr;
}
// ------------------------------------------------------------------
void WiFiSetUp()    // WiFi Set up
{
        String ipStr = IPaddressToString(WiFi.localIP());
        String content;
        //content.reserve(1000);
        content = "<!DOCTYPE HTML>\r\n<html>";
        content += "<head> <style>";  
        content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
        content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
        content += "</style></head><body>";         
        content += "<h3>" + HostName + " WiFi Configuration Page</h3>";
        content += "<form action='WiFiConfiguration' autocomplete = 'off'></p>"; 
                       
        content += "<fieldset>"; 
        content += "<legend><b>Current stored Network details</b></legend>"; 
        content += "<br>SSID = " + esid + "&nbsp&nbsp&nbspWiFi password =  " + epass;  
        content += "<br>Device name = " + HostName + "&nbsp&nbsp&nbspAP password = " + passphrase;                
        long rssi = WiFi.RSSI();        //  received signal strength:        
        content += "<br>Signal strength (RSSI): " + String(rssi);            
        byte mac[6];                      // MAC address 
        WiFi.macAddress(mac);
        content += "<br>MAC address: " + BinHex(mac[0]) + ":" + BinHex(mac[1]) + ":" + BinHex(mac[2]) + ":" + BinHex(mac[3]);
        content += ":" + BinHex(mac[4]) + ":" + BinHex(mac[5]);      
        content += "<br>IP address " + ipStr;
        String SubnetStr = IPaddressToString(WiFi.subnetMask());
        content += "<br>NetMask: " + SubnetStr;
        String GatewayStr = IPaddressToString(WiFi.gatewayIP());
        content += "&nbsp&nbsp&nbspGateway: " + GatewayStr;        
        content += "<br><br>Local WiFi is ";
        if (WiFiManualEnable == true) content += "ENABLED"; else content += "DISABLED";                  
        content += "</fieldset>";    

        content += "<fieldset>"; 
        content += "<legend><b>Router Settings for IP Address assignment</b></legend>"; 
        content += "The router is set to:&nbsp&nbsp";
        content += "<input type = 'radio' name = 'RouterModeSelect' value = 'DHCP'";
        if(RouterMode == DHCP) content += "checked";
        content += ">DHCP&nbsp&nbsp<input type = 'radio' name = 'RouterModeSelect' value = 'StaticIP'";
        if(RouterMode == StaticIP) content += "checked";
        content += ">Static IP";
        if(RouterMode == StaticIP)
        { 
          content += "<br>Static IP Address: " + StaticIPAddress + "&nbsp&nbspGateway:" + GatewayIPAddress;
          content += "&nbsp&nbspSubnet:" + SubnetIPAddress;
          content += "<br><label>StaticIP:</label> <input name='Static_IP' size = '16' length=15>"; 
          content += "&nbsp&nbsp<label>Gateway:</label> <input name='Gateway_IP' size = '16' length=15>";            
          content += "<br><label>Subnet:</label> <input name='Subnet_IP' size = '16' length=15> - (xxx.xxx.xxx.xxx)";         
        } 
        content += "</fieldset>";   
                
        content += "<fieldset>";             
        content += "<legend><b>Detected Networks ... </b></legend>";
        content += st ;
        content += "</fieldset>"; 
                       
        content += "<fieldset>";       
        content += "<legend><b>Input new network settings (20 char max per field, blank fields will not be updated)</b></legend>";
        content += "<label>SSID:</label>  <input name='ssid' size = '22' length=20>"; 
        content += "<label>&nbsp&nbspPassword: </label> <input name='pass' size = '22' length=20>";
        content += "<br><label>HostName:</label> <input name='name' size = '22' length=20>";              
        content += "<label>&nbsp&nbspAP Password:</label> <input name='passAP' size = '22' length=20><br><br>";                 
        if(WiFiManualEnable == true) content += "<input type = 'radio' name = 'WiFiManualEnable' value = 'D'>Click to DISABLE WiFi";  
        else content += "<input type = 'radio' name = 'WiFiManualEnable' value = 'E'>Click to ENABLE WiFi";               
        content += "</fieldset>";         
                
        content += "<p><input type='submit' value = 'Upload new settings to the device' style = 'color:blue;background:yellow;font size 25 px'></form>";
        content += "<br><br><a href='http://192.168.8.200'>";
        content +=  " Return to the Main Menu  </a>"; 
        content += "</form></html>"; 
        if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
        else LocalServer.send(200, "text/html", content);  // send message to AP Webpage        
 }   // end of void WiFiSetUp()    // WiFi Set up
    // -----------------------------------------------------------------------   
void ProcessControlOutputNames()    // Process Control Relay Output text names
{
        String qOP_Name1;   // check input from web page when submitted
        String qOP_Name2;   
        String qOP_Name3;   
  
        if(AccessPointRunning)
        {       
           qOP_Name1 = serverAP.arg("OP_Name1");   // check input from web page when submitted
           qOP_Name2 = serverAP.arg("OP_Name2");   
           qOP_Name3 = serverAP.arg("OP_Name3");   
        }
        else 
        {       
           qOP_Name1 = LocalServer.arg("OP_Name1");   // check input from web page when submitted
           qOP_Name2 = LocalServer.arg("OP_Name2");   
           qOP_Name3 = LocalServer.arg("OP_Name3");   
        }             
// .................. Process Control Output Name 1  .................................       
          if (qOP_Name1.length() > 0 ) // Only if something has been entered into the web field
          {
            unsigned int i=EEPROM_Relay_Descriptors;
            while(i < EEPROM_Relay_Descriptors + MaxStringLength)  // Clear out all of the previous stored entries 
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qOP_Name1.length())   // store new name to EEPROM
            {
              EEPROM.write(EEPROM_Relay_Descriptors + i, qOP_Name1[i]);
              i++;
            }
          } // end of if (qOP_Name1.length() > 0 ) // Only if something has been entered into the field  
 // .................. Process Control Output Name 2  .................................       
          if (qOP_Name2.length() > 0 ) // Only if something has been entered into the web field
          {
            unsigned int i=EEPROM_Relay_Descriptors + MaxStringLength;
            while(i < EEPROM_Relay_Descriptors + (2*MaxStringLength))  // Clear out all of the previous stored entries 
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qOP_Name2.length())   // store new name to EEPROM
            {
              EEPROM.write(EEPROM_Relay_Descriptors + MaxStringLength + i, qOP_Name2[i]);
              i++;
            }
          } // end of if (qOP_Name2.length() > 0 ) // Only if something has been entered into the field    
// .................. Process Control Output Name 3  .................................       
          if (qOP_Name3.length() > 0 ) // Only if something has been entered into the web field
          {
            unsigned int i=EEPROM_Relay_Descriptors + (2*MaxStringLength);
            while(i < EEPROM_Relay_Descriptors + (3*MaxStringLength))  // Clear out all of the previous stored entries 
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qOP_Name3.length())   // store new name to EEPROM
            {
              EEPROM.write(EEPROM_Relay_Descriptors + (2*MaxStringLength) + i, qOP_Name3[i]);
              i++;
            }
          } // end of if (qOP_Name2.length() > 0 ) // Only if something has been entered into the field    
        EEPROM.commit();  // lock in the EEPROM
    Success_Message(true);  // Upload success message to client to AP web page  & reset device 
}  // end of void ProcessControlOutputNames()    // Process output text names
  // -----------------------------------------------------------------------   
void ControlOutputNames()    // Names for Relay Control outputs
 {
    String content = "<!DOCTYPE HTML>\r\n<html>";
    content += "<head> <style>";  
    content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
    content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
    content += "</style></head><body>";     
    content += "<h3>Control Relay Output Names (Device will automatically reset after uploading data)</h3>";
    content += "<p><form action='ProcessControlOutputNames' autocomplete = 'off' ></p>";
    
    content += "<fieldset>";
    content += "<legend><b> Output Names</b> </legend>";
    content += "<label>Output 1 name (Max 20 char) </label>  <input name='OP_Name1' value = ";
    content += RelayDescriptors[0];
    content += " size = '20' length=20>"; 
         
    if (NoOfRelays >= 2)
    {
      content += "<p><label>Output 2 name (Max 20 char) </label>  <input name='OP_Name2' value = ";
      content += RelayDescriptors[1];
      content += " size = '20' length=20>";   
    } 
    if (NoOfRelays == 3)
    {
      content += "<p><label>Output 3 name (Max 20 char) </label>  <input name='OP_Name3' value = ";
      content += RelayDescriptors[2];
      content += " size = '20' length=20>";        
    } 
    content += "</fieldset>" ;      
    if(AccessPointRunning == true)
       content += "<p><input type='submit' value = 'Upload new settings' style = 'color:blue;background:yellow;font size 25 px'> NOTE: <b>Device will reset after uploading' </form>";
    content += "<br><br><a href='http://";           
    if(AccessPointRunning) content += "192.168.8.200'>"; else content += IPaddressToString(WiFi.localIP()) + "'>";
    content +=  " Return to the Main Menu  </a>"; 
    content += "</html>";
    if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
    else LocalServer.send(200, "text/html", content);  // send message to AP Webpage
    Heartbeat_Tick();   // Feed the HW watchdog! 
}   // end of void ControlOutputNames()    
  // -----------------------------------------------------------------------  
void WebSwitchRelay3()    // Manual switching of relay 3
{ 
   String content = "<!DOCTYPE HTML> \r\n<html>";          
   if(digitalRead(RelayPin[2]) == RelayOff) 
   {
     content += "<br>Control Relay 3 (";
     content += RelayDescriptors[2] + ") switched ON";   
     Activate_Relay(2, RelayOn,true);     
   }
   else
   {
     content += "<br>Control Relay 3 (";
     content += RelayDescriptors[2] + ") switched Off";   
     Activate_Relay(2, RelayOff,true);     
   }
   content += "<br><br><a href='http://";           
   if(AccessPointRunning) content += "192.168.8.200'>"; else content += IPaddressToString(WiFi.localIP()) + "'>";
   content +=  " Return to the Main Menu  </a>";   
   if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
   else LocalServer.send(200, "text/html", content);  // send message to AP Webpage 
   Heartbeat_Tick();   // Feed the HW watchdog!  
   if(RemoteDataSendEnable[0] == true) PushMQTT_RelayStatusMessage(0);
   if(RemoteDataSendEnable[1] == true) PushMQTT_RelayStatusMessage(1);
   if(RemoteDataSendEnable[2] == true) PushMQTT_RelayStatusMessage(2);
   if(RemoteDataSendEnable[3] == true) PushMQTT_RelayStatusMessage(3);
   if(RemoteDataSendEnable[4] == true) PushMQTT_RelayStatusMessage(4);
}  // end of void WebSwitchRelay3()    // Manual switching of relay 3
  // -----------------------------------------------------------------------    
void WebSwitchRelay2()    // Manual switching of relay 2
{ 
   String content = "<!DOCTYPE HTML> \r\n<html>";     
   if(digitalRead(RelayPin[1]) == RelayOff) 
   {
     content += "<br>Control Relay 2 (";
     content += RelayDescriptors[1] + ") switched ON";   
     Activate_Relay(1, RelayOn,true);     
   }
   else
   {
     content += "<br>Control Relay 2 (";
     content += RelayDescriptors[1] + ") switched Off";   
     Activate_Relay(1, RelayOff,true);     
   }
   content += "<br><br><a href='http://";           
   if(AccessPointRunning) content += "192.168.8.200'>"; else content += IPaddressToString(WiFi.localIP()) + "'>";
   content +=  " Return to the Main Menu  </a>";   
   
   if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
   else LocalServer.send(200, "text/html", content);  // send message to AP Webpage 
   Heartbeat_Tick();   // Feed the HW watchdog!
   if(RemoteDataSendEnable[0] == true) PushMQTT_RelayStatusMessage(0);
   if(RemoteDataSendEnable[1] == true) PushMQTT_RelayStatusMessage(1);
   if(RemoteDataSendEnable[2] == true) PushMQTT_RelayStatusMessage(2);
   if(RemoteDataSendEnable[3] == true) PushMQTT_RelayStatusMessage(3);
   if(RemoteDataSendEnable[4] == true) PushMQTT_RelayStatusMessage(4);   
 }   // end of void WebSwitchRelay2()    // Manual switching of relay 2
  // ----------------------------------------------------------------------- 
void WebSwitchRelay1()    // Manual switching of relay 1
{ 
   String content = "<!DOCTYPE HTML> \r\n<html>";          
   if(digitalRead(RelayPin[0]) == RelayOff) 
   {
     content += "<br>Control Relay 1 (";
     content += RelayDescriptors[0] + ") switched ON";   
     Activate_Relay(0, RelayOn, true);     
   }
   else
   {
     content += "<br>Control Relay 1 (";
     content += RelayDescriptors[0] + ") switched Off";   
     Activate_Relay(0, RelayOff, true);     
   }
   content += "<br><br><a href='http://";           
   if(AccessPointRunning) content += "192.168.8.200'>"; else content += IPaddressToString(WiFi.localIP()) + "'>";
   content +=  " Return to the Main Menu  </a>";   
   if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
   else LocalServer.send(200, "text/html", content);  // send message to AP Webpage 
   Heartbeat_Tick();   // Feed the HW watchdog! 
   if(RemoteDataSendEnable[0] == true) PushMQTT_RelayStatusMessage(0);
   if(RemoteDataSendEnable[1] == true) PushMQTT_RelayStatusMessage(1);
   if(RemoteDataSendEnable[2] == true) PushMQTT_RelayStatusMessage(2);
   if(RemoteDataSendEnable[3] == true) PushMQTT_RelayStatusMessage(3);
   if(RemoteDataSendEnable[4] == true) PushMQTT_RelayStatusMessage(4);
}   // end of void WebSwitchRelay1()    // Manual switching of relay 1
  // ---------------------------------------------------------------------  
void Relay3TimerControl()   // Relay 3 Timer control configuration page
{
    String qRelay3_Timer1_Sun;
    String qRelay3_Timer1_Mon;   
    String qRelay3_Timer1_Tue;
    String qRelay3_Timer1_Wed;   
    String qRelay3_Timer1_Thu;
    String qRelay3_Timer1_Fri;   
    String qRelay3_Timer1_Sat;  

    String qRelay3_Timer2_Sun;
    String qRelay3_Timer2_Mon;   
    String qRelay3_Timer2_Tue;
    String qRelay3_Timer2_Wed;   
    String qRelay3_Timer2_Thu;
    String qRelay3_Timer2_Fri;   
    String qRelay3_Timer2_Sat;
      
    String qRelay3_TIM_1_ON; 
    String qRelay3_TIM_1_OFF;
    String qRelay3_TIM_2_ON;
    String qRelay3_TIM_2_OFF;   

    String qRelay3_Timer1_Mode;
    String qRelay3_Timer2_Mode;  
    
    if(AccessPointRunning)
    {
      qRelay3_Timer1_Sun = serverAP.arg("Relay3_Timer1_Sunday");
      qRelay3_Timer1_Mon = serverAP.arg("Relay3_Timer1_Monday");   
      qRelay3_Timer1_Tue = serverAP.arg("Relay3_Timer1_Tuesday");
      qRelay3_Timer1_Wed = serverAP.arg("Relay3_Timer1_Wednesday");   
      qRelay3_Timer1_Thu = serverAP.arg("Relay3_Timer1_Thursday");
      qRelay3_Timer1_Fri = serverAP.arg("Relay3_Timer1_Friday");   
      qRelay3_Timer1_Sat = serverAP.arg("Relay3_Timer1_Saturday");  
      qRelay3_Timer2_Sun = serverAP.arg("Relay3_Timer2_Sunday");
      qRelay3_Timer2_Mon = serverAP.arg("Relay3_Timer2_Monday");   
      qRelay3_Timer2_Tue = serverAP.arg("Relay3_Timer2_Tuesday");
      qRelay3_Timer2_Wed = serverAP.arg("Relay3_Timer2_Wednesday");   
      qRelay3_Timer2_Thu = serverAP.arg("Relay3_Timer2_Thursday");
      qRelay3_Timer2_Fri = serverAP.arg("Relay3_Timer2_Friday");   
      qRelay3_Timer2_Sat = serverAP.arg("Relay3_Timer2_Saturday");     
      qRelay3_TIM_1_ON = serverAP.arg("Relay3_Timer_1_ON"); 
      qRelay3_TIM_1_OFF = serverAP.arg("Relay3_Timer_1_OFF");
      qRelay3_TIM_2_ON = serverAP.arg("Relay3_Timer_2_ON");
      qRelay3_TIM_2_OFF = serverAP.arg("Relay3_Timer_2_OFF");   
      qRelay3_Timer1_Mode = serverAP.arg("Relay3_Timer1_Mode");
      qRelay3_Timer2_Mode = serverAP.arg("Relay3_Timer2_Mode"); 
    }
    else
    {
      qRelay3_Timer1_Sun = LocalServer.arg("Relay3_Timer1_Sunday");
      qRelay3_Timer1_Mon = LocalServer.arg("Relay3_Timer1_Monday");   
      qRelay3_Timer1_Tue = LocalServer.arg("Relay3_Timer1_Tuesday");
      qRelay3_Timer1_Wed = LocalServer.arg("Relay3_Timer1_Wednesday");   
      qRelay3_Timer1_Thu = LocalServer.arg("Relay3_Timer1_Thursday");
      qRelay3_Timer1_Fri = LocalServer.arg("Relay3_Timer1_Friday");   
      qRelay3_Timer1_Sat = LocalServer.arg("Relay3_Timer1_Saturday");  
      qRelay3_Timer2_Sun = LocalServer.arg("Relay3_Timer2_Sunday");
      qRelay3_Timer2_Mon = LocalServer.arg("Relay3_Timer2_Monday");   
      qRelay3_Timer2_Tue = LocalServer.arg("Relay3_Timer2_Tuesday");
      qRelay3_Timer2_Wed = LocalServer.arg("Relay3_Timer2_Wednesday");   
      qRelay3_Timer2_Thu = LocalServer.arg("Relay3_Timer2_Thursday");
      qRelay3_Timer2_Fri = LocalServer.arg("Relay3_Timer2_Friday");   
      qRelay3_Timer2_Sat = LocalServer.arg("Relay3_Timer2_Saturday");      
      qRelay3_TIM_1_ON = LocalServer.arg("Relay3_Timer_1_ON"); 
      qRelay3_TIM_1_OFF = LocalServer.arg("Relay3_Timer_1_OFF");
      qRelay3_TIM_2_ON = LocalServer.arg("Relay3_Timer_2_ON");
      qRelay3_TIM_2_OFF = LocalServer.arg("Relay3_Timer_2_OFF");   
      qRelay3_Timer1_Mode = LocalServer.arg("Relay3_Timer1_Mode");
      qRelay3_Timer2_Mode = LocalServer.arg("Relay3_Timer2_Mode");      
    }
    String content;
    content = "<!DOCTYPE HTML> \r\n<html>";
    content = "<!DOCTYPE HTML> \r\n<html>";
    content += "<head> <style>";  
    content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
    content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
    content += "</style></head><body>";     
    EEPROM.write(EEPROM_Relay3_Timer1_TimOn_Min,Get_Decimal_Mins_From_Web_Time_Value(qRelay3_TIM_1_ON) ); 
    EEPROM.write(EEPROM_Relay3_Timer1_TimOn_Hrs,Get_Decimal_Hours_From_Web_Time_Value(qRelay3_TIM_1_ON));             
    EEPROM.write(EEPROM_Relay3_Timer1_TimOff_Min,Get_Decimal_Mins_From_Web_Time_Value(qRelay3_TIM_1_OFF) ); 
    EEPROM.write(EEPROM_Relay3_Timer1_TimOff_Hrs,Get_Decimal_Hours_From_Web_Time_Value(qRelay3_TIM_1_OFF)); 
      
    if (qRelay3_Timer1_Sun == "1") EEPROM.write(EEPROM_Relay3_Timer1_Sun,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Sun,false);
    
    if (qRelay3_Timer1_Mon == "2") EEPROM.write(EEPROM_Relay3_Timer1_Mon,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Mon,false);
    
    if (qRelay3_Timer1_Tue == "3") EEPROM.write(EEPROM_Relay3_Timer1_Tue,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Tue,false);
    
    if (qRelay3_Timer1_Wed == "4") EEPROM.write(EEPROM_Relay3_Timer1_Wed,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Wed,false);
    
    if (qRelay3_Timer1_Thu == "5") EEPROM.write(EEPROM_Relay3_Timer1_Thu,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Thu,false);
    
    if (qRelay3_Timer1_Fri == "6") EEPROM.write(EEPROM_Relay3_Timer1_Fri,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Fri,false);
    
    if (qRelay3_Timer1_Sat == "7") EEPROM.write(EEPROM_Relay3_Timer1_Sat,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Sat,false);

    // TIMER 2    
    EEPROM.write(EEPROM_Relay3_Timer2_TimOn_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay3_TIM_2_ON)); 
    EEPROM.write(EEPROM_Relay3_Timer2_TimOn_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay3_TIM_2_ON));           
    EEPROM.write(EEPROM_Relay3_Timer2_TimOff_Min,Get_Decimal_Mins_From_Web_Time_Value(qRelay3_TIM_2_OFF) ); 
    EEPROM.write(EEPROM_Relay3_Timer2_TimOff_Hrs,Get_Decimal_Hours_From_Web_Time_Value(qRelay3_TIM_2_OFF)); 
    
    if (qRelay3_Timer2_Sun == "1") EEPROM.write(EEPROM_Relay3_Timer2_Sun,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Sun,false);
    
    if (qRelay3_Timer2_Mon == "2") EEPROM.write(EEPROM_Relay3_Timer2_Mon,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Mon,false);
    
    if (qRelay3_Timer2_Tue == "3") EEPROM.write(EEPROM_Relay3_Timer2_Tue,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Tue,false);
    
    if (qRelay3_Timer2_Wed == "4") EEPROM.write(EEPROM_Relay3_Timer2_Wed,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Wed,false);
    
    if (qRelay3_Timer2_Thu == "5") EEPROM.write(EEPROM_Relay3_Timer2_Thu,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Thu,false);
    
    if (qRelay3_Timer2_Fri == "6") EEPROM.write(EEPROM_Relay3_Timer2_Fri,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Fri,false);
    
    if (qRelay3_Timer2_Sat == "7") EEPROM.write(EEPROM_Relay3_Timer2_Sat,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Sat,false);
    
    if (qRelay3_Timer1_Mode == "0") 
    {
      EEPROM.write(EEPROM_TimerEnableRelay3Timer1,false); 
      if (TimerActive[2][0])
      {
        TimerActive[2][0] = false;   // turn off timer if running
        Activate_Relay(2, RelayOff, false);  // turn off relay if on
      }      
    }
    if (qRelay3_Timer1_Mode == "1") EEPROM.write(EEPROM_TimerEnableRelay3Timer1,true);  
    if (qRelay3_Timer2_Mode == "0") 
    {
      EEPROM.write(EEPROM_TimerEnableRelay3Timer2,false); 
      if (TimerActive[2][1])
      {
        TimerActive[2][1] = false;   // turn off timer if running
        Activate_Relay(2, RelayOff, false);  // turn off relay if on
      }     
    }
    if (qRelay3_Timer2_Mode == "1") EEPROM.write(EEPROM_TimerEnableRelay3Timer2,true);       
    
    EEPROM.commit();
    Download_From_EEPROM_Timer_Control_Parameters(false);   
    Success_Message(false);  // Upload success message to AP Web page 
    Heartbeat_Tick();   // Feed the HW watchdog!      
}     // end of void Relay3TimerControl()   // Relay 3 Timer control configuration page
  // ------------------------------------------------------------------------------------------- 
void Relay2TimerControl()    // Relay 2 Timer control configuration page
{
    String qRelay2_Timer1_Sun;
    String qRelay2_Timer1_Mon;   
    String qRelay2_Timer1_Tue;
    String qRelay2_Timer1_Wed;   
    String qRelay2_Timer1_Thu;
    String qRelay2_Timer1_Fri;   
    String qRelay2_Timer1_Sat;  
    String qRelay2_Timer2_Sun;
    String qRelay2_Timer2_Mon;   
    String qRelay2_Timer2_Tue;
    String qRelay2_Timer2_Wed;   
    String qRelay2_Timer2_Thu;
    String qRelay2_Timer2_Fri;   
    String qRelay2_Timer2_Sat;     
    String qRelay2_TIM_1_ON; 
    String qRelay2_TIM_1_OFF;
    String qRelay2_TIM_2_ON;
    String qRelay2_TIM_2_OFF;     
    String qRelay2_Timer1_Mode;
    String qRelay2_Timer2_Mode;

    if(AccessPointRunning)
    {   
       qRelay2_Timer1_Sun = serverAP.arg("Relay2_Timer1_Sunday");
       qRelay2_Timer1_Mon = serverAP.arg("Relay2_Timer1_Monday");   
       qRelay2_Timer1_Tue = serverAP.arg("Relay2_Timer1_Tuesday");
       qRelay2_Timer1_Wed = serverAP.arg("Relay2_Timer1_Wednesday");   
       qRelay2_Timer1_Thu = serverAP.arg("Relay2_Timer1_Thursday");
       qRelay2_Timer1_Fri = serverAP.arg("Relay2_Timer1_Friday");   
       qRelay2_Timer1_Sat = serverAP.arg("Relay2_Timer1_Saturday");  
       qRelay2_Timer2_Sun = serverAP.arg("Relay2_Timer2_Sunday");
       qRelay2_Timer2_Mon = serverAP.arg("Relay2_Timer2_Monday");   
       qRelay2_Timer2_Tue = serverAP.arg("Relay2_Timer2_Tuesday");
       qRelay2_Timer2_Wed = serverAP.arg("Relay2_Timer2_Wednesday");   
       qRelay2_Timer2_Thu = serverAP.arg("Relay2_Timer2_Thursday");
       qRelay2_Timer2_Fri = serverAP.arg("Relay2_Timer2_Friday");   
       qRelay2_Timer2_Sat = serverAP.arg("Relay2_Timer2_Saturday");     
       qRelay2_TIM_1_ON = serverAP.arg("Relay2_Timer_1_ON"); 
       qRelay2_TIM_1_OFF = serverAP.arg("Relay2_Timer_1_OFF");
       qRelay2_TIM_2_ON = serverAP.arg("Relay2_Timer_2_ON");
       qRelay2_TIM_2_OFF = serverAP.arg("Relay2_Timer_2_OFF");     
       qRelay2_Timer1_Mode = serverAP.arg("Relay2_Timer1_Mode");
       qRelay2_Timer2_Mode = serverAP.arg("Relay2_Timer2_Mode");
    }
    else
    {   
       qRelay2_Timer1_Sun = LocalServer.arg("Relay2_Timer1_Sunday");
       qRelay2_Timer1_Mon = LocalServer.arg("Relay2_Timer1_Monday");   
       qRelay2_Timer1_Tue = LocalServer.arg("Relay2_Timer1_Tuesday");
       qRelay2_Timer1_Wed = LocalServer.arg("Relay2_Timer1_Wednesday");   
       qRelay2_Timer1_Thu = LocalServer.arg("Relay2_Timer1_Thursday");
       qRelay2_Timer1_Fri = LocalServer.arg("Relay2_Timer1_Friday");   
       qRelay2_Timer1_Sat = LocalServer.arg("Relay2_Timer1_Saturday");  
       qRelay2_Timer2_Sun = LocalServer.arg("Relay2_Timer2_Sunday");
       qRelay2_Timer2_Mon = LocalServer.arg("Relay2_Timer2_Monday");   
       qRelay2_Timer2_Tue = LocalServer.arg("Relay2_Timer2_Tuesday");
       qRelay2_Timer2_Wed = LocalServer.arg("Relay2_Timer2_Wednesday");   
       qRelay2_Timer2_Thu = LocalServer.arg("Relay2_Timer2_Thursday");
       qRelay2_Timer2_Fri = LocalServer.arg("Relay2_Timer2_Friday");   
       qRelay2_Timer2_Sat = LocalServer.arg("Relay2_Timer2_Saturday");      
       qRelay2_TIM_1_ON = LocalServer.arg("Relay2_Timer_1_ON"); 
       qRelay2_TIM_1_OFF = LocalServer.arg("Relay2_Timer_1_OFF");
       qRelay2_TIM_2_ON = LocalServer.arg("Relay2_Timer_2_ON");
       qRelay2_TIM_2_OFF = LocalServer.arg("Relay2_Timer_2_OFF");     
       qRelay2_Timer1_Mode = LocalServer.arg("Relay2_Timer1_Mode");
       qRelay2_Timer2_Mode = LocalServer.arg("Relay2_Timer2_Mode");
    }    
      
    String content;
    content = "<!DOCTYPE HTML> \r\n<html>";
    content = "<!DOCTYPE HTML> \r\n<html>";
    content += "<head> <style>";  
    content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
    content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
    content += "</style></head><body>";  
    EEPROM.write(EEPROM_Relay2_Timer1_TimOn_Min,Get_Decimal_Mins_From_Web_Time_Value(qRelay2_TIM_1_ON)); 
    EEPROM.write(EEPROM_Relay2_Timer1_TimOn_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay2_TIM_1_ON));       
    EEPROM.write(EEPROM_Relay2_Timer1_TimOff_Min,Get_Decimal_Mins_From_Web_Time_Value(qRelay2_TIM_1_OFF) ); 
    EEPROM.write(EEPROM_Relay2_Timer1_TimOff_Hrs,Get_Decimal_Hours_From_Web_Time_Value(qRelay2_TIM_1_OFF)); 

    if (qRelay2_Timer1_Sun == "1") EEPROM.write(EEPROM_Relay2_Timer1_Sun,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Sun,false);
    
    if (qRelay2_Timer1_Mon == "2") EEPROM.write(EEPROM_Relay2_Timer1_Mon,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Mon,false);
    
    if (qRelay2_Timer1_Tue == "3") EEPROM.write(EEPROM_Relay2_Timer1_Tue,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Tue,false);
  
    if (qRelay2_Timer1_Wed == "4") EEPROM.write(EEPROM_Relay2_Timer1_Wed,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Wed,false);
    
    if (qRelay2_Timer1_Thu == "5") EEPROM.write(EEPROM_Relay2_Timer1_Thu,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Thu,false);
    
    if (qRelay2_Timer1_Fri == "6") EEPROM.write(EEPROM_Relay2_Timer1_Fri,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Fri,false);
    
    if (qRelay2_Timer1_Sat == "7") EEPROM.write(EEPROM_Relay2_Timer1_Sat,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Sat,false);
   
    // TIMER 2
    EEPROM.write(EEPROM_Relay2_Timer2_TimOn_Min,Get_Decimal_Mins_From_Web_Time_Value(qRelay2_TIM_2_ON) ); 
    EEPROM.write(EEPROM_Relay2_Timer2_TimOn_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay2_TIM_2_ON));            
    EEPROM.write(EEPROM_Relay2_Timer2_TimOff_Min,Get_Decimal_Mins_From_Web_Time_Value(qRelay2_TIM_2_OFF) ); 
    EEPROM.write(EEPROM_Relay2_Timer2_TimOff_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay2_TIM_2_OFF)); 
   
    if (qRelay2_Timer2_Sun == "1") EEPROM.write(EEPROM_Relay2_Timer2_Sun,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Sun,false);
    
    if (qRelay2_Timer2_Mon == "2") EEPROM.write(EEPROM_Relay2_Timer2_Mon,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Mon,false);

    if (qRelay2_Timer2_Tue == "3") EEPROM.write(EEPROM_Relay2_Timer2_Tue,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Tue,false);

    if (qRelay2_Timer2_Wed == "4") EEPROM.write(EEPROM_Relay2_Timer2_Wed,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Wed,false);

    if (qRelay2_Timer2_Thu == "5") EEPROM.write(EEPROM_Relay2_Timer2_Thu,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Thu,false);

    if (qRelay2_Timer2_Fri == "6") EEPROM.write(EEPROM_Relay2_Timer2_Fri,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Fri,false);

    if (qRelay2_Timer2_Sat == "7") EEPROM.write(EEPROM_Relay2_Timer2_Sat,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Sat,false);
      
    if (qRelay2_Timer1_Mode == "0") 
    {
      EEPROM.write(EEPROM_TimerEnableRelay2Timer1,false); 
      if (TimerActive[1][0])
      {
        TimerActive[1][0] = false;   // turn off timer if running
        Activate_Relay(1, RelayOff, false);  // turn off relay if on
      }     
    }
    if (qRelay2_Timer1_Mode == "1") EEPROM.write(EEPROM_TimerEnableRelay2Timer1,true);  
    if (qRelay2_Timer2_Mode == "0") 
    {
      EEPROM.write(EEPROM_TimerEnableRelay2Timer2,false); 
      if (TimerActive[1][1])
      {
        TimerActive[1][1] = false;   // turn off timer if running
        Activate_Relay(1, RelayOff, false);  // turn off relay if on
      }      
    }
    if (qRelay2_Timer2_Mode == "1") EEPROM.write(EEPROM_TimerEnableRelay2Timer2,true); 

    EEPROM.commit();
    Download_From_EEPROM_Timer_Control_Parameters(false);
    Success_Message(false);  // Upload success message to AP web page
    Heartbeat_Tick();   // Feed the HW watchdog!       
}   // end of void Relay2TimerControl()    // Relay 2 Timer control configuration page
// --------------------------------------------------------------------------
void Relay1TimerControl()   // Relay 1 Timer control configuration page
{
    String qRelay1_Timer1_Sun;
    String qRelay1_Timer1_Mon;   
    String qRelay1_Timer1_Tue;
    String qRelay1_Timer1_Wed;   
    String qRelay1_Timer1_Thu;
    String qRelay1_Timer1_Fri;   
    String qRelay1_Timer1_Sat;  
    String qRelay1_Timer2_Sun;
    String qRelay1_Timer2_Mon;   
    String qRelay1_Timer2_Tue;
    String qRelay1_Timer2_Wed;   
    String qRelay1_Timer2_Thu;
    String qRelay1_Timer2_Fri;   
    String qRelay1_Timer2_Sat;      
    String qRelay1_TIM_1_ON; 
    String qRelay1_TIM_1_OFF;
    String qRelay1_TIM_2_ON;
    String qRelay1_TIM_2_OFF;      
    String qRelay1_Timer1_Mode;
    String qRelay1_Timer2_Mode; 

    if(AccessPointRunning)
    {
       qRelay1_Timer1_Sun = serverAP.arg("Relay1_Timer1_Sunday");
       qRelay1_Timer1_Mon = serverAP.arg("Relay1_Timer1_Monday");   
       qRelay1_Timer1_Tue = serverAP.arg("Relay1_Timer1_Tuesday");
       qRelay1_Timer1_Wed = serverAP.arg("Relay1_Timer1_Wednesday");   
       qRelay1_Timer1_Thu = serverAP.arg("Relay1_Timer1_Thursday");
       qRelay1_Timer1_Fri = serverAP.arg("Relay1_Timer1_Friday");   
       qRelay1_Timer1_Sat = serverAP.arg("Relay1_Timer1_Saturday");  
       qRelay1_Timer2_Sun = serverAP.arg("Relay1_Timer2_Sunday");
       qRelay1_Timer2_Mon = serverAP.arg("Relay1_Timer2_Monday");   
       qRelay1_Timer2_Tue = serverAP.arg("Relay1_Timer2_Tuesday");
       qRelay1_Timer2_Wed = serverAP.arg("Relay1_Timer2_Wednesday");   
       qRelay1_Timer2_Thu = serverAP.arg("Relay1_Timer2_Thursday");
       qRelay1_Timer2_Fri = serverAP.arg("Relay1_Timer2_Friday");   
       qRelay1_Timer2_Sat = serverAP.arg("Relay1_Timer2_Saturday");      
       qRelay1_TIM_1_ON = serverAP.arg("Relay1_Timer_1_ON"); 
       qRelay1_TIM_1_OFF = serverAP.arg("Relay1_Timer_1_OFF");
       qRelay1_TIM_2_ON = serverAP.arg("Relay1_Timer_2_ON");
       qRelay1_TIM_2_OFF = serverAP.arg("Relay1_Timer_2_OFF");      
       qRelay1_Timer1_Mode = serverAP.arg("Relay1_Timer1_Mode");
       qRelay1_Timer2_Mode = serverAP.arg("Relay1_Timer2_Mode"); 
    }
    else
    {
       qRelay1_Timer1_Sun = LocalServer.arg("Relay1_Timer1_Sunday");
       qRelay1_Timer1_Mon = LocalServer.arg("Relay1_Timer1_Monday");   
       qRelay1_Timer1_Tue = LocalServer.arg("Relay1_Timer1_Tuesday");
       qRelay1_Timer1_Wed = LocalServer.arg("Relay1_Timer1_Wednesday");   
       qRelay1_Timer1_Thu = LocalServer.arg("Relay1_Timer1_Thursday");
       qRelay1_Timer1_Fri = LocalServer.arg("Relay1_Timer1_Friday");   
       qRelay1_Timer1_Sat = LocalServer.arg("Relay1_Timer1_Saturday");  
       qRelay1_Timer2_Sun = LocalServer.arg("Relay1_Timer2_Sunday");
       qRelay1_Timer2_Mon = LocalServer.arg("Relay1_Timer2_Monday");   
       qRelay1_Timer2_Tue = LocalServer.arg("Relay1_Timer2_Tuesday");
       qRelay1_Timer2_Wed = LocalServer.arg("Relay1_Timer2_Wednesday");   
       qRelay1_Timer2_Thu = LocalServer.arg("Relay1_Timer2_Thursday");
       qRelay1_Timer2_Fri = LocalServer.arg("Relay1_Timer2_Friday");   
       qRelay1_Timer2_Sat = LocalServer.arg("Relay1_Timer2_Saturday");     
       qRelay1_TIM_1_ON = LocalServer.arg("Relay1_Timer_1_ON"); 
       qRelay1_TIM_1_OFF = LocalServer.arg("Relay1_Timer_1_OFF");
       qRelay1_TIM_2_ON = LocalServer.arg("Relay1_Timer_2_ON");
       qRelay1_TIM_2_OFF = LocalServer.arg("Relay1_Timer_2_OFF");       
       qRelay1_Timer1_Mode = LocalServer.arg("Relay1_Timer1_Mode");
       qRelay1_Timer2_Mode = LocalServer.arg("Relay1_Timer2_Mode"); 
    }            
    EEPROM.write(EEPROM_Relay1_Timer1_TimOn_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay1_TIM_1_ON) ); 
    EEPROM.write(EEPROM_Relay1_Timer1_TimOn_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay1_TIM_1_ON));          
    EEPROM.write(EEPROM_Relay1_Timer1_TimOff_Min,Get_Decimal_Mins_From_Web_Time_Value(qRelay1_TIM_1_OFF) ); 
    EEPROM.write(EEPROM_Relay1_Timer1_TimOff_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay1_TIM_1_OFF));     
    String content;
    content = "<!DOCTYPE HTML> \r\n<html>";
    content = "<!DOCTYPE HTML> \r\n<html>";
    content += "<head> <style>";  
    content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
    content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
    content += "</style></head><body>"; 
    content += "<br><br>Relay 1 Timer 1 days";           
    if (qRelay1_Timer1_Sun == "1") EEPROM.write(EEPROM_Relay1_Timer1_Sun,true);
    else EEPROM.write(EEPROM_Relay1_Timer1_Sun,false);
    if (qRelay1_Timer1_Mon == "2") EEPROM.write(EEPROM_Relay1_Timer1_Mon,true); 
    else EEPROM.write(EEPROM_Relay1_Timer1_Mon,false);
    if (qRelay1_Timer1_Tue == "3") EEPROM.write(EEPROM_Relay1_Timer1_Tue,true);
    else EEPROM.write(EEPROM_Relay1_Timer1_Tue,false);
    if (qRelay1_Timer1_Wed == "4") EEPROM.write(EEPROM_Relay1_Timer1_Wed,true);      
    else EEPROM.write(EEPROM_Relay1_Timer1_Wed,false);
    if (qRelay1_Timer1_Thu == "5") EEPROM.write(EEPROM_Relay1_Timer1_Thu,true);
    else EEPROM.write(EEPROM_Relay1_Timer1_Thu,false);       
    if (qRelay1_Timer1_Fri == "6") EEPROM.write(EEPROM_Relay1_Timer1_Fri,true);
    else EEPROM.write(EEPROM_Relay1_Timer1_Fri,false);   
    if (qRelay1_Timer1_Sat == "7") EEPROM.write(EEPROM_Relay1_Timer1_Sat,true);                   
    else EEPROM.write(EEPROM_Relay1_Timer1_Sat,false);    
    
    // TIMER 2   
    EEPROM.write(EEPROM_Relay1_Timer2_TimOn_Min,Get_Decimal_Mins_From_Web_Time_Value(qRelay1_TIM_2_ON) ); 
    EEPROM.write(EEPROM_Relay1_Timer2_TimOn_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay1_TIM_2_ON));             
    EEPROM.write(EEPROM_Relay1_Timer2_TimOff_Min,Get_Decimal_Mins_From_Web_Time_Value(qRelay1_TIM_2_OFF) ); 
    EEPROM.write(EEPROM_Relay1_Timer2_TimOff_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay1_TIM_2_OFF)); 
         
    if (qRelay1_Timer2_Sun == "1") EEPROM.write(EEPROM_Relay1_Timer2_Sun,true);
    else EEPROM.write(EEPROM_Relay1_Timer2_Sun,false);    
    if (qRelay1_Timer2_Mon == "2") EEPROM.write(EEPROM_Relay1_Timer2_Mon,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Mon,false);     
    if (qRelay1_Timer2_Tue == "3") EEPROM.write(EEPROM_Relay1_Timer2_Tue,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Tue,false);     
    if (qRelay1_Timer2_Wed == "4") EEPROM.write(EEPROM_Relay1_Timer2_Wed,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Wed,false);     
    if (qRelay1_Timer2_Thu == "5") EEPROM.write(EEPROM_Relay1_Timer2_Thu,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Thu,false);     
    if (qRelay1_Timer2_Fri == "6") EEPROM.write(EEPROM_Relay1_Timer2_Fri,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Fri,false);    
    if (qRelay1_Timer2_Sat == "7") EEPROM.write(EEPROM_Relay1_Timer2_Sat,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Sat,false);
    
    if (qRelay1_Timer1_Mode == "0") 
    {
      EEPROM.write(EEPROM_TimerEnableRelay1Timer1,false); 
      if (TimerActive[0][0])
      {
        TimerActive[0][0] = false;   // turn off timer if running
        Activate_Relay(0, RelayOff, false);  // turn off relay if on
      }
    }
    if (qRelay1_Timer1_Mode == "1") EEPROM.write(EEPROM_TimerEnableRelay1Timer1,true);  
    if (qRelay1_Timer2_Mode == "0") 
    {
      EEPROM.write(EEPROM_TimerEnableRelay1Timer2,false); 
      if (TimerActive[0][1])
      {
        TimerActive[0][1] = false;   // turn off timer if running
        Activate_Relay(0, RelayOff, false);  // turn off relay if on
      }         
    }
    if (qRelay1_Timer2_Mode == "1") EEPROM.write(EEPROM_TimerEnableRelay1Timer2,true);  
            
    EEPROM.commit();
    Download_From_EEPROM_Timer_Control_Parameters(false);   
    Success_Message(false);  // Upload success message to AP web page
    Heartbeat_Tick();   // Feed the HW watchdog! 
}   // end of void Relay1TimerControl()   // Relay 1 Timer control configuration page
// -----------------------------------------------------------------------------------
void WiFiConfiguration()  // Wifi Configuration page
{
        boolean EEPROM_Lock = false; 
        String qsid = serverAP.arg("ssid");   // check input from web page when submitted
        String qpass = serverAP.arg("pass");
        String qname = serverAP.arg("name");
        String qWiFiManualEnable = serverAP.arg("WiFiManualEnable");            
        String qpassAP = serverAP.arg("passAP");
        String qStatic_IP = serverAP.arg("Static_IP");
        String qGateway_IP = serverAP.arg("Gateway_IP");
        String qSubnet_IP = serverAP.arg("Subnet_IP");
        String qRouterModeSelect = serverAP.arg("RouterModeSelect");
             
// -------------------- Process Router Mode ZSelect ----------------------------
          if(qRouterModeSelect == "DHCP" && RouterMode == StaticIP)
          {
            RouterMode = DHCP;
            EEPROM.write (EEPROM_RouterMode, RouterMode);
            EEPROM_Lock = true; 
          }
          else if(qRouterModeSelect == "StaticIP" && RouterMode == DHCP)
          {
            RouterMode = StaticIP;
            EEPROM.write (EEPROM_RouterMode, RouterMode);
            EEPROM_Lock = true; 
          }
// .................. Process Static IP  .................................       
          if (qStatic_IP.length() > 0 ) // Only if something has been entered into the SSID web field
          {
            unsigned int i=EEPROM_StaticIPAddress;
            while(i < EEPROM_StaticIPAddress + 15)  
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qStatic_IP.length())   // store new SSID to EEPROM
            {
              EEPROM.write(EEPROM_StaticIPAddress + i, qStatic_IP[i]);
              i++;
            }
            StaticIPAddress = qStatic_IP;
            EEPROM_Lock = true; 
          } // end of if (qStatic_IP.length() > 0 ) // Only if something has been entered into the SSID web field       
// .................. Gateway IP  .................................       
          if (qGateway_IP.length() > 0 ) // Only if something has been entered into the SSID web field
          {
            unsigned int i=EEPROM_GatewayIPAddress;
            while(i < EEPROM_GatewayIPAddress + 15)  
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qGateway_IP.length())   // store new SSID to EEPROM
            {
              EEPROM.write(EEPROM_GatewayIPAddress + i, qGateway_IP[i]);
              i++;
            }
            GatewayIPAddress = qGateway_IP;
            EEPROM_Lock = true; 
          } // end of if (qGateway_IP.length() > 0 ) // Only if something has been entered into the SSID web field             
// .................. Process Subnet IP  .................................       
          if (qSubnet_IP.length() > 0 ) // Only if something has been entered into the SSID web field
          {
            unsigned int i=EEPROM_SubnetIPAddress;
            while(i < EEPROM_SubnetIPAddress + 15)  
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qSubnet_IP.length())   // store new SSID to EEPROM
            {
              EEPROM.write(EEPROM_SubnetIPAddress + i, qSubnet_IP[i]);
              i++;
            }
            SubnetIPAddress = qSubnet_IP;
            EEPROM_Lock = true; 
          } // end of if (qSubnet_IP.length() > 0 )           
// .................. Process Network SSID  .................................       
          if (qsid.length() > 0 ) // Only if something has been entered into the SSID web field
          {
            unsigned int i=EEPROM_WiFi_SSID;
            while(i < EEPROM_WiFi_SSID + MaxStringLength)  // Clear out all of the previous stored entries for SSID
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qsid.length())   // store new SSID to EEPROM
            {
              EEPROM.write(EEPROM_WiFi_SSID + i, qsid[i]);
              i++;
            }
            esid = qsid;
            EEPROM_Lock = true; 
          } // end of if (qsid.length() > 0 ) // Only if something has been entered into the SSID web field            
// .................. Process Network password  .................................          
          if (qpass.length() > 0) // Only if something has been entered into the Password web field
          {    
            unsigned int i = EEPROM_WiFi_Password;
            while(i < (EEPROM_WiFi_Password + MaxStringLength))
            {
              EEPROM.write(i, 255); // Clear out all of the previous stored entries for password
              i++;
            }         
            i = 0; 
            while(i < qpass.length())  // store new password to EEPROM
            {
              EEPROM.write(EEPROM_WiFi_Password + i, qpass[i]);
              i++;
            }
            epass = qpass;
            EEPROM_Lock = true;            
          } // end of if (qpass.length() > 0) // Only if something has been entered into the Password web field                      
// ................... Process Device Name ..................................          
          if (qname.length() > 0) // Only if something has been entered into the Device name web field
          {    
            unsigned int i = EEPROM_HostName;
            while(i < (EEPROM_HostName + MaxStringLength))
            {
              EEPROM.write(i, 255); // Clear out all of the previous stored entries for password
              i++;
            }         
            i = 0; 
            while(i < qname.length())  // store new device name to EEPROM
            {
              EEPROM.write(EEPROM_HostName + i, qname[i]);
              i++;
            }
            HostName = qname;
            EEPROM_Lock = true; 
          }  // end of if (qname.length() > 0) // Only if something has been entered into the Device name web field
       //  ................. Process Wifi Enable  ......................... 
          if (qWiFiManualEnable.length() > 0 ) // Only if something has been entered into the field
          {
            if(qWiFiManualEnable == "E")   WiFiManualEnable = true; else WiFiManualEnable = false;
            EEPROM.write(EEPROM_WiFiManualEnable, WiFiManualEnable);
            EEPROM_Lock = true; 
          } // end of     if (qWifiManualEnable.length() > 0 ) // Only if something has been 
// .......................... Process AP password ...........................................
          if(qpassAP.length() > 0)
          {
            unsigned int i = EEPROM_AP_Password;
            while(i < (EEPROM_AP_Password + MaxStringLength))
            {
              EEPROM.write(i, 255); // Clear out all of the previous stored entries for password
              i++;
            }         
            i = 0; 
            while(i < qpassAP.length())  // store new password to EEPROM
            {
              EEPROM.write(EEPROM_AP_Password + i, qpassAP[i]);
              i++;
            }
            EEPROM_Lock = true;             
          }  // end of if(qpassAP > 0)  
// -----------------------------------------------------------------            
          if(EEPROM_Lock == true) EEPROM.commit();   // Lock in EEPROM changes                              
          Success_Message(false);  // Upload success message to client to AP web page 
          Heartbeat_Tick();   // Feed the HW watchdog!          
}     // end of void WiFiConfiguration()  // Wifi Configuration page
// --------------------------------------------------------------------------------------------------------------------
void Success_Message(boolean Reset)
{
  // ----------- Display after a sucessful update of any required parameter page-----------------     
  String content = "<!DOCTYPE HTML>\r\n<html><form>"; 
  content += "<br>Success: Data has been uploaded to the device";
  if(Reset) content += "<br>The device will now reset to implement the changes";
  else
  {
    content += "<br><b><i>Note that the device will need resetting ";
    content += "<br>before any new WiFi and/or Control output names";
    content += "<br>will become active</b></i><br><br><a href='http://"; 
    if(AccessPointRunning) content += "192.168.8.200'>"; 
    else     content += IPaddressToString(WiFi.localIP()) + "'>";
    content +=  " Return to the Main Menu  </a>";
  }
  content += "</form></html>";
  if(AccessPointRunning) serverAP.send(200, "text/html", content);
  else LocalServer.send(200, "text/html", content);
  delay(2000);
  if(Reset) ResetDevice("Required by Configuration page"); 
}     // end of void Success_Message(boolean Reset)
// --------------------------------------------------------------------------------------------
void EEPROMWritelong(int address, long value)
{
      //Decomposition from a long to 4 bytes by using bitshift.
      //One = Most significant -> Four = Least significant byte
      byte four = (value & 0xFF);
      byte three = ((value >> 8) & 0xFF);
      byte two = ((value >> 16) & 0xFF);
      byte one = ((value >> 24) & 0xFF);

      //Write the 4 bytes into the eeprom memory.
      EEPROM.write(address, four);
      EEPROM.write(address + 1, three);
      EEPROM.write(address + 2, two);
      EEPROM.write(address + 3, one);
}   // end of void EEPROMWritelong(int address, long value)

long EEPROMReadlong(long address)
{
      //Read the 4 bytes from the eeprom memory.
      long four = EEPROM.read(address);
      long three = EEPROM.read(address + 1);
      long two = EEPROM.read(address + 2);
      long one = EEPROM.read(address + 3);

      //Return the recomposed long by using bitshift.
      return ((four << 0) & 0xFF) + ((three << 8) & 0xFFFF) + ((two << 16) & 0xFFFFFF) + ((one << 24) & 0xFFFFFFFF);
}   // end of long EEPROMReadlong(long address)
  // --------------------------------------------------------------------------
void Download_From_EEPROM_Relay_Descriptor (byte Output_No)  // download from EEPROM to working memory
{                                                             // the text names of each relay  
  unsigned int EEPROM_Address_Offset = EEPROM_Relay_Descriptors + ((Output_No) * MaxStringLength);
  unsigned int i = EEPROM_Address_Offset;
  StoredString = "";
  while(i < EEPROM_Address_Offset + MaxStringLength)
  {   
    if (EEPROM.read(i) != 255) StoredString += char(EEPROM.read(i)); else break;
    i++; 
  }
   RelayDescriptors[Output_No] = StoredString;
}   // end of void Download_From_EEPROM_Relay_Descriptor (byte Output_No) 
// ------------------------------------------------------------
void Download_From_EEPROM_Relay_Descriptors(boolean Display)
{
  byte i= 0;
  while (i < NoOfRelays)
  {
    Download_From_EEPROM_Relay_Descriptor (i);  
    if (Display)
    {
      Serial.print( F("Output: ")); 
      Serial.print(i+1); 
      Serial.print(F(" Description = ")); 
      Serial.println(RelayDescriptors[i]);
    } // end of if (Display)
    i ++;
  }  // end of while (i < NoOfRelays) 
}  // end of void Download_From_EEPROM_Relay_Descriptors(boolean Display)
  // ------------------------------------------------------------------
void Heartbeat_Tick()   // short heatbeat tick to keep the HW watchdog alive
{
  digitalWrite(Heartbeat_LED, LED_On);
  delay(2);
  digitalWrite(Heartbeat_LED, LED_Off); 
  delay(1);   
}  // end of void Heartbeat_Tick() 
//  ---------------------------------------------------------------------
void Download_From_EEPROM_Timer_Control_Parameters(boolean Display)  // display = false = suppress Special messages
{        // download from EEPROM to working memory the timer control parameters
    const byte Timer_On = 0;
    const byte Timer_Off = 1;
    const byte Mins = 0;
    const byte Hrs = 1;
    const byte Timer1 = 0;
    const byte Timer2 = 1;
    const byte Relay1 = 0;
    const byte Relay2 = 1;
    const byte Relay3 = 2;       
     // -------------------- Relay 1 ----------------------------------------------
    byte Timer_No = 0;
    Relay1TimeControl[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay1_Timer1_TimOn_Min);
    Relay1TimeControl[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay1_Timer1_TimOn_Hrs); 
    Relay1TimeControl[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay1_Timer1_TimOff_Min); 
    Relay1TimeControl[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay1_Timer1_TimOff_Hrs); 
    LongTimer_ON[0][Timer_No] = 
      Relay1TimeControl[Timer_No][Timer_On][Mins] + (Relay1TimeControl[Timer_No][Timer_On][Hrs] * 60);   // = Timer ON in minutes [Relay1][Timer1]  
    LongTimer_OFF[0][Timer_No] = 
      Relay1TimeControl[Timer_No][Timer_Off][Mins] + (Relay1TimeControl[Timer_No][Timer_Off][Hrs] * 60);
    if(Display)
    {
      Serial.println("");
      Serial.print("Relay 1 Timer 1:");
      Serial.print("   Time On = "); Serial.print(Relay1TimeControl[Timer_No][Timer_On][Hrs]); 
      Serial.print(":"); 
      if(Relay1TimeControl[Timer_No][Timer_On][Mins] < 10) Serial.print("0"); 
      Serial.print(Relay1TimeControl[Timer_No][Timer_On][Mins]);     
      Serial.print("   Time Off = "); Serial.print(Relay1TimeControl[Timer_No][Timer_Off][Hrs]); 
      Serial.print(":"); 
      if(Relay1TimeControl[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");       
      Serial.println(Relay1TimeControl[Timer_No][Timer_Off][Mins]);       
    }       
    Timer_No = 1;
    Relay1TimeControl[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay1_Timer2_TimOn_Min); 
    Relay1TimeControl[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay1_Timer2_TimOn_Hrs); 
    Relay1TimeControl[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay1_Timer2_TimOff_Min); 
    Relay1TimeControl[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay1_Timer2_TimOff_Hrs); 
    LongTimer_ON[0][Timer_No] = 
      Relay1TimeControl[Timer_No][Timer_On][Mins] + (Relay1TimeControl[Timer_No][Timer_On][Hrs] * 60);   // = Timer ON in minutes [Relay1][Timer2]  
    LongTimer_OFF[0][Timer_No] = 
      Relay1TimeControl[Timer_No][Timer_Off][Mins] + (Relay1TimeControl[Timer_No][Timer_Off][Hrs] * 60);        
    if(Display)
    {
      Serial.print("Relay 1 Timer 2:");     
      Serial.print("   Time On = "); Serial.print(Relay1TimeControl[Timer_No][Timer_On][Hrs]); 
      Serial.print(":"); 
      if(Relay1TimeControl[Timer_No][Timer_On][Mins] < 10) Serial.print("0");      
      Serial.print(Relay1TimeControl[Timer_No][Timer_On][Mins]); 
      Serial.print("   Time Off = "); Serial.print(Relay1TimeControl[Timer_No][Timer_Off][Hrs]); 
      Serial.print(":"); 
      if(Relay1TimeControl[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");   
      Serial.println(Relay1TimeControl[Timer_No][Timer_Off][Mins]);      
    }       
    // ------------------------- Relay 2 -------------------------------------------  
    if (NoOfRelays >=2)   // only if 2 or 3 relays fitted
    {
      Timer_No = 0;
      Relay2TimeControl[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay2_Timer1_TimOn_Min); 
      Relay2TimeControl[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay2_Timer1_TimOn_Hrs);    
      Relay2TimeControl[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay2_Timer1_TimOff_Min); 
      Relay2TimeControl[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay2_Timer1_TimOff_Hrs); 
      LongTimer_ON[1][Timer_No] = 
      Relay2TimeControl[Timer_No][Timer_On][Mins] + (Relay2TimeControl[Timer_No][Timer_On][Hrs] * 60);   // = Timer ON in minutes [Relay1][Timer1]  
      LongTimer_OFF[1][Timer_No] = 
      Relay2TimeControl[Timer_No][Timer_Off][Mins] + (Relay2TimeControl[Timer_No][Timer_Off][Hrs] * 60);         
      if(Display)
      {
        Serial.print("Relay 2 Timer 1:");
        Serial.print("   Time On = "); Serial.print(Relay2TimeControl[Timer_No][Timer_On][Hrs]); 
        Serial.print(":"); 
        if(Relay2TimeControl[Timer_No][Timer_On][Mins] < 10) Serial.print("0");       
        Serial.print(Relay2TimeControl[Timer_No][Timer_On][Mins]);     
        Serial.print("   Time Off = "); Serial.print(Relay2TimeControl[Timer_No][Timer_Off][Hrs]); 
        Serial.print(":"); 
        if(Relay2TimeControl[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");        
        Serial.println(Relay2TimeControl[Timer_No][Timer_Off][Mins]); 
      }       
      Timer_No = 1;;
      Relay2TimeControl[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay2_Timer2_TimOn_Min); 
      Relay2TimeControl[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay2_Timer2_TimOn_Hrs); 
      Relay2TimeControl[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay2_Timer2_TimOff_Min); 
      Relay2TimeControl[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay2_Timer2_TimOff_Hrs); 
      LongTimer_ON[1][Timer_No] = 
      Relay2TimeControl[Timer_No][Timer_On][Mins] + (Relay2TimeControl[Timer_No][Timer_On][Hrs] * 60);   // = Timer ON in minutes [Relay1][Timer1]  
      LongTimer_OFF[1][Timer_No] = 
      Relay2TimeControl[Timer_No][Timer_Off][Mins] + (Relay2TimeControl[Timer_No][Timer_Off][Hrs] * 60);         
      if (Display)
      {
        Serial.print("Relay 2 Timer 2:");    
        Serial.print("   Time On = "); Serial.print(Relay2TimeControl[Timer_No][Timer_On][Hrs]); 
        Serial.print(":"); 
        if(Relay2TimeControl[Timer_No][Timer_On][Mins] < 10) Serial.print("0");        
        Serial.print(Relay2TimeControl[Timer_No][Timer_On][Mins]); 
        Serial.print("   Time Off = "); Serial.print(Relay2TimeControl[Timer_No][Timer_Off][Hrs]); 
        Serial.print(":"); 
        if(Relay2TimeControl[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");        
        Serial.println(Relay2TimeControl[Timer_No][Timer_Off][Mins]);     
      }
    } // end of if (NoOfRelays >=2)    
    // ---------------------- Relay 3 -----------------------------------------   
    if (NoOfRelays == 3)       // only if 3 relays fitted
    {
      Timer_No = 0;  
      Relay3TimeControl[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay3_Timer1_TimOn_Min); 
      Relay3TimeControl[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay3_Timer1_TimOn_Hrs); 
      Relay3TimeControl[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay3_Timer1_TimOff_Min); 
      Relay3TimeControl[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay3_Timer1_TimOff_Hrs); 
      LongTimer_ON[2][Timer_No] = 
      Relay3TimeControl[Timer_No][Timer_On][Mins] + (Relay3TimeControl[Timer_No][Timer_On][Hrs] * 60);   // = Timer ON in minutes [Relay1][Timer1]  
      LongTimer_OFF[2][Timer_No] = 
      Relay3TimeControl[Timer_No][Timer_Off][Mins] + (Relay3TimeControl[Timer_No][Timer_Off][Hrs] * 60);        
      if(Display)
      {
        Serial.print("Relay 3 Timer 1:"); 
        Serial.print("   Time On = "); Serial.print(Relay3TimeControl[Timer_No][Timer_On][Hrs]); 
        Serial.print(":"); 
        if(Relay3TimeControl[Timer_No][Timer_On][Mins] < 10) Serial.print("0");        
        Serial.print(Relay3TimeControl[Timer_No][Timer_On][Mins]);        
        Serial.print("   Time Off = "); Serial.print(Relay3TimeControl[Timer_No][Timer_Off][Hrs]); 
        Serial.print(":"); 
        if(Relay3TimeControl[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");       
        Serial.println(Relay3TimeControl[Timer_No][Timer_Off][Mins]);            
      }    
      Timer_No = 1;;
      Relay3TimeControl[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay3_Timer2_TimOn_Min); 
      Relay3TimeControl[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay3_Timer2_TimOn_Hrs);    
      Relay3TimeControl[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay3_Timer2_TimOff_Min); 
      Relay3TimeControl[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay3_Timer2_TimOff_Hrs);    
      LongTimer_ON[2][Timer_No] = 
      Relay3TimeControl[Timer_No][Timer_On][Mins] + (Relay3TimeControl[Timer_No][Timer_On][Hrs] * 60);   // = Timer ON in minutes [Relay1][Timer1]  
      LongTimer_OFF[2][Timer_No] = 
      Relay3TimeControl[Timer_No][Timer_Off][Mins] + (Relay3TimeControl[Timer_No][Timer_Off][Hrs] * 60);      
   // ------------------------------------------------------------------------------
      if(Display)
      {
        Serial.print("Relay 3 Timer 2:");
        Serial.print("   Time On = "); Serial.print(Relay3TimeControl[Timer_No][Timer_On][Hrs]); 
        Serial.print(":"); 
        if(Relay3TimeControl[Timer_No][Timer_On][Mins] < 10) Serial.print("0");        
        Serial.print(Relay3TimeControl[Timer_No][Timer_On][Mins]); 
        Serial.print("   Time Off = "); Serial.print(Relay3TimeControl[Timer_No][Timer_Off][Hrs]); 
        Serial.print(":"); 
        if(Relay3TimeControl[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");       
        Serial.println(Relay3TimeControl[Timer_No][Timer_Off][Mins]);        
      }
    } // end of     if (NoOfRelays == 3)    
   byte Day;   // pointer
   if(Display) Serial.println("");    
   Timer_No = 0;
   while (Timer_No < 2)  // for each of 2 timers per output
   {
      if(Display)
      {
         Serial.print("Relay 1 Timer "); 
         Serial.print (Timer_No+1);
         Serial.print (" Enabled days:  ");
      }
    Day = 0;
    while (Day < 7)   // read each timer day flag from EEPROM
     {
        Relay1TimeControlDayFlags[Timer_No][Day] = EEPROM.read(EEPROM_Relay1_Timer1_Sun + (Timer_No*7) + Day);
        if(Display)
        {
            Serial.print(Relay1TimeControlDayFlags[Timer_No][Day]); 
            Serial.print(":");
        }
        Day ++;   
     }     // end of while (Day < 7)   // read each timer day flag from EEPROM
     if(Display) Serial.println("");
     Timer_No ++;
   }   // end of while (Timer_No < 2)  // for each of 2 timers per output
  
   
   if (NoOfRelays >= 2)  // only if 2 or 3 relays fitted
   {
      Timer_No = 0;
      while (Timer_No < 2)  // for each of 2 timers per output
      {
        if(Display)
        {
            Serial.print("Relay 2 Timer "); 
            Serial.print (Timer_No+1);
            Serial.print (" Enabled days:  ");
        }     
        Day = 0;
        while (Day < 7)   // read each timer day flag from EEPROM
        {
            Relay2TimeControlDayFlags[Timer_No][Day] = EEPROM.read(EEPROM_Relay2_Timer1_Sun + (Timer_No*7) + Day);
            if(Display)
            {
                Serial.print(Relay2TimeControlDayFlags[Timer_No][Day]); 
                Serial.print(":");
            }
            Day ++;   
        }     // end of while (Day < 7)   // read each timer day flag from EEPROM    
        if(Display) Serial.println("");  
        Timer_No ++;
      } // end of while (Timer_No < 2)  // for each of 2 timers per output 
   } // end of if(NoOfRelays >=2)
   if (NoOfRelays == 3)     // only if 3 relays fitted
   {
      Timer_No = 0;
      while (Timer_No < 2)  // for each of 2 timers per output
      {
        if(Display)
        {
            Serial.print("Relay 3 Timer "); 
            Serial.print (Timer_No+1); 
            Serial.print (" Enabled days:  ");
        }    
        Day = 0;
        while (Day < 7)   // read each timer day flag from EEPROM
        {
            Relay3TimeControlDayFlags[Timer_No][Day] = EEPROM.read(EEPROM_Relay3_Timer1_Sun + (Timer_No*7) + Day);
        
            if(Display)
            {       
                Serial.print(Relay3TimeControlDayFlags[Timer_No][Day]); 
                Serial.print(":");
            }
        
            Day ++;   
        }     // end of while (Day < 7)   // read each timer day flag from EEPROM    
        if(Display)  Serial.println("");    
        Timer_No ++;
      }       // end of while (Timer_No < 2)  // for each of 2 timers per output 
   } // end of if (size of (RelayPin == 3) 
  if(Display)
  {
    Serial.println(""); Serial.println("Timer status");
  }                                                     
    TimerEnable[Relay1][Timer1] = EEPROM.read(EEPROM_TimerEnableRelay1Timer1); 
    TimerEnable[Relay1][Timer2] = EEPROM.read(EEPROM_TimerEnableRelay1Timer2);     
    if(NoOfRelays>= 2) 
    {
      TimerEnable[Relay2][Timer1] = EEPROM.read(EEPROM_TimerEnableRelay2Timer1);
      TimerEnable[Relay2][Timer2] = EEPROM.read(EEPROM_TimerEnableRelay2Timer2);       
    }   
    if(NoOfRelays== 3) 
    {
      TimerEnable[Relay3][Timer1]= EEPROM.read(EEPROM_TimerEnableRelay3Timer1);
      TimerEnable[Relay3][Timer2] = EEPROM.read(EEPROM_TimerEnableRelay3Timer2);       
    }   
    if (Display)
    {
       Serial.print(F("Relay 1 Timer 1: ")); Serial.println(TimerEnable[Relay1][Timer1]);
       Serial.print(F("Relay 1 Timer 2: ")); Serial.println(TimerEnable[Relay1][Timer2]);       
       
       if(NoOfRelays>= 2) 
       {
         Serial.print(F("Relay 2 Timer 1: "));  Serial.println(TimerEnable[Relay2][Timer1]);
         Serial.print(F("Relay 2 Timer 2: "));  Serial.println(TimerEnable[Relay2][Timer2]);       
       }
       if(NoOfRelays== 3) 
       {
         Serial.print(F("Relay 3 Timer 1: "));  Serial.println(TimerEnable[Relay3][Timer1]);
         Serial.print(F("Relay 3 Timer 2: "));  Serial.println(TimerEnable[Relay3][Timer2]);                      
       }
    }  // end of if (Display)
    ClockEnable = EEPROM.read(EEPROM_ClockEnable);
    if (Display) 
    {
      Serial.print(F("Time Clock Enable: ")); 
      Serial.println(ClockEnable); 
    }
}   // end of  void Download_From_EEPROM_Timer_Control_Parameters()
  // -------------------------------------------------------------------- 
void Download_From_EEPROM_Output_And_Input_Settings(boolean Display)   
{   // download from EEPROM to working memory the relay ON timers
  unsigned int i = 0;
  byte Value;
  while (i < NoOfRelays)   // download the output timer settings
  {
    Value = EEPROM.read(EEPROM_RelayOnTimeParameter+i);
    if (Value <= TimerLimit) RelayOnTimeParameter[i] = Value; else  RelayOnTimeParameter[i] = 0;
    if (Display)
    { 
      Serial.print(F("Output ")); 
      Serial.print(i+1); 
      Serial.print(F(" Timer = ")); 
      Serial.print(RelayOnTimeParameter[i]); Serial.println(F(" Minutes"));
    } 
    i++;
  }
  if (Display) Serial.println("");  
}   // end of void Download_From_EEPROM_Output_And_Input_Settings()
// ------------------------------------------------------------
void Activate_Relay(byte Output_No, boolean State, boolean Set_Output_Timer)  
                // Output_No = 0-2 = relay 1 to 3, Set_Ouput_Timer instructs
                // function to set the output timer to required value if flag = true
{     // set or reset the addressed relay & the virtual copy of the relay state
  digitalWrite(RelayPin[Output_No], State);   // activate relay
  if (State == RelayOn)   // if relay is to be switched on
  {           // set output timer to required value
    if(Set_Output_Timer) RelayOnTimer[Output_No] = RelayOnTimeParameter[Output_No];  
    else RelayOnTimer[Output_No] = 0;    // disable output timer 
  }  // end of   if (State)   // if relay switched on
}    // end of void Activate_Relay(byte Output_No, boolean State, boolean Set_Output_Timer) 
// ------------------------------------------------------------
void ResetDevice(String Reason)  // Reset the device - method depends on whether HW watchdog is fitted
{
 WiFi.softAPdisconnect(true);     // precautionary. Ensure that the soft Access point server is disconnected
 WiFi.mode(WIFI_STA);             // Set WIFI module to STA mode 
 delay(100);
 if (EnableMessages)
 {
    Serial.print("Forced reset -  ");
    Serial.println(Reason);
 }
 ESP.restart();  
 while(true) delay(10);
} // end of void ResetDevice(String Reason)
  // -------------------------------------------------------------------
String Control_Timer_Time_To_String (byte Relay_No, byte TimerNo, byte TimeOn_Off )
{             // convert the Timer control parameter to a string value (for web page display)
  String T ;
  String T1;
  switch (Relay_No)
  {
    case 0:
    T =  String(Relay1TimeControl[TimerNo][TimeOn_Off][1]);   // convert hours
    if (T.length() == 1) T = "0" + T;                           // if single digit add leading zero
    T1 = String(Relay1TimeControl[TimerNo][TimeOn_Off][0]);   // convert minutes
    if (T1.length() == 1) T1 = "0" + T1;                        // if single digit add leading zero
    T = T + ":" + T1;           // combine digits with separator
    break;
    case 1:
    T =  String(Relay2TimeControl[TimerNo][TimeOn_Off][1]);             // convert hours
    if(T.length() == 1) T = "0" + T;                            // if single digit add leading zero
    T1 = String(Relay2TimeControl[TimerNo][TimeOn_Off][0]);   // convert minutes
    if (T1.length() == 1) T1 = "0" + T1;                            // if single digit add leading zero
    T = T + ":" + T1;           // combine digits with separator
    break; 
    case 2:
    T =  String(Relay3TimeControl[TimerNo][TimeOn_Off][1]);             // convert hours
    if(T.length() == 1) T = "0" + T;                                  // if single digit add leading zero
    T1 = String(Relay3TimeControl[TimerNo][TimeOn_Off][0]);   // convert minutes
    if (T1.length() == 1) T1 = "0" + T1;                           // if single digit add leading zero
    T = T + ":" + T1;           // combine digits with separator
    break; 
  } // end of Switch (Relay_No)
  return T;   
} // end of String Control_Timer_Time_To_String(byte Relay_No, byte TimerNo, byte TimeOn_Off, ) 
// -----------------------------------------------------------------------------
void Timer_Page_Relay1()   // Common page layout for Output timer 1 set up
{
        const byte TimeOn = 0;
        const byte TimeOff =1; 
        const byte Relay1 = 0;      
        String Tim1 = Control_Timer_Time_To_String(Relay1,Timer1, TimeOn);    // convert time values to a string
        String Tim2 = Control_Timer_Time_To_String(Relay1,Timer1, TimeOff);
        String content;
        content = "<!DOCTYPE HTML> \r\n<html>"; 
        content += "<head> <style>";  
        content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
        content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
        content += "</style></head><body>";           
        content += "<h3>" + HostName + " - Relay 1 (";
        content += RelayDescriptors[0] + ") - Automatic Timer Control</h3>";   
        content += "<form action = 'Relay1TimerControl'>";

        content += "<p>If Timer 1 OFF is set to 23:59 & Timer 2 ON is set to 00:00";
        content += "<br>then Timer 1 and Timer 2 will combine into 1 single timer starting";
        content += "<br>from Timer 1 ON to Timer 2 OFF bridging 2 or more days</p>";
        
        content += "<fieldset>";  
        content += "<legend><b>TIMER 1 - Timer 1 & Timer 2 must NOT overlap</b></legend>";     
        content += "Timer 1 ON: <input type = 'time' name = 'Relay1_Timer_1_ON'  value = ";
        content += Tim1 + ">";      
        content += "&nbsp Timer 1 OFF: <input type = 'time' name = 'Relay1_Timer_1_OFF' value = ";
        content += Tim2 + ">"; 
                   
        content += "<br><br><input type = 'checkbox' name = 'Relay1_Timer1_Sunday' value = '1' ";
        if (Relay1TimeControlDayFlags[Timer1][0]) content += " checked";
        content += ">Sunday&nbsp&nbsp"; 
              
        content += "<input type = 'checkbox' name = 'Relay1_Timer1_Monday'  value = '2' ";
        if (Relay1TimeControlDayFlags[Timer1][1]) content += " checked";
        content += ">Monday&nbsp&nbsp"; 
        
        content += "<input type = 'checkbox' name = 'Relay1_Timer1_Tuesday' value = '3' ";
        if (Relay1TimeControlDayFlags[Timer1][2]) content += " checked";
        content += ">Tuesday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay1_Timer1_Wednesday'  value = '4' ";
        if (Relay1TimeControlDayFlags[Timer1][3]) content += " checked";
        content += ">Wednesday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay1_Timer1_Thursday' value = '5' ";
        if (Relay1TimeControlDayFlags[Timer1][4]) content += " checked";
        content += ">Thursday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay1_Timer1_Friday'  value = '6' ";
        if (Relay1TimeControlDayFlags[Timer1][5]) content += " checked";
        content += ">Friday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay1_Timer1_Saturday' value = '7' ";
        if (Relay1TimeControlDayFlags[Timer1][6]) content += " checked";
        content += ">Saturday";         
        content += "</fieldset><br>";

        content += "<fieldset>";  
        content += "<legend><b>TIMER 2 - Timer 1 & Timer 2 must NOT overlap</b></legend>"; 
        Tim1 = Control_Timer_Time_To_String(Relay1,Timer2, TimeOn);    // convert time values to a string
        Tim2 = Control_Timer_Time_To_String(Relay1,Timer2, TimeOff);       
        content += "Timer 2 ON: <input type = 'time' name = 'Relay1_Timer_2_ON' value = ";
        content += Tim1 + ">"; 
        content += "&nbsp Timer 2 OFF: <input type = 'time' name = 'Relay1_Timer_2_OFF' value = "; 
        content += Tim2 + ">"; 
        
        content += "<br><br><input type = 'checkbox' name = 'Relay1_Timer2_Sunday' value = '1' ";
        if(Relay1TimeControlDayFlags[Timer2][0]) content += " checked";                
        content += ">Sunday&nbsp&nbsp";
        
        content += "<input type = 'checkbox' name = 'Relay1_Timer2_Monday'  value = '2' ";
        if (Relay1TimeControlDayFlags[Timer2][1]) content += " checked";        
        content += ">Monday&nbsp&nbsp";;
        
        content += "<input type = 'checkbox' name = 'Relay1_Timer2_Tuesday' value = '3' ";
        if (Relay1TimeControlDayFlags[Timer2][2]) content += " checked";
        content += ">Tuesday&nbsp&nbsp";
                
        content += "<input type = 'checkbox' name = 'Relay1_Timer2_Wednesday'  value = '4' ";
        if (Relay1TimeControlDayFlags[Timer2][3]) content += " checked";
        content += ">Wednesday&nbsp&nbsp";        
        
        content += "<input type = 'checkbox' name = 'Relay1_Timer2_Thursday' value = '5' ";
        if (Relay1TimeControlDayFlags[Timer2][4]) content += " checked";
        content += ">Thursday&nbsp&nbsp";       
        
        content += "<input type = 'checkbox' name = 'Relay1_Timer2_Friday'  value = '6' ";
        if (Relay1TimeControlDayFlags[Timer2][5]) content += "checked";
        content += ">Friday&nbsp&nbsp";
                
        content += "<input type = 'checkbox' name = 'Relay1_Timer2_Saturday' value = '7' ";
        if (Relay1TimeControlDayFlags[Timer2][6]) content += " checked";
        content += ">Saturday";        
        content += "</fieldset>";
                     
        content += "<h3>Timer Operational Modes</h3>";
        content += "<input type = 'radio' name = 'Relay1_Timer1_Mode' value = '0' "; 
        if (!TimerEnable[Relay1][Timer1]) content += "checked";
        content += ">Timer 1 Control Disabled<br>";
        
        content += "<input type = 'radio' name = 'Relay1_Timer1_Mode' value = '1' ";  
        if (TimerEnable[Relay1][Timer1]) content += "checked";
        content += ">Timer 1 Control Enabled<br>";

        content += "<input type = 'radio' name = 'Relay1_Timer2_Mode' value = '0' "; 
        if (!TimerEnable[Relay1][Timer2]) content += "checked";
        content += ">Timer 2 Control Disabled<br>";
        
        content += "<input type = 'radio' name = 'Relay1_Timer2_Mode' value = '1' ";  
        if (TimerEnable[Relay1][Timer2]) content += "checked";
        content += ">Timer 2 Control Enabled<br>";
                                         
        content += "<p><br> <input type = 'submit' value = 'Press to upload' style = 'color:blue;background:yellow;font size 25 px'> "; 
        content += "<br><br><a href='http://";           
        if(AccessPointRunning) content += "192.168.8.200'>"; else     content += IPaddressToString(WiFi.localIP()) + "'>";
        content +=  " Return to the Main Menu  </a>"; 
        content += "</form> </html>";  
        if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
        else LocalServer.send(200, "text/html", content);  // send message to AP Webpage          
}   // end of void Timer_Page_Relay1()   // Common page layout for Output timer 1 set up
        // ----------------------------------------------------------------------- 
void Timer_Page_Relay2()   // Common page layout for Output timer 1 set up
{
        const byte TimeOn = 0;
        const byte TimeOff =1;
        const byte Relay2 = 1;
        String Tim1 = Control_Timer_Time_To_String(Relay2,Timer1, TimeOn);    // convert time values to a string
        String Tim2 = Control_Timer_Time_To_String(Relay2,Timer1, TimeOff);
        String content;
        content = "<!DOCTYPE HTML> \r\n<html>"; 
        content += "<head> <style>";  
        content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
        content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
        content += "</style></head><body>";            
        content += "<h3>" + HostName + " - Relay 2 (";
        content += RelayDescriptors[1] + ") - Automatic Timer Control</h3>";   
        content += "<form action = 'Relay2TimerControl'>";

        content += "<p>If Timer 1 OFF is set to 23:59 & Timer 2 ON is set to 00:00";
        content += "<br>then Timer 1 and Timer 2 will combine into 1 single timer starting";
        content += "<br>from Timer 1 ON to Timer 2 OFF bridging 2 or more days</p>";

        content += "<fieldset>";  
        content += "<legend><b>TIMER 1 - Timer 1 & Timer 2 must NOT overlap</b></legend>";         
        content += "Timer 1 ON: <input type = 'time' name = 'Relay2_Timer_1_ON'  value = ";
        content += Tim1 + ">";      
        content += "&nbsp Timer 1 OFF: <input type = 'time' name = 'Relay2_Timer_1_OFF' value = ";
        content += Tim2 + ">"; 
                   
        content += "<br><br><input type = 'checkbox' name = 'Relay2_Timer1_Sunday' value = '1' ";
        if (Relay2TimeControlDayFlags[Timer1][0]) content += " checked";
        content += ">Sunday&nbsp&nbsp"; 
              
        content += "<input type = 'checkbox' name = 'Relay2_Timer1_Monday'  value = '2' ";
        if (Relay2TimeControlDayFlags[Timer1][1]) content += " checked";
        content += ">Monday&nbsp&nbsp"; 
        
        content += "<input type = 'checkbox' name = 'Relay2_Timer1_Tuesday' value = '3' ";
        if (Relay2TimeControlDayFlags[Timer1][2]) content += " checked";
        content += ">Tuesday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay2_Timer1_Wednesday'  value = '4' ";
        if (Relay2TimeControlDayFlags[Timer1][3]) content += " checked";
        content += ">Wednesday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay2_Timer1_Thursday' value = '5' ";
        if (Relay2TimeControlDayFlags[Timer1][4]) content += " checked";
        content += ">Thursday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay2_Timer1_Friday'  value = '6' ";
        if (Relay2TimeControlDayFlags[Timer1][5]) content += " checked";
        content += ">Friday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay2_Timer1_Saturday' value = '7' ";
        if (Relay2TimeControlDayFlags[Timer1][6]) content += " checked";
        content += ">Saturday";  
        content += "</fieldset><br>";
           
        content += "<fieldset>";  
        content += "<legend><b>TIMER 2 - Timer 1 & Timer 2 must NOT overlap</b></legend>"; 
        Tim1 = Control_Timer_Time_To_String(1,Timer2, TimeOn);    // convert time values to a string
        Tim2 = Control_Timer_Time_To_String(1,Timer2, TimeOff);       
        content += "Timer 2 ON: <input type = 'time' name = 'Relay2_Timer_2_ON' value = ";
        content += Tim1 + ">"; 
        content += "&nbsp Timer 2 OFF: <input type = 'time' name = 'Relay2_Timer_2_OFF' value = "; 
        content += Tim2 + ">"; 
        
        content += "<br><br><input type = 'checkbox' name = 'Relay2_Timer2_Sunday' value = '1' ";
        if(Relay2TimeControlDayFlags[Timer2][0]) content += " checked";                
        content += ">Sunday&nbsp&nbsp";
        
        content += "<input type = 'checkbox' name = 'Relay2_Timer2_Monday'  value = '2' ";
        if (Relay2TimeControlDayFlags[Timer2][1]) content += " checked";        
        content += ">Monday&nbsp&nbsp";
        
        content += "<input type = 'checkbox' name = 'Relay2_Timer2_Tuesday' value = '3' ";
        if (Relay2TimeControlDayFlags[Timer2][2]) content += " checked";
        content += ">Tuesday&nbsp&nbsp";
                
        content += "<input type = 'checkbox' name = 'Relay2_Timer2_Wednesday'  value = '4' ";
        if (Relay2TimeControlDayFlags[Timer2][3]) content += " checked";
        content += ">Wednesday&nbsp&nbsp";        
        
        content += "<input type = 'checkbox' name = 'Relay2_Timer2_Thursday' value = '5' ";
        if (Relay2TimeControlDayFlags[Timer2][4]) content += " checked";
        content += ">Thursday&nbsp&nbsp";        
        
        content += "<input type = 'checkbox' name = 'Relay2_Timer2_Friday'  value = '6' ";
        if (Relay2TimeControlDayFlags[Timer2][5]) content += "checked";
        content += ">Friday&nbsp&nbsp";
                
        content += "<input type = 'checkbox' name = 'Relay2_Timer2_Saturday' value = '7' ";
        if (Relay2TimeControlDayFlags[Timer2][6]) content += " checked";
        content += ">Saturday";  
        content += "</fieldset><br>";                
                     
        content += "<h3>Timer Operational Modes</h3>";
        content += "<input type = 'radio' name = 'Relay2_Timer1_Mode' value = '0' "; 
        if (!TimerEnable[Relay2][Timer1]) content += "checked";
        content += ">Timer 1 Control Disabled<br>";
        
        content += "<input type = 'radio' name = 'Relay2_Timer1_Mode' value = '1' ";  
        if (TimerEnable[Relay2][Timer1]) content += "checked";
        content += ">Timer 1 Control Enabled<br>";

        content += "<input type = 'radio' name = 'Relay2_Timer2_Mode' value = '0' "; 
        if (!TimerEnable[Relay2][Timer2]) content += "checked";
        content += ">Timer 2 Control Disabled<br>";
        
        content += "<input type = 'radio' name = 'Relay2_Timer2_Mode' value = '1' ";  
        if (TimerEnable[Relay2][Timer2]) content += "checked";
        content += ">Timer 2 Control Enabled<br>";
                             
        content += "<p><br> <input type = 'submit' value = 'Press to upload' style = 'color:blue;background:yellow;font size 25 px'> "; 
        content += "<br><br><a href='http://";           
        if(AccessPointRunning) content += "192.168.8.200'>"; else     content += IPaddressToString(WiFi.localIP()) + "'>";
        content +=  " Return to the Main Menu  </a>";  
        content += "</form> </html>";
        if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
        else LocalServer.send(200, "text/html", content);  // send message to AP Webpage            
}   // end of void Timer_Page_Relay2()   // Common page layout for Output timer 2 set up
  // ---------------------------------------------------------------------------------
void Timer_Page_Relay3()   // Common page layout for Output timer 3 set up
{
        const byte TimeOn = 0;
        const byte TimeOff =1;
        const byte Relay3 = 2;
        String Tim1 = Control_Timer_Time_To_String(Relay3,Timer1, TimeOn);    // convert time values to a string
        String Tim2 = Control_Timer_Time_To_String(Relay3,Timer1, TimeOff);
        String content;
        //content.reserve(1000);
        content = "<!DOCTYPE HTML> \r\n<html>"; 
        content += "<head> <style>";  
        content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
        content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
        content += "</style></head><body>";                
        content += "<h3>" + HostName + " - Relay 3 (";
        content += RelayDescriptors[2] + ") - Automatic Timer Control</h3>";    
        content += "<form action = 'Relay3TimerControl'>";  

        content += "<p>If Timer 1 OFF is set to 23:59 & Timer 2 ON is set to 00:00";
        content += "<br>then Timer 1 and Timer 2 will combine into 1 single timer starting";
        content += "<br>from Timer 1 ON to Timer 2 OFF bridging 2 or more days</p>";

        content += "<fieldset>";  
        content += "<legend><b>TIMER 1 - Timer 1 & Timer 2 must NOT overlap</b></legend>";        
        content += "Timer 1 ON: <input type = 'time' name = 'Relay3_Timer_1_ON'  value = ";
        content += Tim1 + ">";      
        content += "&nbsp Timer 1 OFF: <input type = 'time' name = 'Relay3_Timer_1_OFF' value = ";
        content += Tim2 + ">"; 
                   
        content += "<br><br><input type = 'checkbox' name = 'Relay3_Timer1_Sunday' value = '1' ";
        if (Relay3TimeControlDayFlags[Timer1][0]) content += " checked";
        content += ">Sunday&nbsp&nbsp"; 
              
        content += "<input type = 'checkbox' name = 'Relay3_Timer1_Monday'  value = '2' ";
        if (Relay3TimeControlDayFlags[Timer1][1]) content += " checked";
        content += ">Monday&nbsp&nbsp"; 
        
        content += "<input type = 'checkbox' name = 'Relay3_Timer1_Tuesday' value = '3' ";
        if (Relay3TimeControlDayFlags[Timer1][2]) content += " checked";
        content += ">Tuesday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay3_Timer1_Wednesday'  value = '4' ";
        if (Relay3TimeControlDayFlags[Timer1][3]) content += " checked";
        content += ">Wednesday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay3_Timer1_Thursday' value = '5' ";
        if (Relay3TimeControlDayFlags[Timer1][4]) content += " checked";
        content += ">Thursday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay3_Timer1_Friday'  value = '6' ";
        if (Relay3TimeControlDayFlags[Timer1][5]) content += " checked";
        content += ">Friday&nbsp&nbsp"; 
                
        content += "<input type = 'checkbox' name = 'Relay3_Timer1_Saturday' value = '7' ";
        if (Relay3TimeControlDayFlags[Timer1][6]) content += " checked";
        content += ">Saturday";
        content += "</fieldset><br>"; 
                         
        content += "<fieldset>";  
        content += "<legend><b>TIMER 2 - Timer 1 & Timer 2 must NOT overlap</b></legend>"; 
        Tim1 = Control_Timer_Time_To_String(Relay3,Timer2, TimeOn);    // convert time values to a string
        Tim2 = Control_Timer_Time_To_String(Relay3,Timer2, TimeOff);       
        content += "Timer 2 ON: <input type = 'time' name = 'Relay3_Timer_2_ON' value = ";
        content += Tim1 + ">"; 
        content += "&nbsp Timer 2 OFF: <input type = 'time' name = 'Relay3_Timer_2_OFF' value = "; 
        content += Tim2 + ">"; 
        
        content += "<br><br><input type = 'checkbox' name = 'Relay3_Timer2_Sunday' value = '1' ";
        if(Relay3TimeControlDayFlags[Timer2][0]) content += " checked";                
        content += ">Sunday&nbsp&nbsp";
        
        content += "<input type = 'checkbox' name = 'Relay3_Timer2_Monday'  value = '2' ";
        if (Relay3TimeControlDayFlags[Timer2][1]) content += " checked";        
        content += ">Monday&nbsp&nbsp";
        
        content += "<input type = 'checkbox' name = 'Relay3_Timer2_Tuesday' value = '3' ";
        if (Relay3TimeControlDayFlags[Timer2][2]) content += " checked";
        content += ">Tuesday&nbsp&nbsp";
                
        content += "<input type = 'checkbox' name = 'Relay3_Timer2_Wednesday'  value = '4' ";
        if (Relay3TimeControlDayFlags[Timer2][3]) content += " checked";
        content += ">Wednesday&nbsp&nbsp";        
        
        content += "<input type = 'checkbox' name = 'Relay3_Timer2_Thursday' value = '5' ";
        if (Relay3TimeControlDayFlags[Timer2][4]) content += " checked";
        content += ">Thursday&nbsp&nbsp";        
        
        content += "<input type = 'checkbox' name = 'Relay3_Timer2_Friday'  value = '6' ";
        if (Relay3TimeControlDayFlags[Timer2][5]) content += "checked";
        content += ">Friday&nbsp&nbsp";
                
        content += "<input type = 'checkbox' name = 'Relay3_Timer2_Saturday' value = '7' ";
        if (Relay3TimeControlDayFlags[Timer2][6]) content += " checked";
        content += ">Saturday"; 
        content += "</fieldset><br>";                 
                     
        content += "<h3>Timer Operational Modes</h3>";
        content += "<input type = 'radio' name = 'Relay3_Timer1_Mode' value = '0' "; 
        if (!TimerEnable[Relay3][Timer1]) content += "checked";
        content += ">Timer 1 Control Disabled<br>";
        
        content += "<input type = 'radio' name = 'Relay3_Timer1_Mode' value = '1' ";  
        if (TimerEnable[Relay3][Timer1]) content += "checked";
        content += ">Timer 1 Control Enabled<br>";

        content += "<input type = 'radio' name = 'Relay3_Timer2_Mode' value = '0' "; 
        if (!TimerEnable[Relay3][Timer2]) content += "checked";
        content += ">Timer 2 Control Disabled<br>";
        
        content += "<input type = 'radio' name = 'Relay3_Timer2_Mode' value = '1' ";  
        if (TimerEnable[Relay3][Timer2]) content += "checked";
        content += ">Timer 2 Control Enabled<br>";
                                 
        content += "<p><br> <input type = 'submit' value = 'Press to upload' style = 'color:blue;background:yellow;font size 25 px'> "; 
        content += "<br><br><a href='http://";           
        if(AccessPointRunning) content += "192.168.8.200'>"; else content += IPaddressToString(WiFi.localIP()) + "'>";
        content +=  " Return to the Main Menu  </a>";  
        content += "</form> </html>"; 
        if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
        else LocalServer.send(200, "text/html", content);  // send message to AP Webpage           
}   // end of void Timer_Page_Relay3()   // Common page layout for Output timer 1 set up
   // ---------------------------------------------------------------------------- 
byte Get_Decimal_Hours_From_Web_Time_Value(String Time_Value)   // Input string = hrs:min(xx:yy) format from Access point web page input.
{                                                               // Returns decimal value. Input must be in the correct format
  byte Decimal_Value; 
  String Hours = String(Time_Value.charAt(0));
  Hours += String(Time_Value.charAt(1));
  Decimal_Value = Hours.toInt();
  return Decimal_Value;
}   // end of byte Get_Decimal_Hours_From_Web_Time_Value(String Time_Value) 
   // ----------------------------------------------------------------------------   
byte Get_Decimal_Mins_From_Web_Time_Value(String Time_Value)   // Input string = hrs:min(xx:yy) format from Access point web page input.
{                                                              // Returns decimal value.  Input must be in the correct format
  byte Decimal_Value;  
  String Minutes = String(Time_Value.charAt(3));
  Minutes += String(Time_Value.charAt(4));
  Decimal_Value = Minutes.toInt();
  return Decimal_Value;  
}   // end of  byte Get_Decimal_Mins_From_Web_Time_Value(String Time_Value) 
   // ----------------------------------------------------------------------------   
byte Convert_From_String_To_Decimal_Number(String String_Number)   // Input string number = xxx format from Access point web page input 
{                                                                  // (max value = 256). Returns decimal value
  unsigned int Decimal_Value;
  if (String_Number.length() > 3) 
  {  // String too many characters
    Decimal_Value = 0;
  }
  else 
  {
    Decimal_Value = String_Number.toInt();   // convert string to int (must be numeric string!)
    if (Decimal_Value > 255) Decimal_Value = 255;  
  }
  return byte(Decimal_Value);   
}   // end of byte Convert_From_String_To_Decimal_Number(String String_Number)    
  // ----------------------------------------------------------------------------
void Set_Up_Access_Point()    // set up & create an access point and web page to allow the login details
                              // to be changed - will reset the board after the changes have been entered
                              // Normal login to WiFi network using the stored details
{
  LocalServer.stop();  // Stop the remote control server
  WiFi.mode(WIFI_AP_STA);
  if (EnableMessages) 
  { 
      Serial.println(""); 
      Serial.print(F("Starting up "));
      Serial.print(HostName);
      Serial.println(F(" Setup Access Point"));
  }
  Heartbeat_Tick();   // Feed the HW watchdog! 
  int n = WiFi.scanNetworks();
  st = "<ol>";
  for (int i = 0; i < n; ++i)
    {
      // add SSID and RSSI to string st for each network found
      st += "<li>";
      st += WiFi.SSID(i);
      st += " (";
      st += WiFi.RSSI(i);
      st += ")";
      st += (WiFi.encryptionType(i) == ENC_TYPE_NONE)?" ":"*";
      st += "</li>";
    }   // end of for (int i = 0; i < n; ++i)
  st += "</ol>";

    // ************* delete these 4 lines if you wish to use default IP address of 192.168.4.1
  IPAddress ip(192,168,8,200);        // Give Access point a preferred IP Address
  IPAddress gateway(192,168,8,200);   // Give Access point a preferred gateway address
  IPAddress subnet(255,255,255,0);    // Give Access point a preferred subnet address
  WiFi.softAPConfig(ip,gateway,subnet);
    // ***************************************************************************************
  ssid = HostName + " - Setup" ;  // AP server name is same as the device name
  WiFi.softAP(ssid.c_str(), passphrase.c_str());     // Create Access Point
  serverAP.begin();   // Start the access point webserver
  if (EnableMessages)  
  {
      Serial.print(F("Connect to Access Point ")); Serial.println(ssid); 
      Serial.print(F("Web page IP address ")); Serial.println(WiFi.softAPIP());
      Serial.println(F("for Device Setup")); 
  }
}   // end of void Set_Up_Access_Point(void) 
          // ------------------------------------------------------------------
void MQTT_SetUp()    // MQTT Set up
{
        String qMQTT_ServerName = serverAP.arg("MQTT_ServerName");   // check input from web page when submitted
        String qRecipientHostName1 = serverAP.arg("RecipientHostName1"); 
        String qRecipientHostName2 = serverAP.arg("RecipientHostName2"); 
        String qRecipientHostName3 = serverAP.arg("RecipientHostName3"); 
        String qRecipientHostName4 = serverAP.arg("RecipientHostName4"); 
        String qRecipientHostName5 = serverAP.arg("RecipientHostName5");              
        String qMQTT_PushInterval = serverAP.arg("MQTT_PushInterval");
        String qRemoteDataSendEnable1 = serverAP.arg("RemoteDataSendEnable1");   
        String qRemoteDataSendEnable2 = serverAP.arg("RemoteDataSendEnable2");  
        String qRemoteDataSendEnable3 = serverAP.arg("RemoteDataSendEnable3");  
        String qRemoteDataSendEnable4 = serverAP.arg("RemoteDataSendEnable4");  
        String qRemoteDataSendEnable5 = serverAP.arg("RemoteDataSendEnable5");                     
        boolean EEPROM_Lock = false;

        if (qMQTT_ServerName.length() > 0 ) // Only if something has been entered into the web field
        {
            byte i=0;
            while(i < MaxStringLength)  // Clear out all of the previous stored entries 
            {
              EEPROM.write(EEPROM_MQTT_Server + i, 255);
              i++;
            }
            i=0;
            while(i < qMQTT_ServerName.length())   // store new name to EEPROM
            {
              EEPROM.write(EEPROM_MQTT_Server + i, qMQTT_ServerName[i]);
              i++;
            }
            EEPROM_Lock = true;
        }  // end of if (qMQTT_ServerName.length() > 0 )

        if (qRecipientHostName1.length() > 0 ) // Only if something has been entered into the web field
        {
            byte i=0;
            while(i < MaxStringLength)  // Clear out all of the previous stored entries 
            {
              EEPROM.write(EEPROM_RecipientHostName1 + i, 255);
              i++;
            }
            
            i=0;
            while(i < qRecipientHostName1.length())   // store new name to EEPROM
            {
              EEPROM.write(EEPROM_RecipientHostName1 + i, qRecipientHostName1[i]);
              i++;
            }
            EEPROM_Lock = true;            
        }  // end of if (qRecipientHostName1.length() > 0 )

        if (qRecipientHostName2.length() > 0 ) // Only if something has been entered into the web field
        {
            byte i=0;
            while(i < MaxStringLength)  // Clear out all of the previous stored entries 
            {
              EEPROM.write(EEPROM_RecipientHostName2 + i, 255);
              i++;
            }
            
            i=0;
            while(i < qRecipientHostName2.length())   // store new name to EEPROM
            {
              EEPROM.write(EEPROM_RecipientHostName2 + i, qRecipientHostName2[i]);
              i++;
            }
            EEPROM_Lock = true;            
        }  // end of if (qRecipientHostName2.length() > 0 )

        if (qRecipientHostName3.length() > 0 ) // Only if something has been entered into the web field
        {
            byte i=0;
            while(i < MaxStringLength)  // Clear out all of the previous stored entries 
            {
              EEPROM.write(EEPROM_RecipientHostName3 + i, 255);
              i++;
            }
            
            i=0;
            while(i < qRecipientHostName3.length())   // store new name to EEPROM
            {
              EEPROM.write(EEPROM_RecipientHostName3 + i, qRecipientHostName3[i]);
              i++;
            }
            EEPROM_Lock = true;            
        }  // end of if (qRecipientHostName3.length() > 0 )

        if (qRecipientHostName4.length() > 0 ) // Only if something has been entered into the web field
        {
            byte i=0;
            while(i < MaxStringLength)  // Clear out all of the previous stored entries 
            {
              EEPROM.write(EEPROM_RecipientHostName4 + i, 255);
              i++;
            }
            
            i=0;
            while(i < qRecipientHostName4.length())   // store new name to EEPROM
            {
              EEPROM.write(EEPROM_RecipientHostName4 + i, qRecipientHostName4[i]);
              i++;
            }
            EEPROM_Lock = true;            
        }  // end of if (qRecipientHostName4.length() > 0 )

        if (qRecipientHostName5.length() > 0 ) // Only if something has been entered into the web field
        {
            byte i=0;
            while(i < MaxStringLength)  // Clear out all of the previous stored entries 
            {
              EEPROM.write(EEPROM_RecipientHostName5 + i, 255);
              i++;
            }
            
            i=0;
            while(i < qRecipientHostName5.length())   // store new name to EEPROM
            {
              EEPROM.write(EEPROM_RecipientHostName5 + i, qRecipientHostName5[i]);
              i++;
            }
            EEPROM_Lock = true;            
        }  // end of if (qRecipientHostName5.length() > 0 )        
             
        if (qMQTT_PushInterval.length() > 0 ) // Only if something has been entered into the web field
        {
            MQTT_PushInterval = qMQTT_PushInterval.toInt();
            EEPROM.write(EEPROM_MQTT_PushInterval, MQTT_PushInterval);
            EEPROM_Lock = true;
        }  // end of if (qMQTT_PushInterval.length() > 0 )

        if (qRemoteDataSendEnable1.length() > 0 ) // Only if something has been entered into the web field
        {
            if(qRemoteDataSendEnable1 == "D" && RemoteDataSendEnable[0] == true) 
            {
              RemoteDataSendEnable[0] = false;
              EEPROM.write(EEPROM_RemoteDataSendEnable1, RemoteDataSendEnable[0]);
              EEPROM_Lock = true;               
            }
            else 
            if(qRemoteDataSendEnable1 == "E" && RemoteDataSendEnable[0] == false) 
            {
              RemoteDataSendEnable[0] = true;
              EEPROM.write(EEPROM_RemoteDataSendEnable1, RemoteDataSendEnable[0]);
              EEPROM_Lock = true;
            }
        } // end of if (qRemoteDataSendEnable1.length() > 0 )  
        
        if (qRemoteDataSendEnable2.length() > 0 ) // Only if something has been entered into the web field
        {
            if(qRemoteDataSendEnable2 == "D" && RemoteDataSendEnable[1] == true) 
            {
              RemoteDataSendEnable[1] = false;
              EEPROM.write(EEPROM_RemoteDataSendEnable2, RemoteDataSendEnable[1]);
              EEPROM_Lock = true;               
            }
            else 
            if(qRemoteDataSendEnable2 == "E" && RemoteDataSendEnable[1] == false) 
            {
              RemoteDataSendEnable[1] = true;
              EEPROM.write(EEPROM_RemoteDataSendEnable2, RemoteDataSendEnable[1]);
              EEPROM_Lock = true;
            }
        } // end of if (qRemoteDataSendEnable2.length() > 0 )          
        
        if (qRemoteDataSendEnable3.length() > 0 ) // Only if something has been entered into the web field
        {
            if(qRemoteDataSendEnable3 == "D" && RemoteDataSendEnable[2] == true) 
            {
              RemoteDataSendEnable[2] = false;
              EEPROM.write(EEPROM_RemoteDataSendEnable3, RemoteDataSendEnable[2]);
              EEPROM_Lock = true;               
            }
            else 
            if(qRemoteDataSendEnable3 == "E" && RemoteDataSendEnable[2] == false) 
            {
              RemoteDataSendEnable[2] = true;
              EEPROM.write(EEPROM_RemoteDataSendEnable3, RemoteDataSendEnable[2]);
              EEPROM_Lock = true;
            }
        } // end of if (qRemoteDataSendEnable3.length() > 0 )   

        if (qRemoteDataSendEnable4.length() > 0 ) // Only if something has been entered into the web field
        {
            if(qRemoteDataSendEnable4 == "D" && RemoteDataSendEnable[3] == true) 
            {
              RemoteDataSendEnable[3] = false;
              EEPROM.write(EEPROM_RemoteDataSendEnable4, RemoteDataSendEnable[3]);
              EEPROM_Lock = true;               
            }
            else 
            if(qRemoteDataSendEnable4 == "E" && RemoteDataSendEnable[3] == false) 
            {
              RemoteDataSendEnable[3] = true;
              EEPROM.write(EEPROM_RemoteDataSendEnable4, RemoteDataSendEnable[3]);
              EEPROM_Lock = true;
            }
        } // end of if (qRemoteDataSendEnable4.length() > 0 )   

        if (qRemoteDataSendEnable5.length() > 0 ) // Only if something has been entered into the web field
        {
            if(qRemoteDataSendEnable5 == "D" && RemoteDataSendEnable[4] == true) 
            {
              RemoteDataSendEnable[4] = false;
              EEPROM.write(EEPROM_RemoteDataSendEnable5, RemoteDataSendEnable[4]);
              EEPROM_Lock = true;               
            }
            else 
            if(qRemoteDataSendEnable5 == "E" && RemoteDataSendEnable[4] == false) 
            {
              RemoteDataSendEnable[4] = true;
              EEPROM.write(EEPROM_RemoteDataSendEnable5, RemoteDataSendEnable[4]);
              EEPROM_Lock = true;
            }
        } // end of if (qRemoteDataSendEnable5.length() > 0 )   
               
        if(EEPROM_Lock == true) 
        {
          EEPROM.commit();   // Lock in EEPROM changes  
          DownloadMQTT_detailsFromEEPROM(false);  
        }         
        // -----------------------------------------------
        String ipStr = IPaddressToString(WiFi.localIP());
        String content;
        content = "<!DOCTYPE HTML>\r\n<html>";
        content += "<head> <style>";  
        content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
        content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
        content += "</style></head><body>";  
        content += "<h3>" + HostName + " MQTT Configuration Page</h3>";
        content += "<form action='MQTT_SetUp' autocomplete = 'off'></p>";                             
        content += "<fieldset>"; 
        content += "<legend><b>Current stored MQTT Server details</b></legend>"; 
        content += "MQTT Broker Name = " + String(MQTT_Server); 
        //content += "<br>MQTT Recipient Host Name = " + RecipientHostName[0];          
        content += "<br>MQTT Broker is ";
        if(MQTT_Status == true) content += "Connected"; else content += "Disconnected";
        content += "<br>No of dropouts: " + String(MQTT_DropOutCounter);                      
        content += "<br>Data Push Time Interval (Seconds) = " + String(MQTT_PushInterval/1000);                    
        content += "<b><br><br>Enabled Recipients</b><br>";
        byte i = 0;
        while (i < 5)  // list each enabled recipient host name
        {
            if(RemoteDataSendEnable[i] == true) 
            {
              content += String (i + 1) + " - " + RecipientHostName[i]; 
              if (i < 4) content += "<br>";
            }
            i++;
        } 
        if(RemoteDataSend() == false) content += "Not linked to any recipient device";        
        content += "</fieldset>";  
                
        if(AccessPointRunning == true)
        {         
          content += "<fieldset>";       
          content += "<legend><b>Input new MQTT Broker settings (20 char max per text field, blank fields will not be updated)</b></legend>";
          content += "<label>MQTT Broker Name:</label>  <input name='MQTT_ServerName' size = '" + String(MaxStringLength) + "' length=" + String(MaxStringLength) + ">";        
          content += "&nbsp&nbsp&nbsp<label>Data Push Time Interval (1-255 S) </label> ";    
          content += "<input type = 'number' name='MQTT_PushInterval' + length=3 size = '4' min='1' max = '255'><br>";                               
          content += "</fieldset>";

          content += "<fieldset>";       
          content += "<legend><b>Recipient Housenode 1 (20 char max per text field, blank fields will not be updated)</b></legend>";   
          content += "<label>MQTT Recipient Host Name: </label> <input name='RecipientHostName1' size = '" + String(MaxStringLength) + "' length=" + String(MaxStringLength) + ">";                      
          if(RemoteDataSendEnable[0] == true) content += "<input type = 'radio' name = 'RemoteDataSendEnable1' value = 'D'>Click to DISABLE Remote Send";  
          else content += "<input type = 'radio' name = 'RemoteDataSendEnable1' value = 'E'>Click to ENABLE Remote Send";               
          content += "</fieldset>";          
                  
          content += "<fieldset>";       
          content += "<legend><b>Recipient Housenode 2 (20 char max per text field, blank fields will not be updated)</b></legend>";   
          content += "<label>MQTT Recipient Host Name: </label> <input name='RecipientHostName2' size = '" + String(MaxStringLength) + "' length=" + String(MaxStringLength) + ">";                      
          if(RemoteDataSendEnable[1] == true) content += "<input type = 'radio' name = 'RemoteDataSendEnable2' value = 'D'>Click to DISABLE Remote Send";  
          else content += "<input type = 'radio' name = 'RemoteDataSendEnable2' value = 'E'>Click to ENABLE Remote Send";               
          content += "</fieldset>";

          content += "<fieldset>";       
          content += "<legend><b>Recipient Housenode 3 (20 char max per text field, blank fields will not be updated)</b></legend>";   
          content += "<label>MQTT Recipient Host Name: </label> <input name='RecipientHostName3' size = '" + String(MaxStringLength) + "' length=" + String(MaxStringLength) + ">";                      
          if(RemoteDataSendEnable[2] == true) content += "<input type = 'radio' name = 'RemoteDataSendEnable3' value = 'D'>Click to DISABLE Remote Send";  
          else content += "<input type = 'radio' name = 'RemoteDataSendEnable3' value = 'E'>Click to ENABLE Remote Send";               
          content += "</fieldset>";

          content += "<fieldset>";       
          content += "<legend><b>Recipient Housenode 4 (20 char max per text field, blank fields will not be updated)</b></legend>";   
          content += "<label>MQTT Recipient Host Name: </label> <input name='RecipientHostName4' size = '" + String(MaxStringLength) + "' length=" + String(MaxStringLength) + ">";                      
          if(RemoteDataSendEnable[3] == true) content += "<input type = 'radio' name = 'RemoteDataSendEnable4' value = 'D'>Click to DISABLE Remote Send";  
          else content += "<input type = 'radio' name = 'RemoteDataSendEnable4' value = 'E'>Click to ENABLE Remote Send";               
          content += "</fieldset>";

          content += "<fieldset>";       
          content += "<legend><b>Recipient Housenode 5 (20 char max per text field, blank fields will not be updated)</b></legend>";   
          content += "<label>MQTT Recipient Host Name: </label> <input name='RecipientHostName5' size = '" + String(MaxStringLength) + "' length=" + String(MaxStringLength) + ">";                      
          if(RemoteDataSendEnable[4] == true) content += "<input type = 'radio' name = 'RemoteDataSendEnable5' value = 'D'>Click to DISABLE Remote Send";  
          else content += "<input type = 'radio' name = 'RemoteDataSendEnable5' value = 'E'>Click to ENABLE Remote Send";               
          content += "</fieldset>";
                               
          content += "<p><input type='submit' value = 'Upload new settings to the device' style = 'color:blue;background:yellow;font size 25 px'> </form>";           
        } // end of if(AccessPointRunning == true)
        content += "</form></html>"; 
        content += "<br><a href='http://";           
        if(AccessPointRunning) content += "192.168.8.200'>"; else content += IPaddressToString(WiFi.localIP()) + "'>";
        content +=  " Return to the Main Menu  </a>";   
        if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
        else LocalServer.send(200, "text/html", content);  // send message to AP Webpage       
}  // end of  void MQTT_SetUp()    // MQTT Set up
 // ----------------------------------------------------------------
boolean CheckForCombinedTimersRelay1()
{
    if(Relay1TimeControl [Timer1][TimeOFF][Hours] == 23 && Relay1TimeControl [Timer1][TimeOFF][Minutes] == 59   
        && Relay1TimeControl [Timer2][TimeON][Hours] == 0 && Relay1TimeControl [Timer2][TimeON][Minutes] == 0)
            return true; else return false; 
}  // end of boolean CheckForCombinedTimersRelay1()
boolean CheckForCombinedTimersRelay2()
{
    if(Relay2TimeControl [Timer1][TimeOFF][Hours] == 23 && Relay2TimeControl [Timer1][TimeOFF][Minutes] == 59   
        && Relay2TimeControl [Timer2][TimeON][Hours] == 0 && Relay2TimeControl [Timer2][TimeON][Minutes] == 0)
            return true; else return false; 
}  // end of boolean CheckForCombinedTimersRelay2()
boolean CheckForCombinedTimersRelay3()
{
    if(Relay3TimeControl [Timer1][TimeOFF][Hours] == 23 && Relay3TimeControl [Timer1][TimeOFF][Minutes] == 59   
        && Relay3TimeControl [Timer2][TimeON][Hours] == 0 && Relay3TimeControl [Timer2][TimeON][Minutes] == 0)
            return true; else return false; 
}  // end of boolean CheckForCombinedTimersRelay3()
// --------------------------------------------------------------------------------
void PIR_Setup()
{
    String content;

    String qPIR_Timer1 = serverAP.arg("PIR_Timer1");   
    String qPIR_Timer2 = serverAP.arg("PIR_Timer2");
    String qPIR_Timer3 = serverAP.arg("PIR_Timer3");
    String qPIR_Timer4 = serverAP.arg("PIR_Timer4");   
    String qPIR_Timer5 = serverAP.arg("PIR_Timer5");
    String qPIR_Timer6 = serverAP.arg("PIR_Timer6");   
    String qPIR_AssignedRelay1 = serverAP.arg("PIR_AssignedRelay1");  
    String qPIR_AssignedRelay2 = serverAP.arg("PIR_AssignedRelay2");  
    String qPIR_AssignedRelay3 = serverAP.arg("PIR_AssignedRelay3");  
    String qPIR_AssignedRelay4 = serverAP.arg("PIR_AssignedRelay4");  
    String qPIR_AssignedRelay5 = serverAP.arg("PIR_AssignedRelay5");  
    String qPIR_AssignedRelay6 = serverAP.arg("PIR_AssignedRelay6"); 
    String qPIR_Action1 = serverAP.arg("PIR_Action1");
    String qPIR_Action2 = serverAP.arg("PIR_Action2");
    String qPIR_Action3 = serverAP.arg("PIR_Action3");
    String qPIR_Action4 = serverAP.arg("PIR_Action4");
    String qPIR_Action5 = serverAP.arg("PIR_Action5");
    String qPIR_Action6 = serverAP.arg("PIR_Action6");               
    boolean Status = false;
                   // validate and convert web entry to a decimal number for storage

    if(qPIR_Action1 == "ON" && PIR_Action[0] != PIR_SwitchOn)
    {
      PIR_Action[0] = PIR_SwitchOn;
      EEPROM.write(EEPROM_PIR_Action,PIR_SwitchOn);
      Status = true;       
    }
    else
    if(qPIR_Action1 == "OFF" && PIR_Action[0] != PIR_SwitchOff)
    {
      PIR_Action[0] = PIR_SwitchOff;
      EEPROM.write(EEPROM_PIR_Action,PIR_SwitchOff);
      Status = true;        
    }
    else
    if(qPIR_Action1 == "NOTHING" && PIR_Action[0] != PIR_DoNothing)
    {
      PIR_Action[0] = PIR_DoNothing; 
      EEPROM.write(EEPROM_PIR_Action,PIR_DoNothing);
      Status = true;
    }

    if(qPIR_Action2 == "ON" && PIR_Action[1] != PIR_SwitchOn)
    {
      PIR_Action[1] = PIR_SwitchOn; 
      EEPROM.write(EEPROM_PIR_Action+1,PIR_SwitchOn);
      Status = true;
    }
    else
    if(qPIR_Action2 == "OFF" && PIR_Action[1] != PIR_SwitchOff)
    {
      PIR_Action[1] = PIR_SwitchOff;
      EEPROM.write(EEPROM_PIR_Action+1,PIR_SwitchOff);
      Status = true;          
    }
    else
    if(qPIR_Action2 == "NOTHING" && PIR_Action[1] != PIR_DoNothing)
    {
      PIR_Action[1] = PIR_DoNothing; 
      EEPROM.write(EEPROM_PIR_Action+1,PIR_DoNothing);
      Status = true;        
    }    
    
    if(qPIR_Action3 == "ON" && PIR_Action[2] != PIR_SwitchOn)
    {
      PIR_Action[2] = PIR_SwitchOn; 
      EEPROM.write(EEPROM_PIR_Action+2,PIR_SwitchOn);
      Status = true;
    }
    else
    if(qPIR_Action3 == "OFF" && PIR_Action[2] != PIR_SwitchOff)
    {
      PIR_Action[2] = PIR_SwitchOff;
      EEPROM.write(EEPROM_PIR_Action+2,PIR_SwitchOff);
      Status = true;          
    }
    else
    if(qPIR_Action3 == "NOTHING" && PIR_Action[2] != PIR_DoNothing)
    {
      PIR_Action[2] = PIR_DoNothing; 
      EEPROM.write(EEPROM_PIR_Action+2,PIR_DoNothing);
      Status = true;        
    }    

    if(qPIR_Action4 == "ON" && PIR_Action[3] != PIR_SwitchOn)
    {
      PIR_Action[3] = PIR_SwitchOn; 
      EEPROM.write(EEPROM_PIR_Action+3,PIR_SwitchOn);
      Status = true;
    }
    else
    if(qPIR_Action4 == "OFF" && PIR_Action[3] != PIR_SwitchOff)
    {
      PIR_Action[3] = PIR_SwitchOff;
      EEPROM.write(EEPROM_PIR_Action+3,PIR_SwitchOff);
      Status = true;          
    }
    else
    if(qPIR_Action4 == "NOTHING" && PIR_Action[3] != PIR_DoNothing)
    {
      PIR_Action[3] = PIR_DoNothing; 
      EEPROM.write(EEPROM_PIR_Action+3,PIR_DoNothing);
      Status = true;        
    }    

    if(qPIR_Action5 == "ON" && PIR_Action[4] != PIR_SwitchOn)
    {
      PIR_Action[4] = PIR_SwitchOn; 
      EEPROM.write(EEPROM_PIR_Action+4,PIR_SwitchOn);
      Status = true;
    }
    else
    if(qPIR_Action5 == "OFF" && PIR_Action[4] != PIR_SwitchOff)
    {
      PIR_Action[4] = PIR_SwitchOff;
      EEPROM.write(EEPROM_PIR_Action+4,PIR_SwitchOff);
      Status = true;          
    }
    else
    if(qPIR_Action5 == "NOTHING" && PIR_Action[4] != PIR_DoNothing)
    {
      PIR_Action[4] = PIR_DoNothing; 
      EEPROM.write(EEPROM_PIR_Action+4,PIR_DoNothing);
      Status = true;        
    }  

    if(qPIR_Action6 == "ON" && PIR_Action[5] != PIR_SwitchOn)
    {
      PIR_Action[5] = PIR_SwitchOn; 
      EEPROM.write(EEPROM_PIR_Action+5,PIR_SwitchOn);
      Status = true;
    }
    else
    if(qPIR_Action6 == "OFF" && PIR_Action[5] != PIR_SwitchOff)
    {
      PIR_Action[5] = PIR_SwitchOff;
      EEPROM.write(EEPROM_PIR_Action+5,PIR_SwitchOff);
      Status = true;          
    }
    else
    if(qPIR_Action6 == "NOTHING" && PIR_Action[5] != PIR_DoNothing)
    {
      PIR_Action[5] = PIR_DoNothing; 
      EEPROM.write(EEPROM_PIR_Action+5,PIR_DoNothing);
      Status = true;        
    } 
 
    if (qPIR_AssignedRelay1.length() > 0 && qPIR_AssignedRelay1 != String(PIR_AssignedRelay[0]+1)) // value has been changed
    {
         PIR_AssignedRelay[0] = qPIR_AssignedRelay1.toInt()-1;
         EEPROM.write(EEPROM_PIR_AssignedRelay,PIR_AssignedRelay[0]);
         Status = true;
    } // end of if (qPIR_AssignedRelay1 != String(PIR_AssignedRelay[0]))

    if (qPIR_AssignedRelay2.length() > 0 && qPIR_AssignedRelay2 != String(PIR_AssignedRelay[1]+1)) // value has been changed
    {
         PIR_AssignedRelay[1] = qPIR_AssignedRelay2.toInt()-1; 
         EEPROM.write(EEPROM_PIR_AssignedRelay+1,PIR_AssignedRelay[1]);
         Status = true;
    } // end of if (qPIR_AssignedRelay2 != String(PIR_AssignedRelay[1]))

    if (qPIR_AssignedRelay3.length() > 0 && qPIR_AssignedRelay3 != String(PIR_AssignedRelay[2]+1)) // value has been changed
    {
         PIR_AssignedRelay[2] = qPIR_AssignedRelay3.toInt()-1; 
         EEPROM.write(EEPROM_PIR_AssignedRelay+2,PIR_AssignedRelay[2]);
         Status = true;
    } // end of if (qPIR_AssignedRelay3 != String(PIR_AssignedRelay[2]))

    if (qPIR_AssignedRelay4.length() > 0 && qPIR_AssignedRelay4 != String(PIR_AssignedRelay[3]+1)) // value has been changed
    {
         PIR_AssignedRelay[3] = qPIR_AssignedRelay4.toInt()-1; 
         EEPROM.write(EEPROM_PIR_AssignedRelay+2,PIR_AssignedRelay[3]);
         Status = true;
    } // end of if (qPIR_AssignedRelay4.length() > 0 && qPIR_AssignedRelay4 != String(PIR_AssignedRelay[3]+1)) 

    if (qPIR_AssignedRelay5.length() > 0 && qPIR_AssignedRelay5 != String(PIR_AssignedRelay[4]+1)) // value has been changed
    {
         PIR_AssignedRelay[4] = qPIR_AssignedRelay5.toInt()-1; 
         EEPROM.write(EEPROM_PIR_AssignedRelay+2,PIR_AssignedRelay[4]);
         Status = true;
    } // end of if (qPIR_AssignedRelay5.length() > 0 && qPIR_AssignedRelay5 != String(PIR_AssignedRelay[4]+1)) 

    if (qPIR_AssignedRelay6.length() > 0 && qPIR_AssignedRelay6 != String(PIR_AssignedRelay[5]+1)) // value has been changed
    {
         PIR_AssignedRelay[5] = qPIR_AssignedRelay6.toInt()-1; 
         EEPROM.write(EEPROM_PIR_AssignedRelay+2,PIR_AssignedRelay[5]);
         Status = true;
    } // end of if (qPIR_AssignedRelay6.length() > 0 && qPIR_AssignedRelay6 != String(PIR_AssignedRelay[5]+1))   
      // ----------------------------------------------------
    if (qPIR_Timer1.length() > 0 && qPIR_Timer1 != String(PIR_TimerInterval[0]))  // New value added
    {
         PIR_TimerInterval[0] = qPIR_Timer1.toInt();
         EEPROM.write(EEPROM_PIR_TimerInterval, PIR_TimerInterval[0]);     // if valid entry made          
         Status = true;
    } // end of if (qPIR_Timer1 != PIR_TimerInterval[0]) 
            
    if (qPIR_Timer2.length() > 0 && qPIR_Timer2 != String(PIR_TimerInterval[1]))  // New value added
    {
         PIR_TimerInterval[1] = qPIR_Timer2.toInt();
         EEPROM.write(EEPROM_PIR_TimerInterval+1, PIR_TimerInterval[1]);     // if valid entry made          
         Status = true;
    } // end of if (qPIR_Timer2 != PIR_TimerInterval[1])
            
    if (qPIR_Timer3.length() > 0 && qPIR_Timer3 != String(PIR_TimerInterval[2]))  // New value added
    {
         PIR_TimerInterval[2] = qPIR_Timer3.toInt();
         EEPROM.write(EEPROM_PIR_TimerInterval+2, PIR_TimerInterval[2]);     // if valid entry made          
         Status = true;
    } // end of if (qPIR_Timer3 != PIR_TimerInterval[2]) 

    if (qPIR_Timer4.length() > 0 && qPIR_Timer4 != String(PIR_TimerInterval[3]))  // New value added
    {
         PIR_TimerInterval[3] = qPIR_Timer4.toInt();
         EEPROM.write(EEPROM_PIR_TimerInterval+3, PIR_TimerInterval[3]);     // if valid entry made          
         Status = true;
    } // end of if (qPIR_Timer4.length() > 0 && qPIR_Timer4 != String(PIR_TimerInterval[3]))  

    if (qPIR_Timer5.length() > 0 && qPIR_Timer5 != String(PIR_TimerInterval[4]))  // New value added
    {
         PIR_TimerInterval[4] = qPIR_Timer5.toInt();
         EEPROM.write(EEPROM_PIR_TimerInterval+4, PIR_TimerInterval[4]);     // if valid entry made          
         Status = true;
    } // end of if (qPIR_Timer5.length() > 0 && qPIR_Timer5 != String(PIR_TimerInterval[4]))  

    if (qPIR_Timer6.length() > 0 && qPIR_Timer6 != String(PIR_TimerInterval[5]))  // New value added
    {
         PIR_TimerInterval[5] = qPIR_Timer6.toInt();
         EEPROM.write(EEPROM_PIR_TimerInterval+5, PIR_TimerInterval[5]);     // if valid entry made          
         Status = true;
    } // end of if (qPIR_Timer6.length() > 0 && qPIR_Timer6 != String(PIR_TimerInterval[5]))    
    if(Status == true) EEPROM.commit();
    // --------------------------------------------------------------------------        
    content = "<!DOCTYPE HTML> \r\n<html>";
    content += "<head> <style>";  
    content += "fieldset {background-color: #lightcyan;font-family: Helv, sans-serif; width 75%;}";
    content += "legend {background-color: gray; color: white; padding: 5px 5px; font-size: 14px}";
    content += "</style></head><body>";     
    content += "<h3>" + HostName;
    content += " Remote (MQTT) PIR Setup Page</h3>";
    content += "<p><form action='PIR_Setup'></p>";   
            
    content += "<fieldset>"; 
    content += "<legend><b>Output running ON timers when activated by a remote PIR (mins)</b></legend>";
    content += "<label>PIR 1 (1-45 mins): </label>"; 
    content += "<input type = 'number' name='PIR_Timer1' + value = ";
    content += String(PIR_TimerInterval[0]) + " length=3 size = '3' min='1' max = '45'></p>";  

    content += "<p><label>PIR 2 (1-45 mins): </label>"; 
    content += "<input type = 'number' name='PIR_Timer2' + value = ";
    content += String(PIR_TimerInterval[1]) + " length=3 size = '3' min='1' max = '45'></p>";  

    content += "<p><label>PIR 3 (1-45 mins): </label>"; 
    content += "<input type = 'number' name='PIR_Timer3' + value = ";
    content += String(PIR_TimerInterval[2]) + " length=3 size = '3' min='1' max = '45'></p>"; 

    content += "<label>PIR 4 (1-45 mins): </label>"; 
    content += "<input type = 'number' name='PIR_Timer4' + value = ";
    content += String(PIR_TimerInterval[3]) + " length=3 size = '3' min='1' max = '45'></p>";  

    content += "<p><label>PIR 5 (1-45 mins): </label>"; 
    content += "<input type = 'number' name='PIR_Timer5' + value = ";
    content += String(PIR_TimerInterval[4]) + " length=3 size = '3' min='1' max = '45'></p>";  

    content += "<p><label>PIR 6 (1-45 mins): </label>"; 
    content += "<input type = 'number' name='PIR_Timer6' + value = ";
    content += String(PIR_TimerInterval[5]) + " length=3 size = '3' min='1' max = '45'></p>";   
    content += "</fieldset>"; 
    content += "</p>";
    
    content += "<fieldset>"; 
    content += "<legend><b>Remote PIR to Relay assignment links (E.g. PIR1 => Output Relay 3</b></legend>";
    content += "<label>PIR 1 is linked to Relay</label>"; 
    content += "<input type = 'number' name='PIR_AssignedRelay1' + value = ";
    content += String(PIR_AssignedRelay[0]+1) + " length=3 size = '3' min='1' max = '3'>";
    content += "&nbspto switch&nbsp";
    content += "<input type = 'radio' name = 'PIR_Action1' value = 'OFF' "; 
    if(PIR_Action[0] == PIR_SwitchOff) content += "checked";
    content += ">OFF";
    content += "<input type = 'radio' name = 'PIR_Action1' value = 'ON' "; 
    if(PIR_Action[0] == PIR_SwitchOn) content += "checked";
    content += ">ON";
    content += "<input type = 'radio' name = 'PIR_Action1' value = 'NOTHING' "; 
    if(PIR_Action[0] == PIR_DoNothing) content += "checked";
    content += ">Do nothing</p>";
    
     
    content += "<label>PIR 2 is linked to Relay</label>"; 
    content += "<input type = 'number' name='PIR_AssignedRelay2' + value = ";
    content += String(PIR_AssignedRelay[1]+1) + " length=3 size = '3' min='1' max = '3'>"; 
    content += "&nbspto switch&nbsp";
    content += "<input type = 'radio' name = 'PIR_Action2' value = 'OFF' "; 
    if(PIR_Action[1] == PIR_SwitchOff) content += "checked";
    content += ">OFF";
    content += "<input type = 'radio' name = 'PIR_Action2' value = 'ON' "; 
    if(PIR_Action[1] == PIR_SwitchOn) content += "checked";
    content += ">ON";
    content += "<input type = 'radio' name = 'PIR_Action2' value = 'NOTHING' "; 
    if(PIR_Action[1] == PIR_DoNothing) content += "checked";
    content += ">Do nothing</p>";
         
    content += "<label>PIR 3 is linked to Relay</label>"; 
    content += "<input type = 'number' name='PIR_AssignedRelay3' + value = ";
    content += String(PIR_AssignedRelay[2]+1) + " length=3 size = '3' min='1' max = '3'>"; 
    content += "&nbspto switch&nbsp";
    content += "<input type = 'radio' name = 'PIR_Action3' value = 'OFF' "; 
    if(PIR_Action[2] == PIR_SwitchOff) content += "checked";
    content += ">OFF";
    content += "<input type = 'radio' name = 'PIR_Action3' value = 'ON' "; 
    if(PIR_Action[2] == PIR_SwitchOn) content += "checked";
    content += ">ON";
    content += "<input type = 'radio' name = 'PIR_Action3' value = 'NOTHING' "; 
    if(PIR_Action[2] == PIR_DoNothing) content += "checked";
    content += ">Do nothing</p>";
            
    content += "<label>PIR 4 is linked to Relay</label>"; 
    content += "<input type = 'number' name='PIR_AssignedRelay4' + value = ";
    content += String(PIR_AssignedRelay[3]+1) + " length=3 size = '3' min='1' max = '3'>"; 
    content += "&nbspto switch&nbsp";
    content += "<input type = 'radio' name = 'PIR_Action4' value = 'OFF' "; 
    if(PIR_Action[3] == PIR_SwitchOff) content += "checked";
    content += ">OFF";
    content += "<input type = 'radio' name = 'PIR_Action4' value = 'ON' "; 
    if(PIR_Action[3] == PIR_SwitchOn) content += "checked";
    content += ">ON";
    content += "<input type = 'radio' name = 'PIR_Action4' value = 'NOTHING' "; 
    if(PIR_Action[3] == PIR_DoNothing) content += "checked";
    content += ">Do nothing</p>";
        
    content += "<label>PIR 5 is linked to Relay</label>"; 
    content += "<input type = 'number' name='PIR_AssignedRelay5' + value = ";
    content += String(PIR_AssignedRelay[4]+1) + " length=3 size = '3' min='1' max = '3'>"; 
    content += "&nbspto switch&nbsp";
    content += "<input type = 'radio' name = 'PIR_Action5' value = 'OFF' "; 
    if(PIR_Action[4] == PIR_SwitchOff) content += "checked";
    content += ">OFF";
    content += "<input type = 'radio' name = 'PIR_Action5' value = 'ON' "; 
    if(PIR_Action[4] == PIR_SwitchOn) content += "checked";
    content += ">ON";
    content += "<input type = 'radio' name = 'PIR_Action5' value = 'NOTHING' "; 
    if(PIR_Action[4] == PIR_DoNothing) content += "checked";
    content += ">Do nothing</p>";    
        
    content += "<label>PIR 6 is linked to Relay</label>"; 
    content += "<input type = 'number' name='PIR_AssignedRelay6' + value = ";
    content += String(PIR_AssignedRelay[5]+1) + " length=3 size = '3' min='1' max = '3'>";             
    content += "&nbspto switch&nbsp";
    content += "<input type = 'radio' name = 'PIR_Action6' value = 'OFF' "; 
    if(PIR_Action[5] == PIR_SwitchOff) content += "checked";
    content += ">OFF";
    content += "<input type = 'radio' name = 'PIR_Action6' value = 'ON' "; 
    if(PIR_Action[5] == PIR_SwitchOn) content += "checked";
    content += ">ON";
    content += "<input type = 'radio' name = 'PIR_Action6' value = 'NOTHING' "; 
    if(PIR_Action[5] == PIR_DoNothing) content += "checked";
    content += ">Do nothing";      
    content += "</fieldset>"; 
    content += "</p>";    
      
    content += "<fieldset>"; 
    content += "<legend><b>Current value of Output running ON timers (mins)</b></legend>";
    content += RelayDescriptors[0] + " = " + String(RelayOnTimer[0]) + "</p>";    
    if (NoOfRelays >= 2) content += "<p>" + RelayDescriptors[1] + " = " + String(RelayOnTimer[1]) + "</p>";     
    if (NoOfRelays == 3) content += "<p>" + RelayDescriptors[2] + " = " + String(RelayOnTimer[2]) + "</p>";          
    content += "</fieldset>";     
    
    if(AccessPointRunning)  
          content += "<p><input type='submit' value = 'Upload new settings to the device' style = 'color:blue;background:yellow;font size 25 px'></p>";
    
    content += "<br><a href='http://";           
    if(AccessPointRunning) content += "192.168.8.200'>"; else content += IPaddressToString(WiFi.localIP()) + "'>";
    content +=  " Return to the Main Menu  </a> </form>";    
     
    if (AccessPointRunning) serverAP.send(200, "text/html", content);  // send message to AP Webpage     
    else LocalServer.send(200, "text/html", content);  // send message to AP Webpage
  
}    // end of void PIR_Setup()
